{
        Program Name : Goto_Address
        Package Name : Subroutine Library - Layer 4
        Purpose      : Goto Address dialog
        Institution  : Conroy & Conroy Co.
        Date Written : 4-Aug-2001
        Written By   : Alan Conroy
        Version      : 1.0

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        Released to the public domain.
        
        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This unit defines the dialog for querying the user for an address.

        *************************************************************
        *                                                           *
        *        C O N T R I B U T O R S                            *
        *                                                           *
        *************************************************************

        AC (EAC)    Alan Conroy    http://www.conroyhome.net/alan

}

unit Goto_Address ;

interface

uses // Borland...
     Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, Buttons, ExtCtrls,

     // Subroutine Library - Layer 4
     TDialogs ; // TDialog

type
  TGoto_Address_Form = class(TDialog)
    Button_Panel: TPanel;
    Label1: TLabel;
    OK_Button: TBitBtn;
    BitBtn2: TBitBtn;
    ComboBox1: TComboBox;
    Help_Button: TBitBtn;
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure OK_ButtonClick(Sender: TObject);
    procedure Help_ButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);

  private // Internal...
      _Base : integer ;

      procedure Set_Base( Value : integer ) ;

  public // API...
      property Base : integer
          read _Base
          write Set_Base ;
  end ;

var Goto_Address_Form : TGoto_Address_Form ;

implementation

uses // C&C Subroutine Library - Layer 0...
     L10N, // Text_*

     // C&C Subroutine Library - Layer 1...
     CVT ; // Valid_Base

{$R *.DFM}

// TGoto_Address_Form methods...

procedure TGoto_Address_Form.ComboBox1KeyPress( Sender : TObject ;
    var Key : Char ) ;

begin
    if( Key <> #8 ) then
    begin
        Key := upcase( Key ) ;
        if( not Valid_Base( Key, Base ) ) then
        begin
            Key := #0 ;
            MessageBeep( 0 ) ;
        end ;
    end ;
end ;


procedure TGoto_Address_Form.OK_ButtonClick( Sender : TObject ) ;

begin
    if( ComboBox1.Items.Indexof( ComboBox1.Text ) = -1 ) then
    begin
        ComboBox1.Items.Add( ComboBox1.Text ) ;
    end ;
end ;


// Internal...

procedure TGoto_Address_Form.Set_Base( Value : integer ) ;

begin
    if( Base <> Value ) then
    begin
        _Base := Value ;
        ComboBox1.Items.Clear ;
    end ;
end ;


procedure TGoto_Address_Form.Help_ButtonClick( Sender : TObject ) ;

begin
    Application.HelpContext( HelpContext ) ;
end ;



procedure TGoto_Address_Form.FormShow(Sender: TObject);

begin
    Caption := Text_Caption_Goto_Address ;
    Label1.Caption := Text_Enter_New_Address ;
    OK_Button.Caption := Text_Button_Caption_OK ;
    BitBtn2.Caption := Text_Button_Caption_Abort ;
    Help_Button.Caption := Text_Button_Caption_Help ;
end ;


end.
