{$IFNDEF FPC}
  {$E+}
  {$N+}
{$ENDIF}
{
        Program Name : OS_Android
        Package Name : Subroutine Library - Layer 1
        Purpose      : Android Operating system interface
        Institution  : Conroy & Conroy Co.
        Date Written : 6-Oct-2018
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2018 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit OS_IOS ;

interface

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

{$I EDEFINES.INC}

uses // Borland...
     SysUtils, // inttostr
{$IFDEF FPC}
     LCLType, // ID_Abort
{$ENDIF}
     Classes, // TList

     { Subroutine Library - Layer 0... }
{$IFNDEF MOBILE}
     _DebugIn, // TDebug_Interface
{$ENDIF}
     _Types, { int64 }
     _UE, { PSUnified_Exception }

     { Subroutine Library - Layer 1... }
     _DevMan, { PSDevice_Manager }
     _OS, { TOperating_System }
     _TPM ; { TSText_Presentation_Manager }

type TSIOS_Text_Presentation_Manager = object( TSText_Presentation_Manager )
                                               public { Constructors and destructors... }
                                                   constructor Init ;
                                                   destructor Done ; virtual ;

                                               private
                                                   _Numeric_Text_Presentation_Manager : PSNumeric_Text_Presentation_Manager ;
                                                   _Monetary_Text_Presentation_Manager : PSMonetary_Text_Presentation_Manager ;
                                                   _Date_Text_Presentation_Manager : PSDate_Text_Presentation_Manager ;

                                               public { API... }
                                                   function Numeric_Text_Presentation_Manager : PSNumeric_Text_Presentation_Manager ;
                                                       virtual ;

                                                   function Monetary_Text_Presentation_Manager : PSMonetary_Text_Presentation_Manager ;
                                                       virtual ;

                                                   function Date_Text_Presentation_Manager : PSDate_Text_Presentation_Manager ;
                                                       virtual ;
                                           end ;
     PSWindows_Text_Presentation_Manager = ^TSIOS_Text_Presentation_Manager ;

type TSOS_IOS = object( TSOperating_System )
                             public { Constructors and destructors... }
                                 constructor Init ;
                                 destructor Done ; virtual ;

                             private { Instance data... }
                                 Input_Buffer : Ansistring ;
                                 Internal_Clipboard : Ansistring ;
                                 _Device_Manager : PSDevice_Manager ;
                                 _Text_Presentation_Manager : PSWindows_Text_Presentation_Manager ;

                                 File_Mapping_List : TList ;

                             public { API... }
                                 function Name : Ansistring ; virtual ; { O/S name }
                                 function Version : Ansistring ; virtual ;
                                 { O/S version }

                                 function Application_Path : Ansistring ; virtual ;
                                 procedure Beep( Typ : integer ) ; virtual ;
                                 procedure Cancel_Typeahead( Handle : integer ) ;
                                     virtual ;
                                 function Command_Line : Ansistring ; virtual ;
{$IFNDEF MOBILE}
                                 function Debugger : PSDebug_Interface ;
                                     virtual ;
                                 { Returns a debugger for the operating system }
{$ENDIF}
                                 function Get_Char( Wait : boolean ;
                                     var Valid : boolean ; Handle : integer ) : Ansichar ;
                                     virtual ;
                                 function Get_Symbol( const X : AnsiString ) : Ansistring ;
                                     virtual ;
                                 procedure Get_Date( var Year, Month, Day : word ) ;
                                     virtual ;
                                 procedure Get_Time( var Hour, Minute, Second, Hundreths, NS : word ) ;
                                     virtual ;
                                 function Last_Error : PSUnified_Exception ;
                                     virtual ;
                                 function Error_Text( Code : longint ;
                                     const Language : AnsiString ) : Ansistring ;
                                     virtual ;
                                 function Logical_CPUs : integer ; virtual ;
                                 function Pending_Input( Handle : integer ) : boolean ;
                                     virtual ;
                                 function PID : longint ; virtual ;
                                 procedure Print( T : AnsiString ) ; virtual ;
                                 function Spawn( const Path, Parameters, Default_Dir : Ansistring ;
                                     Flags : integer ) : boolean ;
                                     virtual ;
                                 function Get_Temp_Path : Ansistring ; virtual ;
                                 function System_Path : Ansistring ; virtual ;
                                 function Text_Presentation_Manager : PSText_Presentation_Manager ;
                                     virtual ;
                                 function Swap_File_List : Ansistring ; virtual ;
                                 function Thread_ID : longint ; virtual ;
                                 function Timestamp : int64 ; virtual ;
                                 function Get_Clipboard( Path : AnsiString ) : Ansistring ;
                                     virtual ;
                                 procedure Set_Clipboard( Path, Value : AnsiString ) ;
                                     virtual ;
                                 function Max_File_Size : int64 ; virtual ;
                                 function User_Name : Ansistring ; virtual ;
                                 function Device_Manager : PSDevice_Manager ;
                                     virtual ;
                                 function Load_Library( Nam : AnsiString ) : longint ;
                                     virtual ;

                                 function Get_Symbol_Address( Lib : longint ;
                                     Nam : AnsiString ) : int64 ; virtual ;

                                 function Show_Message( Handle : longint ;
                                     Msg, Title : Ansistring ;
                                     Options : integer ) : integer ; virtual ;

                                 function Get_Country : Ansistring ; virtual ;

                                 { Memory mapping... }
                                 function Max_Memory_Map : int64 ; virtual ;

                                 function Memory_Map_File( _Name : Ansistring ;
                                     Writeable : boolean ;
                                     Start, Size : int64 ;
                                     Flag : boolean ) : integer ; virtual ;

                                 procedure Unmap_File_From_Memory( Handle : integer ) ;
                                     virtual ;

                                 function Memory_Mapped_File_Base( Handle : integer ) : pointer ;
                                     virtual ;

                                 function Memory_Mapped_File_Size( Handle : integer ) : int64 ;
                                     virtual ;

                                 { Memory... }
                                 function Total_Physical_Memory : int64 ;
                                     virtual ;

                                 function Available_Physical_Memory : int64 ;
                                     virtual ;

                                 function Total_Virtual_Memory : int64 ;
                                     virtual ;

                                 function Available_Virtual_Memory : int64 ;
                                     virtual ;

                                 function Application_Data_Path( Default_Root, Path : Ansistring ;
                                     Flags : integer ) : Ansistring ;
                                     virtual ;

                                 function Create_Path( Path : AnsiString ) : integer ;
                                     virtual ;

                                 function Shared_Library_Extension : Ansistring ;
                                     virtual ;

                                 function Path_Separator : Ansistring ;
                                     virtual ;

                                 function Hardware_Name : Ansistring ;
                                     virtual ;
                         end ; { TSOS_Windows }
     PSOS_IOS = ^TSOS_IOS ;

implementation

uses { Borland... }
     FMX.Platform,
     IOSapi.JNI.JavaTypes,
     FMX.Helpers.IOS,
     IOSapi.JNI.GraphicsContentViewText,
     IOSapi.Helpers,
     IOSapi.JNI.Os, // TJBuild

     { Subroutine Library - Layer 0... }
     _ASCII, { NUL }

     { Subroutine Library - Layer 1... }
     CommonUt, { Edit }
     Compatib, { SetLength }
     UE,

     { Subroutine Library - Layer 3... }
     Filestd ;

{ TOS_Device_Manager... }

type TOS_Device_Manager = object( TSDevice_Manager )
                              public { API... }
                                  function Disk_Clusters( Drive : AnsiString ) : int64 ;
                                      virtual ;
                                  { Returns number of clusters on specified disk
                                    drive.  Returns -1 if an error or unknown. }

                                  function Disk_Sector_Size( Drive : AnsiString ) : longint ;
                                      virtual ;
                                  { Returns size of disk sectors, in bytes.
                                    Returns -1 if an error or unknown. }

                                  function Fixed_Device( Device : AnsiString ) : boolean ;
                                      virtual ;
                                  { Returns true if the passed device is fixed
                                    (non-removable) }

                                  function Max_Filename_Length( Device : AnsiString ) : longint ;
                                      virtual ;

                                  function Media_ID( Device : AnsiString ) : longint ;
                                      virtual ;
                                  { Return type of media in/on device.  -1 if
                                    error or unknown. }

                                  function Valid_Device( Device : AnsiString ) : boolean ;
                                      virtual ;
                                  { Returns true if the passed device is valid. }

                                  function Device_Name( Clas, Index : integer ) : Ansistring ;
                                      virtual ;

                                  function Current_Path( Device : AnsiString ) : Ansistring ;
                                      virtual ;

                                  function Media_Present( Device : AnsiString ) : boolean ;
                                      virtual ;
                          end ; // TOS_Device_Manager
     POS_Device_Manager = ^TOS_Device_Manager ;


{ API... }

function TOS_Device_Manager.Disk_Clusters( Drive : AnsiString ) : int64 ;

begin
    Disk_Clusters := -1 ;
end ;


function TOS_Device_Manager.Disk_Sector_Size( Drive : AnsiString ) : longint ;

begin
    Disk_Sector_Size := -1 ;
end ;


function TOS_Device_Manager.Fixed_Device( Device : AnsiString ) : boolean ;

begin
    Fixed_Device := False ;
    if(
        ( length( Device ) = 0 )
        or
        ( ( length( Device ) > 1 ) and ( Device[ 2 ] <> ':' ) )
      ) then
    begin
        exit ;
    end ;
end ;


function TOS_Device_Manager.Max_Filename_Length( Device : AnsiString ) : longint ;

begin
    Result := -1 ;
    if(
        ( length( Device ) = 0 )
        or
        ( ( length( Device ) > 1 ) and ( Device[ 2 ] <> ':' ) )
      ) then
    begin
        exit ;
    end ;
    Result := 255 ;
end ;


function TOS_Device_Manager.Media_ID( Device : AnsiString ) : longint ;

var Typ : integer ;

begin
    Media_ID := -1 ;
    if(
        ( length( Device ) = 0 )
        or
        ( ( length( Device ) > 1 ) and ( Device[ 2 ] <> ':' ) )
      ) then
    begin
        exit ;
    end ;
end ;


function TOS_Device_Manager.Valid_Device( Device : AnsiString ) : boolean ;

begin
    Valid_Device := ( Media_ID( Device ) <> -1 ) ;
end ;


function TOS_Device_Manager.Device_Name( Clas, Index : integer ) : Ansistring ;

var Loop : integer ;

begin
    Device_Name := '' ;
    if( ( Clas = DC_Unknown ) or ( Clas = DC_Disk ) ) then
    begin
        for Loop := 1 to 26 do
        begin
            if( Valid_Device( chr( Loop + 64 ) + ':' ) ) then
            begin
                dec( Index ) ;
                if( Index < 0 ) then
                begin
                    Device_Name := chr( Loop + 64 ) + ':' ;
                    exit ;
                end ;
            end ;
        end ;
    end ;
end ;


function TOS_Device_Manager.Current_Path( Device : AnsiString ) : Ansistring ;

begin
    Current_Path := '' ;
    if( Device = '' ) then
    begin
        setlength( Result, 127 ) ;
        GetCurDir( PAnsiChar( Result ), 0 ) ;
        setlength( Result, strlen( PAnsiChar( Result ) ) ) ;
    end else
    if( Valid_Device( Device ) ) then
    begin
        setlength( Result, 127 ) ;
        GetCurDir( PAnsiChar( Result ), ord( Device[ 1 ] ) - 64 ) ;
        setlength( Result, strlen( PAnsiChar( Result ) ) ) ;
    end ;
end ;


function TOS_Device_Manager.Media_Present( Device : AnsiString ) : boolean ;

var D : string ;
    Handle : THandle ;
    T : integer ;

begin
    // Setup...
    if( not Valid_Device( Device ) ) then
    begin
        Media_Present := False ;
        exit ; // Invalid device
    end ;
    Result := True ;
end ; // TOS_Device_Manager.Media_Present


function CPUID_Supported : boolean ;

begin
    Result := False ;
end ;


function Is_HWMT_Supported : boolean ;

begin
    if( not CPUID_Supported ) then
    begin
        Result := False ;
        exit ;
    end ;
    Result := False ;
end ;


Function Number_Of_Logical_Processors : integer ;

var _EBX : longint ;

begin
    if( not Is_HWMT_Supported ) then
    begin
        Result := 1 ;
        exit ;
    end ;
    Result := -1 ;
end ;


function Get_Max_Cores : integer ;

var _EAX : longint ;

label Single_Core, Multi_Core ;

begin
    if( not Is_HWMT_Supported ) then
    begin
        Result := 1 ;
        exit ;
    end ;
    Result := 1 ;
end ;



{ TOS_IOS methods... }

{ Constructors and destructors... }

constructor TSOS_IOS.Init ;

begin
    inherited Init ;

    Initialize( Input_Buffer ) ;
    Initialize( Internal_Clipboard ) ;
    _Device_Manager := nil ;
end ;


destructor TSOS_IOS.Done ;

var Loop : integer ;

begin
    _Device_Manager.Free ;
    _Device_Manager := nil ;
    if( _Text_Presentation_Manager <> nil ) then
    begin
        dispose( _Text_Presentation_Manager, Done ) ;
        _Text_Presentation_Manager := nil ;
    end ;
    finalize( Input_Buffer ) ;
    finalize( Internal_Clipboard ) ;

    if( File_Mapping_List <> nil ) then
    begin
        for Loop := File_Mapping_List.Count - 1 downto 0 do
        begin
            Unmap_File_From_Memory( Loop + 1 ) ;
        end ;
        File_Mapping_List.Free ;
        File_Mapping_List := nil ;
    end ;

    inherited Done ;
end ;


{ API... }

function TSOS_IOS.Name : Ansistring ; { O/S name }

var OSVersion : TOSVersion ;

begin
    Name := OSVersion.Name ;
end ; // TOS_IOS.Name


(*
  Get program version...
var PackageManager : JPackageManager ;
    PackageInfo : JPackageInfo ;

begin
    PackageManager := SharedActivity.getPackageManager ;
    PackageInfo := PackageManager.getPackageInfo( SharedActivityContext.getPackageName(), TJPackageManager.JavaClass.GET_ACTIVITIES ) ;
    Result := JStringToString( PackageInfo.versionName ) ;
*)


function TSOS_IOS.Version : Ansistring ; { O/S version }

var OSVersion : TOSVersion ;
    V : double ;

begin
    V := OSVersion.Minor ;
    while( V >= 1 ) do
    begin
        V := V / 10 ;
    end ;
    V := V + OSVersion.Major ;
    Result := floattostr( V ) ;
end ;


function TSOS_IOS.Application_Path : Ansistring ;

var Dummy : integer ;
    S : string ;

begin
    S := Paramstr( 0 ) ;
    Dummy := length( S ) ;
    while( S[ Dummy ] <> '/' ) do
    begin
        dec( Dummy ) ;
    end ;
    S := copy( S, 1, Dummy ) ;
    if( length( S ) = 0 ) then
    begin
        S := GetCurrentDir ;
    end ;
    Application_Path := S ;
end ;


procedure TSOS_IOS.Cancel_Typeahead( Handle : integer ) ;

begin
    Input_Buffer := '' ;

    inherited Cancel_Typeahead( Handle ) ;
end ;


function Parse_Parameter( Separator : Ansistring ; var Command : AnsiString ) : Ansistring ;
{ Return next parameter - have a local copy of this routine to ensure that this
  unit is initialized before any others that might reference it (Parse.pas
  includes too many other units). }

var Dummy : Integer ;
    Quote : AnsiChar ;

begin
    Quote := ' ' ; { No quote yet }
    if Length( Separator ) = 0 then Separator := ' ' ; { Default to space }
    for Dummy := 1 to Length( Command ) do
    begin
        if( Quote <> ' ' ) { if within a quote }
            then
                if( Command[ Dummy ] = Quote ) then Quote := ' ' else
            else { Not within a quote }
                if( ( Command[ Dummy ] = '"' ) or ( Command[ Dummy ] = Chr( 39 ) ) )
                    then Quote := Command[ Dummy ] ; { Check for quotes }
        if( Command[ Dummy ] = Separator[ 1 ] ) then if( Quote = ' ' ) then
        begin
            Parse_Parameter := Copy( Command, 1, Dummy - 1 ) ; { Return parameter }
            Command := Copy( Command, Dummy + 1, length( Command ) ) ; { Strip from command line }
            Exit ; { Done }
        end ;
    end ;
    { At this point, the entire command line is a parameter }
    Parse_Parameter := Command ; { Return next parameter }
    Command := '' ; { Strip from command line }
end ; { Parse_Parameter }


function TSOS_IOS.Command_Line : Ansistring ;

var I : integer ;

begin
    Result := '' ;
    for I := 0 to ParamCount - 1 do
    begin
        Result := Result + Paramstr( I ) ;
        if( I < ParamCount - 1 ) then
        begin
            Result := Result + ' ' ;
        end ;
    end ;
    Parse_Parameter( ' ', Result ) ; { Trim program name }
end ;


{$IFNDEF MOBILE}
function TSOS_IOS.Debugger : PSDebug_Interface ;

begin
  {$IFDEF Internals}
    Debugger := Static_Debug_Wrapper( TMS_Windows_Debugger.Create ) ;
  {$ELSE}
    Debugger := nil ;
  {$ENDIF}
end ;
{$ENDIF}


function TSOS_IOS.Get_Char( Wait : boolean ; var Valid : boolean ;
    Handle : integer ) : Ansichar ;

begin
    Get_Char := NUL ;
end ; // TOS_Windows.Get_Char


procedure TSOS_IOS.Beep( Typ : integer ) ;

begin
    //MessageBeep( 0 ) ;
end ;


function TSOS_IOS.Get_Symbol( const X : AnsiString ) : Ansistring ;

begin
    Get_Symbol := '' ; { Not defined }
end ;


procedure TSOS_IOS.Get_Date( var Year, Month, Day : word ) ;

begin
    DecodeDate( Date, Year, Month, Day ) ;
end ;


var Last_S : word ;
    Last_H : word ;
    Last_NS : word ;

procedure TSOS_IOS.Get_Time( var Hour, Minute, Second, Hundreths, NS : word ) ;

var I : int64 ;

begin
    DecodeTime( Time, Hour, Minute, Second, Hundreths ) ;
    NS := 0 ;
    if( ( Last_S = Second ) and ( Last_H = Hundreths ) and ( NS < Last_NS ) ) then
    begin
        // Make sure we don't go backwards in time (in ns)
        NS := Last_NS + 1 ;
        if( NS >= 10000 ) then
        begin
            NS := Last_NS ;
        end ;
    end ;
    Last_S := Second ;
    Last_H := Hundreths ;
    Last_NS := NS ;
end ;


function TSOS_IOS.Logical_CPUs : integer ;

begin
    Logical_CPUs := Number_Of_Logical_Processors ;
end ;


function TSOS_IOS.Pending_Input( Handle : integer ) : boolean ;


begin
    Pending_Input := False ;
end ;


function TSOS_IOS.PID : longint ;

begin
    PID := 0 ;
end ;


procedure TSOS_IOS.Print( T : AnsiString ) ;

begin
    //TODO
end ;


function TSOS_IOS.Last_Error : PSUnified_Exception ;

begin
    Result := nil ;
end ;


function TSOS_IOS.Error_Text( Code : longint ;
    const Language : AnsiString ) : Ansistring ;

begin
    Error_Text := '' ;
end ;


function TSOS_IOS.Get_Temp_Path : Ansistring ;

begin
    Get_Temp_Path := '/tmp' ;
end ;


function TSOS_IOS.System_Path : Ansistring ;

begin
    Result := '' ; // TODO
end ;


function TSOS_IOS.Text_Presentation_Manager : PSText_Presentation_Manager ;

begin
    if( _Text_Presentation_Manager = nil ) then
    begin
        _Text_Presentation_Manager := new( PSWindows_Text_Presentation_Manager, Init ) ;
    end ;
    Text_Presentation_Manager := _Text_Presentation_Manager ;
end ;


function TSOS_IOS.Swap_File_List : Ansistring ;

begin
    Swap_File_List := '' ;
end ;


function TSOS_IOS.Spawn( const Path, Parameters, Default_Dir : Ansistring ;
    Flags : integer ) : boolean ;

begin
    Result := False ;
end ; // Spawn


function TSOS_IOS.Thread_ID : longint ;

begin
    Thread_ID := 0 ;
end ;


function TSOS_IOS.Timestamp : int64 ;

begin
    Timestamp := 0 ;
end ;


function TSOS_IOS.Get_Clipboard( Path : AnsiString ) : Ansistring ;

var Clipboard : IFMXClipboardService ;

begin
    if( Path = '' ) then
    begin
        Get_Clipboard := Internal_Clipboard ;
        exit ;
    end ;
    if TPlatformServices.Current.SupportsPlatformService( IFMXClipboardService, Clipboard ) then
    begin
        if( not Clipboard.GetClipboard.IsEmpty ) then
        begin
            if( Path = 'TEXT' ) then
            begin
                if( Clipboard.GetClipboard.IsType<string> ) then
                begin
                    Result := Clipboard.GetClipboard.ToString ;
                    exit ;
                end ;
            end ;
        end ;
    end ;
    Get_Clipboard := '' ;
end ; { TSOS_IOS.Get_Clipboard }


procedure TSOS_IOS.Set_Clipboard( Path, Value : AnsiString ) ;

var Handle : THandle ;
    P : pointer ;
    Clipboard : IFMXClipboardService ;

begin
    if( Path = '' ) then
    begin
        Internal_Clipboard := Value ;
        exit ;
    end ;
    if TPlatformServices.Current.SupportsPlatformService( IFMXClipboardService, Clipboard ) then
    begin
        if( not Clipboard.GetClipboard.IsEmpty ) then
        begin
            if( Path = 'TEXT' ) then
            begin
                Clipboard.SetClipboard( Value ) ;
                exit ;
            end ;
        end ;
    end ;
end ; { TSOS_IOS.Set_Clipboard }


function TSOS_IOS.Max_File_Size : int64 ;

begin
    Max_File_Size := $3FFFFFFF ;
end ;


function TSOS_IOS.User_Name : Ansistring ;

begin
    Result := '' ;
end ;


function TSOS_IOS.Device_Manager : PSDevice_Manager ;

begin
    if( _Device_Manager = nil ) then
    begin
        _Device_Manager := new( POS_Device_Manager, Init ) ;
    end ;
    Device_Manager := _Device_Manager ;
end ;


function TSOS_IOS.Load_Library( Nam : AnsiString ) : longint ;

var S : string ;

begin
    S := Name ;
    Load_Library := LoadLibrary( PChar( Nam ) ) ;
end ;


function TSOS_IOS.Get_Symbol_Address( Lib : longint ; Nam : AnsiString ) : int64 ;

var S : string ;

begin
    S := Nam ;
    Result := integer( GetProcAddress( Lib, PChar( S ) ) ) ;
end ;


function TSOS_IOS.Show_Message( Handle : longint ; Msg, Title : Ansistring ;
    Options : integer ) : integer ;

begin
//TODO
end ; { TSOS_IOS.Show_Message }


function TSOS_IOS.Get_Country : Ansistring ;

begin
     Result := '' ;
end ;


function TSOS_IOS.Max_Memory_Map : int64 ;

begin
    Result := 0 ;
end ;


type TFile_Mapping_Info = class
                              public // API...
                                  Handle : THandle ;
                                  Mapping : THandle ;
                                  Base : pointer ;
                                  Size : int64 ;
                                  Writeable : boolean ;
                          end ;

function TSOS_IOS.Memory_Map_File( _Name : Ansistring ; Writeable : boolean ;
    Start, Size : int64 ; Flag : boolean ) : integer ;

begin
    Result := 0 ;
end ; // TSOS_IOS.Memory_Map_File


procedure TSOS_IOS.Unmap_File_From_Memory( Handle : integer ) ;

begin
end ;


function TSOS_IOS.Memory_Mapped_File_Base( Handle : integer ) : pointer ;

begin
end ;


function TSOS_IOS.Memory_Mapped_File_Size( Handle : integer ) : int64 ;

var Info : TFile_Mapping_Info ;

begin
    Result := 0 ;
    if( ( Handle > 0 ) and ( Handle <= File_Mapping_List.Count ) ) then
    begin
        Info := TFile_Mapping_Info( File_Mapping_List[ Handle - 1 ] ) ;
        if( Info = nil ) then
        begin
            exit ;
        end ;
        Result := Info.Size ;
    end ;
end ;


function TSOS_IOS.Total_Physical_Memory : int64 ;

begin
    Result := -1 ;
end ;


function TSOS_IOS.Available_Physical_Memory : int64 ;

begin
    Result := 0 ;
end ;


function TSOS_IOS.Total_Virtual_Memory : int64 ;

begin
    Result := 0 ;
end ;


function TSOS_IOS.Available_Virtual_Memory : int64 ;

begin
    Result := 0 ;
end ;


function TSOS_IOS.Application_Data_Path( Default_Root, Path : Ansistring ;
    Flags : integer ) : Ansistring ;
//      ADPF_Create = 2 ; { Create path if it doesn't exist }

var Dummy : integer ;
    Loop : integer ;
    P : Ansistring ;
    S : string ;

    procedure Determine_Path ;

    var Dummy : integer ;
        H : THandle ;

    begin
        S := '~/.config' ;
        if( Path <> '' ) then
        begin
            if( copy( Path, 1, 1 ) <> '/' ) then
            begin
                S := S + '/' ;
            end ;
            S := S + Path ;
        end ;
        if( copy( S, length( S ), 1 ) <> '/' ) then
        begin
            S := S + '/' ;
        end ;
        Result := S ;

        // Remove double separators...
        Dummy := pos( '//', Result ) ;
        while( Dummy > 0 ) do
        begin
            Result := copy( Result, 1, Dummy ) + copy( Result, Dummy + 2, length( Result ) ) ;
            Dummy := pos( '//', Result ) ;
        end ;
    end ; { TSOS_IOS.Application_Data_Path.Determine_Path }


begin { TSOS_IOS.Application_Data_Path }
    // Normalize paths...
    if( copy( Path, 1, 1 ) = '/' ) then
    begin
        Path := copy( Path, 2, length( Path ) ) ;
    end ;
    if( copy( Default_Root, 1, 1 ) = '/' ) then
    begin
        Default_Root := copy( Default_Root, 2, length( Default_Root ) ) ;
    end ;
    if( Path <> '' ) then
    begin
        if( copy( Path, length( Path ), 1 ) <> '/' ) then
        begin
            Path := Path + '/' ;
        end ;
    end ;
    if( Default_Root <> '' ) then
    begin
        if( copy( Default_Root, length( Default_Root ), 1 ) <> '/' ) then
        begin
            Default_Root := Default_Root + '/' ;
        end ;
        Path := Default_Root + Path ;
    end ;

    // Now determine path...
    Determine_Path ;
    S := Result ;
    if( copy( S, length( S ), 1 ) = '/' ) then
    begin
        setlength( S, length( S ) - 1 ) ;
    end ;
    if( ( not DirectoryExists( S ) ) and ( ( Flags and ADPF_Create ) <> 0 ) ) then
    begin
        // Missing directory and caller wants to create missing directories...
        if( Create_Path( S ) <> 0 ) then
        begin
            Result := '' ;
        end ;
    end ;
end ; { TSOS_IOS.Application_Data_Path }


function TSOS_IOS.Create_Path( Path : AnsiString ) : integer ;

var Dummy : integer ;
    So_Far : Ansistring ;

begin
    So_Far := '' ;
    while( Path <> '' ) do
    begin
        Dummy := pos( '/', Path + '/' ) ;
        So_Far := So_Far + copy( Path, 1, Dummy - 1 ) ;
        Path := copy( Path, Dummy + 1, length( Path ) ) ;
        if( copy( So_Far, length( So_Far ), 1 ) <> ':' ) then
        begin
            {$I-}
            MkDir( So_Far ) ;
            {$I+}
            Dummy := IOResult ;
            if( ( Dummy <> 0 ) and ( Dummy <> 183 ) and ( Dummy <> 5 ) ) then // Not okay and not already exists
            begin
                Create_Path := Dummy ;
                exit ;
            end ;
        end ; // if( copy( So_Far, length( So_Far ), 1 ) <> ':' )
        So_Far := So_Far + '/' ;
    end ; // while( Path <> '' )
    Result := 0 ;
end ; // TSOS_IOS.Create_Path


function TSOS_IOS.Shared_Library_Extension : Ansistring ;

begin
    Result := 'so' ;
end ;


function TSOS_IOS.Path_Separator : Ansistring ;

begin
    Result := '/' ;
end ;


function TSOS_IOS.Hardware_Name : Ansistring ;

var Size : size_t ;
    DeviceModelBuffer : array of Byte ;

begin
    sysctlbyname( 'hw.machine', nil, @Size, nil, 0 ) ;

    if( Size > 0 ) then
    begin
        SetLength( DeviceModelBuffer, Size ) ;
        sysctlbyname( 'hw.machine', @DeviceModelBuffer[ 0 ], @Size, nil, 0) ;
        Result := UTF8ToString( MarshaledAString( DeviceModelBuffer ) ) ;
    end else
    begin
        Result := '' ;
    end ;
end ;



{ PSWindows_Numeric_Text_Presentation_Manager... }

type TSIOS_Numeric_Text_Presentation_Manager = object( TSNumeric_Text_Presentation_Manager )
                                                       public
                                                          function Decimal : Ansistring ;
                                                              virtual ;

                                                          function Group : Ansistring ;
                                                              virtual ;

                                                          function Negative : Ansistring ;
                                                              virtual ;

                                                          function Positive : Ansistring ;
                                                              virtual ;
                                                   end ;
     PSWindows_Numeric_Text_Presentation_Manager = ^TSIOS_Numeric_Text_Presentation_Manager ;


function TSIOS_Numeric_Text_Presentation_Manager.Decimal : Ansistring ;

begin
    Decimal := '.' ; //TODO
end ;


function TSIOS_Numeric_Text_Presentation_Manager.Group : Ansistring ;

begin
    Group := ',' ; // TODO
end ;


function TSIOS_Numeric_Text_Presentation_Manager.Negative : Ansistring ;

begin
    Negative := '-' ; // TODO
end ;


function TSIOS_Numeric_Text_Presentation_Manager.Positive : Ansistring ;

begin
    Positive := '+' ; // TODO
end ;



{ TSIOS_Monetary_Text_Presentation_Manager... }

type TSIOS_Monetary_Text_Presentation_Manager = object( TSMonetary_Text_Presentation_Manager )
                                                       public { API... }
                                                           function Decimal : Ansistring ;
                                                               virtual ;

                                                           function Group : Ansistring ;
                                                               virtual ;

                                                           function Money_Symbol : Ansistring ;
                                                               virtual ;

                                                           function Internationl_Money_Symbol : Ansistring ;
                                                               virtual ;
                                                    end ;
     PSWindows_Monetary_Text_Presentation_Manager = ^TSIOS_Monetary_Text_Presentation_Manager ;


function TSIOS_Monetary_Text_Presentation_Manager.Decimal : Ansistring ;

begin
    Decimal := '.' ; // TODO
end ;


function TSIOS_Monetary_Text_Presentation_Manager.Group : Ansistring ;

begin
    Group := ',' ; // TODO
end ;


function TSIOS_Monetary_Text_Presentation_Manager.Money_Symbol : Ansistring ;

begin
    Money_Symbol := '$' ; // TODO
end ;


function TSIOS_Monetary_Text_Presentation_Manager.Internationl_Money_Symbol : Ansistring ;

begin
    Internationl_Money_Symbol := '$' ; // TODO
end ;



{ TSIOS_Date_Text_Presentation_Manager... }

type TSIOS_Date_Text_Presentation_Manager = object( TSDate_Text_Presentation_Manager )
                                                   public { API... }
                                                       function AM : Ansistring ;
                                                           virtual ;

                                                       function Date_Separator : Ansistring ;
                                                           virtual ;

                                                       function Days( M : integer ) : Ansistring ;
                                                           virtual ;

                                                       function Months( M : integer ) : Ansistring ;
                                                           virtual ;

                                                       function PM : Ansistring ;
                                                           virtual ;

                                                       function Short_Days( M : integer ) : Ansistring ;
                                                           virtual ;

                                                       function Short_Months( M : integer ) : Ansistring ;
                                                           virtual ;

                                                       function Time_Separator : Ansistring ;
                                                           virtual ;
                                                end ;
     PSWindows_Date_Text_Presentation_Manager = ^TSIOS_Date_Text_Presentation_Manager ;


function TSIOS_Date_Text_Presentation_Manager.AM : Ansistring ;

begin
    AM := 'AM' ; // TODO
end ;


function TSIOS_Date_Text_Presentation_Manager.Date_Separator : Ansistring ;

begin
    Date_Separator := '/' ; // TODO
end ;


function TSIOS_Date_Text_Presentation_Manager.Days( M : integer ) : Ansistring ;

begin
    case M of // TODO
        1 : Days := 'Sunday' ;
        2 : Days := 'Monday' ;
        3 : Days := 'Tuesday' ;
        4 : Days := 'Wednesday' ;
        5 : Days := 'Thursday' ;
        6 : Days := 'Friday' ;
        7 : Days := 'Saturday' ;
        else Days := '' ;
    end ;
end ;


function TSIOS_Date_Text_Presentation_Manager.Months( M : integer ) : Ansistring ;

begin
    case M of // TODO
        1 : Months := 'January' ;
        2 : Months := 'February' ;
        3 : Months := 'March' ;
        4 : Months := 'April' ;
        5 : Months := 'May' ;
        6 : Months := 'June' ;
        7 : Months := 'July' ;
        8 : Months := 'August' ;
        9 : Months := 'September' ;
        10 : Months := 'October' ;
        11 : Months := 'November' ;
        12 : Months := 'December' ;
        13 : Months := '' ;
        else Months := '' ;
    end ;
end ;


function TSIOS_Date_Text_Presentation_Manager.PM : Ansistring ;

begin
    PM := 'PM' ; // TDO
end ;


function TSIOS_Date_Text_Presentation_Manager.Short_Days( M : integer ) : Ansistring ;

begin
    case M of // TODO
        1 : Short_Days := 'Sun' ;
        2 : Short_Days := 'Mon' ;
        3 : Short_Days := 'Tue' ;
        4 : Short_Days := 'Wed' ;
        5 : Short_Days := 'Thr' ;
        6 : Short_Days := 'Fri' ;
        7 : Short_Days := 'Sat' ;
        else Short_Days := '' ;
    end ;
end ;


function TSIOS_Date_Text_Presentation_Manager.Short_Months( M : integer ) : Ansistring ;

begin
    case M of // TODO
        1 : Short_Months := 'Jan' ;
        2 : Short_Months := 'Feb' ;
        3 : Short_Months := 'Mar' ;
        4 : Short_Months := 'Apr' ;
        5 : Short_Months := 'May' ;
        6 : Short_Months := 'Jun' ;
        7 : Short_Months := 'Jul' ;
        8 : Short_Months := 'Aug' ;
        9 : Short_Months := 'Sep' ;
        10 : Short_Months := 'Oct' ;
        11 : Short_Months := 'Nov' ;
        12 : Short_Months := 'Dec' ;
        13 : Short_Months := '' ;
        else Short_Months := '' ;
    end ;
end ;


function TSIOS_Date_Text_Presentation_Manager.Time_Separator : Ansistring ;

begin
    Time_Separator := ':' ; // TODO
end ;



{ TSIOS_Text_Presentation_Manager methods... }

{ Constructors and destructors... }

constructor TSIOS_Text_Presentation_Manager.Init ;

begin
    inherited Init ;

    _Numeric_Text_Presentation_Manager := nil ;
    _Monetary_Text_Presentation_Manager := nil ;
    _Date_Text_Presentation_Manager := nil ;
end ;


destructor TSIOS_Text_Presentation_Manager.Done ;

begin
    if( _Numeric_Text_Presentation_Manager <> nil ) then
    begin
        dispose( _Numeric_Text_Presentation_Manager, Done ) ;
        _Numeric_Text_Presentation_Manager := nil ;
    end ;
    if( _Monetary_Text_Presentation_Manager <> nil ) then
    begin
        dispose( _Monetary_Text_Presentation_Manager, Done ) ;
        _Monetary_Text_Presentation_Manager := nil ;
    end ;
    if( _Date_Text_Presentation_Manager <> nil ) then
    begin
        dispose( _Date_Text_Presentation_Manager, Done ) ;
        _Date_Text_Presentation_Manager := nil ;
    end ;

    inherited Done ;
end ;


{ API... }

function TSIOS_Text_Presentation_Manager.Numeric_Text_Presentation_Manager : PSNumeric_Text_Presentation_Manager ;

begin
    if( _Numeric_Text_Presentation_Manager = nil ) then
    begin
        _Numeric_Text_Presentation_Manager := new( PSWindows_Numeric_Text_Presentation_Manager, Init ) ;
    end ;
    Numeric_Text_Presentation_Manager := _Numeric_Text_Presentation_Manager ;
end ;


function TSIOS_Text_Presentation_Manager.Monetary_Text_Presentation_Manager : PSMonetary_Text_Presentation_Manager ;

begin
    if( _Monetary_Text_Presentation_Manager = nil ) then
    begin
        _Monetary_Text_Presentation_Manager := new( PSWindows_Monetary_Text_Presentation_Manager, Init ) ;
    end ;
    Monetary_Text_Presentation_Manager := _Monetary_Text_Presentation_Manager ;
end ;


function TSIOS_Text_Presentation_Manager.Date_Text_Presentation_Manager : PSDate_Text_Presentation_Manager ;

begin
    if( _Date_Text_Presentation_Manager = nil ) then
    begin
        _Date_Text_Presentation_Manager := new( PSWindows_Date_Text_Presentation_Manager, Init ) ;
    end ;
    Date_Text_Presentation_Manager := _Date_Text_Presentation_Manager ;
end ;



begin
    Last_S := 0 ;
    Last_H := 0 ;
    Last_NS := 0 ;
end.
