{
        Program Name : ObjectFa
        Package Name : Subroutine Library - Layer 4
        Purpose      : Common base objects (TBase_Object and TBase_Delphi_Object)
        Institution  : Conroy & Conroy Co.
        Date Written : 19-Feb-2005
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2005 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit ObjectFa ;

interface

{$I EDEFINES.INC}

implementation

uses { Subroutine Library - Layer 0... }
     _GenVal, { PSGeneric_Value }
     _NameVal, { PSNamed_Values }
     _ObjectF, { PSObject_Factory }
     _Propert, { PSDynamic_Properties }

     { Subroutine Library - Layer 1... }
     DPropert, { PSStandard_Dynamic_Properties }
     NameVals, { PSStandard_Named_Properties }

     { Subroutine Library - Layer 4... }
     GenVal ; { PSSimple_Generic_Value }

type TSDefault_Object_Factory = object( TSObject_Factory )
                                    public
                                        function Static_Dynamic_Properties : PSDynamic_Properties ;
                                            virtual ;
                                        function Static_Generic_Value : PSGeneric_Value ;
                                            virtual ;
                                        function Static_Named_Values : PSNamed_Values ;
                                            virtual ;
{$IFDEF FPC_OR_DELPHI}
                                        function COM_Dynamic_Properties : TCOM_Dynamic_Properties ;
                                            virtual ;
                                        function Dynamic_Properties : TDynamic_Properties ;
                                            virtual ;
                                        function COM_Generic_Value : TCOM_Generic_Value ;
                                            virtual ;
                                        function Generic_Value : TGeneric_Value ;
                                            virtual ;
                                        function COM_Named_Values( Set_Name : string ;
                                            Create : boolean ) : TCOM_Named_Values ;
                                            virtual ;
                                        function Named_Values( Set_Name : string ;
                                            Create : boolean ) : TNamed_Values ;
                                            virtual ;
{$ENDIF}
                                end ;
     PSDefault_Object_Factory = ^TSDefault_Object_Factory ;

function TSDefault_Object_Factory.Static_Dynamic_Properties : PSDynamic_Properties ;

begin
    Static_Dynamic_Properties := new( PSStandard_Dynamic_Properties, Init ) ;
end ;


function TSDefault_Object_Factory.Static_Generic_Value : PSGeneric_Value ;

begin
    Static_Generic_Value := new( PSSimple_Generic_Value, Init ) ;
end ;


function TSDefault_Object_Factory.Static_Named_Values : PSNamed_Values ;

begin
    Static_Named_Values := new( PSStandard_Named_Values, Init ) ;
end ;


{$IFDEF FPC_OR_DELPHI}
function TSDefault_Object_Factory.COM_Dynamic_Properties : TCOM_Dynamic_Properties ;

begin
    COM_Dynamic_Properties := TStandard_COM_Dynamic_Properties.Create ;
end ;


function TSDefault_Object_Factory.Dynamic_Properties : TDynamic_Properties ;

begin
    Dynamic_Properties := TStandard_Dynamic_Properties.Create ;
end ;


function TSDefault_Object_Factory.COM_Generic_Value : TCOM_Generic_Value ;

begin
    COM_Generic_Value := TCOM_Simple_Generic_Value.Create ;
end ;


function TSDefault_Object_Factory.Generic_Value : TGeneric_Value ;

begin
    Generic_Value := TSimple_Generic_Value.Create ;
end ;


function TSDefault_Object_Factory.COM_Named_Values( Set_Name : string ; Create : boolean ) : TCOM_Named_Values ;

begin
    COM_Named_Values := TStandard_COM_Named_Values.Create ;
end ;


function TSDefault_Object_Factory.Named_Values( Set_Name : string ; Create : boolean ) : TNamed_Values ;

begin
    Named_Values := TStandard_Named_Values.Create ;
end ;
{$ENDIF}



begin
    Object_Factory := new( PSDefault_Object_Factory, Init ) ;
end.
