{$IFNDEF FPC}
  {$N+}
{$ENDIF}
{
        Program Name : _CCStandard
        Package Name : Subroutine Library - Layer 3
        Purpose      : Standard Pascal routines
        Institution  : Conroy & Conroy Co.
        Date Written : 28-Nov-88
        Written By   : Alan Conroy
        Version      : 2.1I

        Copyright (c) 1988-2018 by Alan Conroy.  Released to the Public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

             DATE      BY             REASON

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          This unit contains standard Pascal support routines for Conroy &
        Conroy Co.
}

{$I EDEFINES.INC}

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

{$IFDEF FPC_OR_DELPHI}
{$DEFINE WINDOWS}
{$ENDIF}

unit _CCStandard ;

interface

var Bit_Values : array[ 0..31 ] of longint =
        (1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768,65536,
         $20000,$40000,$80000,
         $100000,$200000,$400000,$800000,
         $1000000,$2000000,$4000000,$8000000,
         $10000000,$20000000,$40000000,$80000000) ;
{$IFDEF INT64}
    XBit_Values : array[ 0..63 ] of int64 =
        (1,2,4,8,
         16,32,64,128,
         256,512,1024,2048,
         4096,8192,16384,32768,
         $10000, $20000,$40000,$80000,
         $100000,$200000,$400000,$800000,
         $1000000,$2000000,$4000000,$8000000,
         $10000000,$20000000,$40000000,$80000000,
         $100000000,$200000000,$400000000,$800000000,
         $1000000000,$2000000000,$4000000000,$8000000000,
         $10000000000,$20000000000,$40000000000,$80000000000,
         $100000000000,$200000000000,$400000000000,$800000000000,
         $1000000000000,$2000000000000,$4000000000000,$8000000000000,
         $10000000000000,$20000000000000,$40000000000000,$80000000000000,
         $100000000000000,$200000000000000,$400000000000000,$800000000000000,
         $1000000000000000,$2000000000000000,$4000000000000000,$8000000000000000) ;
    Bit_Masks : array[ 0..63 ] of int64 =
        (1,3,7,15,
         $1F,$3F,$7F,$FF,
         $1FF,$3FF,$7FF,$FFF,
         $1FFF,$3FFF,$7FFF,$FFFF,
         $1FFFF,$3FFFF,$7FFFF,$FFFFF,
         $1FFFFF,$3FFFFF,$7FFFFF,$FFFFFF,
         $1FFFFFF,$3FFFFFF,$7FFFFFF,$FFFFFFF,
         $1FFFFFFF,$3FFFFFFF,$7FFFFFFF,$FFFFFFFF,
         $1FFFFFFFF,$3FFFFFFFF,$7FFFFFFFF,$FFFFFFFFF,
         $1FFFFFFFFF,$3FFFFFFFFF,$7FFFFFFFFF,$FFFFFFFFFF,
         $1FFFFFFFFFF,$3FFFFFFFFFF,$7FFFFFFFFFF,$FFFFFFFFFFF,
         $1FFFFFFFFFFF,$3FFFFFFFFFFF,$7FFFFFFFFFFF,$FFFFFFFFFFFF,
         $1FFFFFFFFFFFF,$3FFFFFFFFFFFF,$7FFFFFFFFFFFF,$FFFFFFFFFFFFF,
         $1FFFFFFFFFFFFF,$3FFFFFFFFFFFFF,$7FFFFFFFFFFFFF,$FFFFFFFFFFFFFF,
         $1FFFFFFFFFFFFFF,$3FFFFFFFFFFFFFF,$7FFFFFFFFFFFFFF,$FFFFFFFFFFFFFFF,
         $1FFFFFFFFFFFFFFF,$3FFFFFFFFFFFFFFF,$7FFFFFFFFFFFFFFF,-1) ;
{$ELSE}
    Bit_Masks : array[ 0..31 ] of longint =
        (1,3,7,15,$1F,$3F,$7F,$FF,$1FF,$3FF,$7FF,$1FFF,$3FFF,$7FFF,$FFFF,
         $1FFFF,$3FFFF,$7FFFF,$FFFFF,$1FFFFF,$3FFFFF,$7FFFFF,$FFFFFF,
         $1FFFFFF,$3FFFFFF,$7FFFFFF,$FFFFFFF,$1FFFFFFF,$3FFFFFFF,$7FFFFFFF,$FFFFFFFF) ;
{$ENDIF}


implementation


var D : integer ;

begin
    Bit_Masks[ 0 ] := 1 ;
{$IFDEF FPC_OR_DELPHI}
    for D := 1 to 63 do
    begin
        Bit_Masks[ D ] := ( Bit_Masks[ D - 1 ] shl 1 ) or 1 ;
    end ;
{$ENDIF}
end.
