{
        Program Name : _COMLists
        Package Name : Subroutine Library Layer 0
        Purpose      : COM list abstract class
        Institution  : Conroy & Conroy Co.
        Date Written : 1-Nov-2006
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2006 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit _COMLists ;

interface

{$I EDEFINES.INC}

{$IFDEF DYNAMIC_OBJECTS}
uses { C&C Subroutine Library - Layer 0... }
     COMInter, { TCommon_COM_Interface }

     { Borland... }
     Classes ; { TList }

type TCOM_List = class( TCommon_COM_Interface )
                     public { API... }
                         function Add( Value : longint ) : longint ;
                             virtual ; stdcall ; abstract ;
                         function Get_Count : longint ;
                             virtual ; stdcall ; abstract ;
                         procedure Set_Count( Value : longint ) ;
                             virtual ; stdcall ; abstract ;
                         function Get_Capacity : longint ;
                             virtual ; stdcall ; abstract ;
                         procedure Set_Capacity( Value : longint ) ;
                             virtual ; stdcall ; abstract ;
                         function Get_Item( Index : longint ) : longint ;
                             virtual ; stdcall ; abstract ;
                         procedure Set_Item( Index, Value : longint ) ;
                             virtual ; stdcall ; abstract ;
                         function Get_Delta : longint ;
                             virtual ; stdcall ; abstract ;
                         procedure Set_Delta( Value : longint ) ;
                             virtual ; stdcall ; abstract ;
                         function IndexOf( Value : longint ) : longint ;
                             virtual ; stdcall ; abstract ;

                     public { Property handlers... }
                         function _Get_Item( Index : int64 ) : int64 ;
                         procedure _Set_Item( Index, Value : int64 ) ;
                         function _Get_Count : longint ;
                         procedure _Set_Count( Value : longint ) ;
                         function _Get_Capacity : longint ;
                         procedure _Set_Capacity( Value : longint ) ;
                         function _Get_Delta : longint ;
                         procedure _Set_Delta( Value : longint ) ;

                         property Items[ Index : int64 ] : int64
                             read _Get_Item
                             write _Set_Item ; default ;

                     published { Properties... }
                         property Capacity : longint
                             read _Get_Capacity
                             write _Set_Capacity ;
                         property Count : longint
                             read _Get_Count
                             write _Set_Count ;
                         property Delta : longint
                             read _Get_Delta
                             write _Set_Delta ;
                 end ;
{$ENDIF}

implementation

// TCOM_List methods...

function TCOM_List._Get_Item( Index : int64 ) : int64 ;

begin
    Result := Get_Item( Index ) ;
end ;


procedure TCOM_List._Set_Item( Index, Value : int64 ) ;

begin
    Set_Item( Index, Value ) ;
end ;


function TCOM_List._Get_Count : longint ;

begin
    Result := Get_Count ;
end ;


procedure TCOM_List._Set_Count( Value : longint ) ;

begin
    Set_Count( Value ) ;
end ;


function TCOM_List._Get_Capacity : longint ;

begin
    Result := Get_Capacity ;
end ;


procedure TCOM_List._Set_Capacity( Value : longint ) ;

begin
    Set_Capacity( Value ) ;
end ;


function TCOM_List._Get_Delta : longint ;

begin
    Result := Get_Delta ;
end ;


procedure TCOM_List._Set_Delta( Value : longint ) ;

begin
    Set_Delta( Value ) ;
end ;


end.

