{$A-}
{
              Program Name : _Lib
              Package Name : Subroutine Library - Layer 1
              Purpose      : Abstract Object Librarian class definitions
              Institution  : Conroy & Conroy Co.
              Date Written : 15-Dec-1988
              Written By   : Alan Conroy
              Version      : 1.0

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

             DATE      BY             REASON                   


        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *            F I L E   D E S C R I P T I O N S          *
        *                                                       *
        *********************************************************

}

unit _Lib ;

interface

{$I EDEFINES.INC}

uses { C&C... }
     _Common, { TObject }
     CommBase, { TBase_Delphi_Object }
     COMInter, { TCommon_COM_Interface }
     _UE ; { TUnified_Exception }

const LibErr_Facility = 14 ;
      LibErr_Success = 0 ;
      LibErr_Invalid_Library_File_Format = 1 ;
      LibErr_Module_Not_Found = 2 ;
      LibErr_Module_Already_Exists = 3 ;
      LibErr_Illegal_Module_Format = 4 ;

type Block = array[ 0..255 ] of Byte ;
     TModule_Info = record
                        Name : string[ 127 ] ;
                        Size : longint ;
                        Day, Month, Year, Hour, Minute : integer ;
                        Flags : longint ;
                    end ;

     TSObject_Librarian = object( TObject )
                            public
                                Creation_Hour, Creation_Minute : Integer ;
                                Creation_Day, Creation_Month, Creation_Year : Integer ;
                                Deleted_Space : longint ;
                                Modified_Hour, Modified_Minute : Integer ;
                                Modified_Day, Modified_Month, Modified_Year : Integer ;
                                Version : string ;

                            public { API... }
                                procedure Create_New( Command : String ;
                                    Language_Id, Typ : Integer) ; virtual ;
                                function Error : tSUnified_Exception ; virtual ;
                                procedure Extract( Module, Filename : string ) ;
                                    virtual ;
                                procedure Extract_Index( Module : integer ;
                                    Filename : string ; Start_Block : longint ) ;
                                    virtual ;
                                procedure Open( X : string ) ; virtual ;
                                procedure Delete( Command : string ) ; virtual ;
                                procedure Insert( Command, Filename : string ) ;
                                    virtual ;
                                procedure Get_Module( Start_Block, X : integer ;
                                    var Buffer ) ; virtual ;
                                function Get_Module_Info( X : integer ;
                                    var Info : TModule_Info ) : boolean ;
                                    virtual ;
                                function Size : longint ; virtual ;
                        end ; { TSObject_Librarian }

     PSObject_Librarian = ^TSObject_Librarian ;

{$IFDEF Delphi}
     TCOM_Object_Librarian = class( TCommon_COM_Interface )
                                 public { API... }
                                     function Creation_Hour : integer ;
                                         virtual ; stdcall ; abstract ;
                                     function Creation_Minute : Integer ;
                                         virtual ; stdcall ; abstract ;
                                     function Creation_Day : Integer ;
                                         virtual ; stdcall ; abstract ;
                                     function Creation_Month : Integer ;
                                         virtual ; stdcall ; abstract ;
                                     function Creation_Year : Integer ;
                                         virtual ; stdcall ; abstract ;
                                     function Deleted_Space : longint ;
                                         virtual ; stdcall ; abstract ;
                                     function Modified_Hour : Integer ;
                                         virtual ; stdcall ; abstract ;
                                     function Modified_Minute : Integer ;
                                         virtual ; stdcall ; abstract ;
                                     function Modified_Day : Integer ;
                                         virtual ; stdcall ; abstract ;
                                     function Modified_Month : Integer ;
                                         virtual ; stdcall ; abstract ;
                                     function Modified_Year : Integer ;
                                         virtual ; stdcall ; abstract ;
                                     function Version : PChar ;
                                         virtual ; stdcall ; abstract ;
                                     procedure Create_New( Command : PChar ;
                                         Language_Id, Typ : Integer ) ;
                                         virtual ; stdcall ; abstract ;
                                     function Error : tUnified_Exception ;
                                         virtual ; stdcall ; abstract ;
                                     procedure Extract( Module, Filename : PChar ) ;
                                         virtual ; stdcall ; abstract ;
                                     function Open( X : PChar ) : tUnified_Exception ;
                                         virtual ; stdcall ; abstract ;
                                     function Delete( Command : PChar ) : tUnified_Exception ;
                                         virtual ; stdcall ; abstract ;
                                     function Insert( Command, Filename : PChar ) : tUnified_Exception ;
                                         virtual ; stdcall ; abstract ;
                                     function Get_Module_Info_By_Name( Command : PChar ;
                                         var Info : TModule_Info ) : boolean ;
                                         virtual ; stdcall ; abstract ;
                                     function Get_Module_Info_By_Index( Index : integer ;
                                         var Info : TModule_Info ) : boolean ;
                                         virtual ; stdcall ; abstract ;
                                     function Size : longint ;
                                         virtual ; stdcall ; abstract ;
                             end ; { TCOM_Object_Librarian }

     TObject_Librarian = class( TBase_Delphi_Object )
                             public { API... }
                                 function Creation_Hour : integer ;
                                     virtual ; abstract ;
                                 function Creation_Minute : Integer ;
                                     virtual ; abstract ;
                                 function Creation_Day : Integer ;
                                     virtual ; abstract ;
                                 function Creation_Month : Integer ;
                                     virtual ; abstract ;
                                 function Creation_Year : Integer ;
                                     virtual ; abstract ;
                                 function Deleted_Space : longint ;
                                     virtual ; abstract ;
                                 function Modified_Hour : Integer ;
                                     virtual ; abstract ;
                                 function Modified_Minute : Integer ;
                                     virtual ; abstract ;
                                 function Modified_Day : Integer ;
                                     virtual ; abstract ;
                                 function Modified_Month : Integer ;
                                     virtual ; abstract ;
                                 function Modified_Year : Integer ;
                                     virtual ; abstract ;
                                 function Version : string ;
                                     virtual ; abstract ;
                                 procedure Create_New( Command : String ;
                                     Language_Id, Typ : Integer) ;
                                     virtual ; abstract ;
                                 function Error : tUnified_Exception ;
                                     virtual ; abstract ;
                                 procedure Extract( Module, Filename : string ) ;
                                     virtual ; abstract ;
                                 procedure Extract_Index( Module : integer ;
                                     Filename : string ; Start_Block : longint ) ;
                                     virtual ; abstract ;
                                 procedure Open( X : string ) ;
                                     virtual ; abstract ;
                                 procedure Delete( Command : string ) ;
                                     virtual ; abstract ;
                                 procedure Insert( Command, Filename : string ) ;
                                     virtual ; abstract ;
                                 procedure Get_Module( Start_Block, X : integer ;
                                     var Buffer ) ; virtual ; abstract ;
                                 function Get_Module_Info( X : integer ;
                                     var Info : TModule_Info ) : boolean ;
                                     virtual ; abstract ;
                                 function Size : longint ; virtual ; abstract ;
                         end ; { TObject_Librarian }
{$ENDIF}

implementation

{ TSObject_Librarian methods... }

{ API... }

procedure TSObject_Librarian.Create_New( Command : String ;
    Language_Id, Typ : Integer) ;

begin
    Abstract_Error ;
end ;


function TSObject_Librarian.Error : tSUnified_Exception ;

begin
    Abstract_Error ;
end ;


procedure TSObject_Librarian.Extract( Module, Filename : string ) ;

begin
    Abstract_Error ;
end ;


procedure TSObject_Librarian.Extract_Index( Module : integer ;
    Filename : string ; Start_Block : longint ) ;

begin
    Abstract_Error ;
end ;


procedure TSObject_Librarian.Open( X : string ) ;

begin
    Abstract_Error ;
end ;


procedure TSObject_Librarian.Delete( Command : string ) ;

begin
    Abstract_Error ;
end ;


procedure TSObject_Librarian.Insert( Command, Filename : string ) ;

begin
    Abstract_Error ;
end ;


procedure TSObject_Librarian.Get_Module( Start_Block, X : integer ;
    var Buffer ) ;

begin
    Abstract_Error ;
end ;


function TSObject_Librarian.Get_Module_Info( X : integer ;
    var Info : TModule_Info ) : boolean ;

begin
    Get_Module_Info := False ;
    Abstract_Error ;
end ;


function TSObject_Librarian.Size : longint ;

begin
    Size := 0 ;
    Abstract_Error ;
end ;



end.
