{$IFNDEF FPC}
  {$N+}
  {$E+}
{$ENDIF}
{
        Program Name : _NameVal
        Package Name : Subroutine Library - Layer 0
        Purpose      : Named values class definitions.
        Institution  : Conroy & Conroy Co.
        Date Written : 14-April-2008
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2008 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TNamed_Values is a class that provides a set of values associated with
        a name.
}

unit _NameVal ;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

{$I EDEFINES.INC}

uses { C&C Subroutine Library... }
     _Common, { TObject }
     ComInter, { TCommon_COM_Interface }
     _Types ; { AnsiString }

{$IFDEF FPC_OR_DELPHI}
type TNamed_Values = class( TDelphi_Object )
                          public { API... }
                              function Index_Of( Name : Ansistring ) : integer ;
                                  virtual ; abstract ;
                              function Index_Of_Value( Value : Ansistring ) : integer ;
                                  virtual ; abstract ;
                              function Get( Index : integer ) : Ansistring ;
                                  virtual ; abstract ;
                              function Get_Name( Index : integer ) : Ansistring ;
                                  virtual ; abstract ;
                              function Put( Index : integer ; Value : Ansistring ) : integer ;
                                  virtual ; abstract ;
                              function Put_by_Name( Name, Value : Ansistring ) : integer ;
                                  virtual ; abstract ;
                              procedure Delete( Index : integer ) ;
                                  virtual ; abstract ;
                      end ;

     TCOM_Named_Values = class( TCommon_COM_Interface )
                              public { API... }
                                  function Index_Of( Name : PAnsiChar ) : integer ;
                                      virtual ; stdcall ; abstract ;
                                  function Index_Of_Value( Value : PAnsiChar ) : integer ;
                                      virtual ; stdcall ; abstract ;
                                  function Get( Index : integer ) : PAnsiChar ;
                                      virtual ; stdcall ; abstract ;
                                  function Get_Name( Index : integer ) : PAnsiChar ;
                                      virtual ; stdcall ; abstract ;
                                  function Put( Index : integer ; Value : PAnsiChar ) : integer ;
                                      virtual ; stdcall ; abstract ;
                                  function Put_by_Name( Name, Value : PAnsiChar ) : integer ;
                                      virtual ; stdcall ; abstract ;
                                  procedure Delete( Index : integer ) ;
                                      virtual ; stdcall ; abstract ;
                          end ;
{$ENDIF}

type PSNamed_Values = ^TSNamed_Values ;

     TSNamed_Values = object( TObject )
                           public { API... }
                              function Index_Of( Name : Ansistring ) : integer ;
                                  virtual ;
                              function Index_Of_Value( Value : Ansistring ) : integer ;
                                  virtual ;
                              function Get( Index : integer ) : Ansistring ;
                                  virtual ;
                              function Get_Name( Index : integer ) : Ansistring ;
                                  virtual ;
                              function Put( Index : integer ; Value : Ansistring ) : integer ;
                                  virtual ;
                              function Put_by_Name( Name, Value : Ansistring ) : integer ;
                                  virtual ;
                              procedure Delete( Index : integer ) ;
                                  virtual ;
                       end ;

implementation

{ TSNamed_Values methods...}

function TSNamed_Values.Index_Of( Name : Ansistring ) : integer ;

begin
    Index_Of := -1 ;
    Abstract_Error ;
end ;


function TSNamed_Values.Index_Of_Value( Value : Ansistring ) : integer ;

begin
    Index_Of_Value := -1 ;
    Abstract_Error ;
end ;


function TSNamed_Values.Get( Index : integer ) : Ansistring ;

begin
    Get := '' ;
    Abstract_Error ;
end ;


function TSNamed_Values.Get_Name( Index : integer ) : Ansistring ;

begin
    Get_Name := '' ;
    Abstract_Error ;
end ;


function TSNamed_Values.Put( Index : integer ; Value : Ansistring ) : integer ;

begin
    Put := -1 ;
    Abstract_Error ;
end ;


function TSNamed_Values.Put_by_Name( Name, Value : Ansistring ) : integer ;

begin
    Put_by_Name := -1 ;
    Abstract_Error ;
end ;


procedure TSNamed_Values.Delete( Index : integer ) ;

begin
    Abstract_Error ;
end ;



end.
