{
        Program Name : Text_Editor_Interface
        Package Name : Subroutine Library - layer 0
        Purpose      : Visual interface to a Text_Editor
        Institution  : Conroy & Conroy Co.
        Date Written :
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2012 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON                         

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit _TE_Interface ;

interface

uses // Borland...
     Classes, // TShiftState
     Graphics, // TColor

     // C&C Subroutine Library - layer 0...
     CommBase ; // TBase_Delphi_Object

type TText_Editor_Position = record
                                 Row : integer ;
                                 Column : integer ;
                             end ;

     TText_Editor_Interface_Notifier = class( TBase_Delphi_Object )
                                           public // API...
                                               procedure Cursor_Change( R, C : integer ) ;
                                                   virtual ; stdcall ; abstract ;
                                               procedure Line_Read( R : integer ) ;
                                                   virtual ; stdcall ; abstract ;
                                       end ;


     TText_Editor_Interface = class( TBase_Delphi_Object )
                                  public // API...
                                      procedure Set_Parent( Handle : integer ) ;
                                          virtual ; stdcall ; abstract ;
                                      function Get_Parent : integer ;
                                          virtual ; stdcall ; abstract ;
                                      procedure Set_Size( Height, Width : integer ) ;
                                          virtual ; stdcall ; abstract ;
                                      function Column_Count : integer ;
                                          virtual ; stdcall ; abstract ;
                                      function Line_Count : integer ;
                                          virtual ; stdcall ; abstract ;

                                      procedure Set_Background( Color : TColor ) ;
                                          virtual ; stdcall ; abstract ;
                                      procedure Set_Foreground( Color : TColor ) ;
                                          virtual ; stdcall ; abstract ;
                                      procedure Set_Font( Name : PChar ) ;
                                          virtual ; stdcall ; abstract ;
                                      procedure Set_Font_Size( Siz : integer ) ;
                                          virtual ; stdcall ; abstract ;

                                      procedure Load_File( Nam : PChar ) ;
                                          virtual ; stdcall ; abstract ;
                                      procedure Save_File( Nam : PChar ) ;
                                          virtual ; stdcall ; abstract ;

                                      function Get_Line( Row : integer ) : PChar ;
                                          virtual ; stdcall ; abstract ;

                                      procedure Locate( S : string ;
                                          var R, C : integer ; CS : boolean ) ;
                                          virtual ; stdcall ; abstract ;
                                      procedure Position_To( R, C : integer ) ;
                                          virtual ; stdcall ; abstract ;
                                      procedure Get_Position( var R, C : integer ) ;
                                          virtual ; stdcall ; abstract ;
                                      procedure Set_Notifier( V : TText_Editor_Interface_Notifier ) ;
                                          virtual ; stdcall ; abstract ;
                                      procedure Key_Down( var Key : Word ;
                                          Shift : TShiftState ) ;
                                          virtual ; stdcall ; abstract ;
                                      procedure Bring_Cursor_Into_View ;
                                          virtual ; stdcall ; abstract ;
                                      procedure SetFocus ;
                                          virtual ; stdcall ; abstract ;
                                      procedure Set_Position( P : TText_Editor_Position ) ;
                                          virtual ; stdcall ; abstract ;
                                      function Get_Selected_Text : string ;
                                          virtual ; stdcall ; abstract ;

                                  public
                                      property Parent : integer
                                          read Get_Parent
                                          write Set_Parent ;
                              end ;

implementation

end.

