{
        Program Name : _TestMa
        Package Name : Subroutine Library - Layer 1
        Purpose      : Test Manager pure virtual classes
        Institution  : Conroy & Conroy Co.
        Date Written : 15-August-2008
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2008 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          The classes in this unit define the Test Manager interface.
}

unit _TestMa ;

interface

uses { Layer 0... }
     _Streams, { TStream }
     CommBase, { TBase_Object }
     ComInter, { TCommon_COM_Interface }
     _Types ; { Ansistring }

{$I EDEFINES.INC}

{$IFDEF DYNAMIC_OBJECTS}
type TUnit_Tester = class( TBase_Delphi_Object )
                        public { API... }
                            { Returns the name of the unit }
                            function Get_Name : Ansistring ; virtual ; abstract ;

                            { Runs test }
                            function Run_Test( Flags : longint ;
                                Stream : TStream ) : boolean ;
                                virtual ; abstract ;
                    end ;

type TTest_Manager = class( TBase_Delphi_Object )
                          public { Unit tester support... }
                              function Get_Unit_Tester( Index : longint ) : TUnit_Tester ;
                                  virtual ; abstract ;

                              { Register a unit tester }
                              procedure Register_Unit_Tester( D : TUnit_Tester ) ;
                                  virtual ; abstract ;

                              { Remove a registered unit tester }
                              procedure Remove_Unit_Tester( D : TUnit_Tester ) ;
                                  virtual ; abstract ;

                              { Returns count of registered unit Testers }
                              function Unit_Tester_Count : longint ;
                                  virtual ; abstract ;

                              { Runs test }
                              function Run_Test( Flags : longint ;
                                Stream : TStream ) : boolean ;
                                virtual ; abstract ;
                      end ;

type TCOM_Unit_Tester = class( TBase_Delphi_Object )
                            public { API... }
                                { Returns the name of the unit }
                                function Get_Name : PAnsiChar ;
                                    virtual ; stdcall ; abstract ;

                                { Runs test }
                                function Run_Test( Flags : longint ;
                                    Stream : TCOM_Stream ) : boolean ;
                                virtual ; stdcall ; abstract ;
                        end ;

type TCOM_Test_Manager = class( TCommon_COM_Interface )
                              public { Unit Tester support... }
                                  function Get_Unit_Tester( Index : longint ) : TCOM_Unit_Tester ;
                                      virtual ; stdcall ; abstract ;

                                  { Register a unit Tester }
                                  procedure Register_Unit_Tester( D : TCOM_Unit_Tester ) ;
                                      virtual ; stdcall ; abstract ;

                                  { Remove a registered unit Tester }
                                  procedure Remove_Unit_Tester( D : TCOM_Unit_Tester ) ;
                                      virtual ; stdcall ; abstract ;

                                  { Returns count of registered unit Testers }
                                  function Unit_Tester_Count : longint ;
                                      virtual ; stdcall ; abstract ;

                                  { Runs test }
                                  function Run_Test( Flags : longint ;
                                      Stream : TCOM_Stream ) : boolean ;
                                      virtual ; stdcall ; abstract ;
                          end ;
{$ENDIF}

type TSUnit_Tester = object( TBase_Object )
                         public { API... }
                             { Returns the name of the unit }
                             function Get_Name : Ansistring ; virtual ;

                             { Runs test }
                             function Run_Test( Flags : longint ;
                                Stream : PSStream ) : boolean ;
                                virtual ;
                     end ;
     PSUnit_Tester = ^TSUnit_Tester ;

type TSTest_Manager = object( TBase_Object )
                          public { Unit Tester support... }
                              function Get_Unit_Tester( Index : longint ) : PSUnit_Tester ;
                                  virtual ;

                              { Register a unit Tester }
                              procedure Register_Unit_Tester( D : PSUnit_Tester ) ;
                                  virtual ;

                              { Remove a registered unit Tester }
                              procedure Remove_Unit_Tester( D : PSUnit_Tester ) ;
                                  virtual ;

                              { Returns count of registered unit Testers }
                              function Unit_Tester_Count : longint ;
                                  virtual ;

                              { Runs test }
                              function Run_Test( Flags : longint ;
                                Stream : PSStream ) : boolean ;
                                virtual ;
                      end ;
     PSTest_Manager = ^TSTest_Manager ;

implementation

function TSUnit_Tester.Get_Name : Ansistring ;

begin
    Get_Name := '' ;
end ;


function TSUnit_Tester.Run_Test( Flags : longint ; Stream : PSStream ) : boolean ;

begin
    Run_Test := True ;
end ;



function TSTest_Manager.Get_Unit_Tester( Index : longint ) : PSUnit_Tester ;

begin
    Get_Unit_Tester := nil ;
end ;


procedure TSTest_Manager.Register_Unit_Tester( D : PSUnit_Tester ) ;

begin
    { Intentionally left blank }
end ;


procedure TSTest_Manager.Remove_Unit_Tester( D : PSUnit_Tester ) ;

begin
    { Intentionally left blank }
end ;


function TSTest_Manager.Unit_Tester_Count : longint ;

begin
    Unit_Tester_Count := 0 ;
end ;


function TSTest_Manager.Run_Test( Flags : longint ;
    Stream : PSStream ) : boolean ;

begin
    Run_Test := True ;
end ;



end.
