{
        Program Name : Events
        Package Name : Subroutine library - layer 1
        Purpose      : Abstract base class for events
        Institution  : Conroy & Conroy Co.
        Date Written : 18-July-2004
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2004 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON                         

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TSEvent is the base class for event objects which are used to pass
        event notifications between objects.
}

unit _Events ;

interface

{$I EDEFINES.INC}

uses
{$IFDEF FPC_OR_DELPHI}
     { Borland... }
     Classes,
{$ENDIF}

     { Layer 0... }
     CommBase ; { TObject }

const EID_Windows_Key_Down = 1 ; { Key downpress }
      EID_Windows_Mouse_LButton_Click = 2 ; { Mouse left-button click }
      EID_Windows_Resize = 3 ; { Size/resize }

type TSGeneric_Event = object( TBase_Object )
                           public { API... }
                               Source : pointer ; { Source (object) of event }
                               User : boolean ; { True if directly a user-generated event (such as a keystroke) }
                               Event_Type : longint ; { Unique ID for event }

                               function Name : string ; virtual ; { Name of event }
                       end ;
     PSGeneric_Event = ^TSGeneric_Event ;

{$IFDEF DYNAMIC_OBJECTS}
type TGeneric_Event = class( TBase_Delphi_Object )
                          public { API... }
                              Source : pointer ; { Source (object) of event }
                              User : boolean ; { True if directly a user-generated event (such as a keystroke) }
                              Event_Type : longint ; { Unique ID for event }

                              function Name : string ; virtual ; abstract ; { Name of event }
                      end ;
{$ENDIF}

implementation

{ TSGeneric_Event methods...}

{ API... }

function TSGeneric_Event.Name : string ;

begin
    Name := 'Abstract TSGeneric_Event' ;
end ;



end.

