/*
----------------------------------------------------------------------------
file:      eDefines.h
type:      C++ header/include file

compiler:  C++Builder 1-5
           Borland C++
           MingW

platforms: DOS, DPMI, Win16, Win32, Linux

contents:  Defines that can be used to determine the compiler, compiler version,
   and features used.  It also provides cross-compiler compatibility.

----------------------------------------------------------------------------
*/

/*
----------------------------------------------------------------------------
 Compiler and OS version defines:

 exact compiler versions:

 BORLANDCPP2     Borland C++ 2.0
 BORLANDCPP3     Borland C++ 3.0
 BORLANDCPP3_1   Borland C++ 3.1
 BORLANDCPP4     Borland C++ 4.0
 BORLANDCPP5     Borland C++ 5.0
 BORLANDCPP5_5	 Borland C++ 5.5
 BORLANDCPP5_6	 Borland C++ 5.6
 CBUILDER1       C++Builder 1.0
 CBUILDER3       C++Builder 3.0
 CBUILDER4       C++Builder 4.0
 CBUILDER5       C++Builder 5.0
 CBUILDER2006	 C++Builder 2006
 CBUILDER2007	 C++Builder 2007
 CBUILDER2009	 C++Builder 2009
 CBUILDER2010	 C++Builder 2010
 CBUILDERXE		 C++Builder XE
 CBUILDERXE2	 C++Builder XE2
 CBUILDERXE3	 C++Builder XE3
 CBUILDERXE4	 C++Builder XE4
 CBUILDERXE5	 C++Builder XE5
 CBUILDERXE6	 C++Builder XE6
 CBUILDERXE7	 C++Builder XE7
 CBUILDERXE8	 C++Builder XE8
 CBUILDERSEATTLE C++Builder Seattle

 minimum compiler versions:

 BORLANDCPP2UP   Borland C++ 2.0 and above
 BORLANDCPP3UP   Borland C++ 3.0 and above
 BORLANDCPP3_1UP Borland C++ 3.1 and above
 BORLANDCPP4UP	 Borland C++ 4.0 and above
 BORLANDCPP5UP	 Borland C++ 5.0 and above
 BORLANDCPP5_5UP Borland C++ 5.5 and above
 BORLANDCPP5_6UP Borland C++ 5.6 and above
 CBUILDER1UP     C++Builder 1.0 and above (any C++Builder)
 CBUILDER3UP     C++Builder 3.0 and above
 CBUILDER4UP     C++Builder 4.0 and above
 CBUILDER5UP     C++Builder 5.0 and above
 CBUILDER2006UP	 C++Builder 2006 and above
 CBUILDER2007UP	 C++Builder 2007 and above
 CBUILDER2009UP	 C++Builder 2009 and above
 CBUILDER2010UP	 C++Builder 2010 and above
 CBUILDERXEUP	 C++Builder XE and above
 CBUILDERXE2UP	 C++Builder XE2 and above
 CBUILDERXE3UP	 C++Builder XE3 and above
 CBUILDERXE4UP	 C++Builder XE4 and above
 CBUILDERXE5UP	 C++Builder XE5 and above
 CBUILDERXE6UP	 C++Builder XE6 and above
 CBUILDERXE7UP	 C++Builder XE7 and above
 CBUILDERXE8UP	 C++Builder XE8 and above

 compiler types:

 CBUILDER        any C++Builder
 BORLANDCPP		 any Borland C++

 target platforms compiler types:

 CBUILDER_32BIT  32bit C++Builder


 target platforms

 CONSOLE		 Console mode

 MSWINDOWS       any Windows platform
 WIN16           16bit Windows
 WIN32           32bit Windows

 LINUX           any Linix platform

 Features:
 STDCALL_SUPPORTED	STDCALL calling convention supported
----------------------------------------------------------------------------
*/

// defines for C++Builder 3
#ifdef __BORLANDC__
  #if __BORLANDC__ == 0x0200
    #define BORLANDCPP2
    #define BORLANDCPP2UP
  #endif

  #if __BORLANDC__ == 0x0400
    #define BORLANDCPP3
    #define BORLANDCPP3UP
    #define BORLANDCPP2UP
  #endif

  #if __BORLANDC__ == 0x0410
    #define BORLANDCPP3_1
    #define BORLANDCPP3_1UP
    #define BORLANDCPP3UP
    #define BORLANDCPP2UP
  #endif

  #if __BORLANDC__ == 0x0452
    #define BORLANDCPP4
    #define BORLANDCPP3UP
    #define BORLANDCPP2UP
    #define BORLANDCPP3_1UP
    #define BORLANDCPP4UP
  #endif

  #if __BORLANDC__ >= 0x0500 && __BORLANDC__ < 0x0550
    #define BORLANDCPP5
    #define BORLANDCPP2UP
    #define BORLANDCPP3_1UP
    #define BORLANDCPP3UP
    #define BORLANDCPP4UP
    #define BORLANDCPP5UP
  #endif

  #if __BORLANDC__ >= 0x0550 && __BORLANDC__ < 0x0560
    #define BORLANDCPP5_5
    #define BORLANDCPP5_5UP
    #define BORLANDCPP5UP
    #define BORLANDCPP2UP
    #define BORLANDCPP3_1UP
    #define BORLANDCPP3UP
    #define BORLANDCPP4UP
  #endif

  #if __BORLANDC__ == 0x0562
    #define BORLANDCPP5_6
    #define BORLANDCPP5_6UP
    #define BORLANDCPP5_5UP
    #define BORLANDCPP5UP
    #define BORLANDCPP2UP
    #define BORLANDCPP3_1UP
    #define BORLANDCPP3UP
    #define BORLANDCPP4UP
  #endif

  #if __BORLANDC__ >= 0x0550 && __BORLANDC__ < 0x0560
    #define BORLANDCPP5_5
    #define BORLANDCPP2UP
    #define BORLANDCPP3_1UP
    #define BORLANDCPP3UP
    #define BORLANDCPP4UP
    #define BORLANDCPP5UP
    #define BORLANDCPP5_5UP
  #endif

  #if __BORLANDC__ == 0x0520
    #define CBUILDER1 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0530
    #define CBUILDER3 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0540
    #define CBUILDER4 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0550
    #define CBUILDER5 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0570
    #define CBUILDER2006 1
    #define CBUILDER2006UP 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0590 || __BORLANDC__ == 0x0591 || __BORLANDC__ == 0x0592 || __BORLANDC__ == 0x0593
    #define CBUILDER2007 1
    #define CBUILDER2007UP 1
    #define CBUILDER2006UP 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0610 || __BORLANDC__ == 0x0620 || __BORLANDC__ == 0x0621
    #define CBUILDER2009 1
    #define CBUILDER2009UP 1
    #define CBUILDER2007UP 1
    #define CBUILDER2006UP 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0620 || __BORLANDC__ == 0x0621
    #define CBUILDER2010 1
    #define CBUILDER2010UP 1
    #define CBUILDER2009UP 1
    #define CBUILDER2007UP 1
    #define CBUILDER2006UP 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0630 || __BORLANDC__ == 0x0631
    #define CBUILDERXE 1
    #define CBUILDERXEUP 1
    #define CBUILDER2010UP 1
    #define CBUILDER2009UP 1
    #define CBUILDER2007UP 1
    #define CBUILDER2006UP 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0640
    #define CBUILDERXE2 1
    #define CBUILDERXE2UP 1
    #define CBUILDERXEUP 1
    #define CBUILDER2010UP 1
    #define CBUILDER2009UP 1
    #define CBUILDER2007UP 1
    #define CBUILDER2006UP 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0650 || __BORLANDC__ == 0x0651
    #define CBUILDERXE3 1
    #define CBUILDERXE3UP 1
    #define CBUILDERXE2UP 1
    #define CBUILDERXEUP 1
    #define CBUILDER2010UP 1
    #define CBUILDER2009UP 1
    #define CBUILDER2007UP 1
    #define CBUILDER2006UP 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0660
    #define CBUILDERXE4 1
    #define CBUILDERXE4UP 1
    #define CBUILDERXE3UP 1
    #define CBUILDERXE2UP 1
    #define CBUILDERXEUP 1
    #define CBUILDER2010UP 1
    #define CBUILDER2009UP 1
    #define CBUILDER2007UP 1
    #define CBUILDER2006UP 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0670
    #define CBUILDERXE5 1
    #define CBUILDERXE5UP 1
    #define CBUILDERXE4UP 1
    #define CBUILDERXE3UP 1
    #define CBUILDERXE2UP 1
    #define CBUILDERXEUP 1
    #define CBUILDER2010UP 1
    #define CBUILDER2009UP 1
    #define CBUILDER2007UP 1
    #define CBUILDER2006UP 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0680
    #define CBUILDERXE6 1
    #define CBUILDERXE6UP 1
    #define CBUILDERXE5UP 1
    #define CBUILDERXE4UP 1
    #define CBUILDERXE3UP 1
    #define CBUILDERXE2UP 1
    #define CBUILDERXEUP 1
    #define CBUILDER2010UP 1
    #define CBUILDER2009UP 1
    #define CBUILDER2007UP 1
    #define CBUILDER2006UP 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0690
    #define CBUILDERXE7 1
    #define CBUILDERXE7UP 1
    #define CBUILDERXE6UP 1
    #define CBUILDERXE5UP 1
    #define CBUILDERXE4UP 1
    #define CBUILDERXE3UP 1
    #define CBUILDERXE2UP 1
    #define CBUILDERXEUP 1
    #define CBUILDER2010UP 1
    #define CBUILDER2009UP 1
    #define CBUILDER2007UP 1
    #define CBUILDER2006UP 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0700
    #define CBUILDERXE8 1
    #define CBUILDERXE8UP 1
    #define CBUILDERXE7UP 1
    #define CBUILDERXE6UP 1
    #define CBUILDERXE5UP 1
    #define CBUILDERXE4UP 1
    #define CBUILDERXE3UP 1
    #define CBUILDERXE2UP 1
    #define CBUILDERXEUP 1
    #define CBUILDER2010UP 1
    #define CBUILDER2009UP 1
    #define CBUILDER2007UP 1
    #define CBUILDER2006UP 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif

  #if __BORLANDC__ == 0x0710 || __BORLANDC__ == 0x0711
    #define CBUILDERSEATTLE 1
    #define CBUILDERSEATTLEUP 1
    #define CBUILDERXE8UP 1
    #define CBUILDERXE7UP 1
    #define CBUILDERXE6UP 1
    #define CBUILDERXE5UP 1
    #define CBUILDERXE4UP 1
    #define CBUILDERXE3UP 1
    #define CBUILDERXE2UP 1
    #define CBUILDERXEUP 1
    #define CBUILDER2010UP 1
    #define CBUILDER2009UP 1
    #define CBUILDER2007UP 1
    #define CBUILDER2006UP 1
    #define CBUILDER5UP 1
    #define CBUILDER4UP 1
    #define CBUILDER3UP 1
    #define CBUILDER1UP 1
  #endif
#endif

#ifdef CBUILDER1UP
  #define CBUILDER
  #define BORLANDCPP_OR_BUILDER
#endif

#if BORLANDCPP2UP
  #define BORLANDCPP
  #define BORLANDCPP_OR_BUILDER
#endif

// Other...
/*
#ifdef WIN32
  #define  MSWINDOWS 1
  #define  _32BIT 1
#endif

#ifdef WIN64
  #define  MSWINDOWS 1
  #define  _64BIT 1
#endif

#ifdef LINUX
  #define  _32BIT 1
  #define  LINUX32 1
  #define  UNIX 1
#endif

#ifdef MSDOS
  #define  MSDOS_OR_DPMI 1
#endif
#ifdef DPMI
  #define  MSDOS_OR_DPMI 1
#endif
*/

// Operating system...
#ifdef __WIN32__
  #define WIN32
#endif
#ifdef _WIN64
  #define WIN64
#endif
#ifdef __CONSOLE__
  #define CONSOLE
  #define MSWINDOWS
#else
  #ifdef _Windows
     #define WINDOWS
     #define MSWINDOWS
  #endif
  #ifdef WIN32
    #define WINDOWS
    #define MSWINDOWS
  #endif
  #ifdef WIN64
    #define WINDOWS
    #define MSWINDOWS
  #endif
#endif
#ifdef WINDOWS
  #define WINDOWS_OR_CONSOLE
#endif
#ifdef CONSOLE
  #define WINDOWS_OR_CONSOLE
#endif
#ifdef WIN32
  #define _32BIT
#endif
#ifdef WIN64
  #define _64BIT
#endif
#ifdef __FLAT__
  #define _32BIT
#endif
#ifdef _STDCALL_SUPPORTED
  #define STDCALL_SUPPORTED
#endif
#ifdef _32BIT
  #ifdef CBUILDER
    #define CBUILDER_32BIT
  #endif
#endif
#ifdef __ANDROID__
  #define ANDROID
#endif
#ifdef __APPLE__
  #define APPLE
#endif
#ifdef __arm__
  #define ARM
#endif
#ifdef __arm64__
  #define ARM
  #define _64BIT
#endif
#ifdef __MACH__
  #define MACOSX
#endif
#ifdef __linux__
  #define LINUX
#endif
#ifdef __MINGW32__
  #define MINGW
  #define _32BIT
#endif
#ifdef __MINGW64__
  #define MINGW
  #define _64BIT
#endif
#ifdef MINGW
  #include <cstdint>
  #include <stdint.h>
  #define int64 int64_t
#endif
#ifndef __BORLANDC__
  #define __int64 int64
#endif
