{
              Program Name : Format
              Package Name : Subroutine Library - Layer 1
              Purpose      : Various Formatting routines
              Institution  : Conroy & Conroy Co.
              Date Written : 05-Jul-1993
              Written By   : EAC
              Version      : 1.0

        Copyright (C) 1993 by Alan Conroy.  Released to the Public Domain.

	TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

             DATE      BY             REASON

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

	  This unit consists of functions to perform various text
	formatting functions.
}

unit Format ;

interface

function Format_String( Source, Fmt : string ) : string ;
function Tab2Space( Count : Integer ; const X : String ) : String ;

{$IFDEF CC_Regression_Test}
procedure Test_Unit ;
{$ENDIF}

implementation

uses { Subroutine Library - Layer 0... }
     _ASCII ; { HT }

function Format_String( Source, Fmt : string ) : string ;

var I, Count : integer ;

begin
//NOTE: THIS FUNCTION IS INCOMPLETE AND WILL CHANGE IN THE FUTURE
    I := length( Source ) ;
    while( ( I > 0 ) and ( Source[ I ] = ' ' ) ) do
    begin
        dec( I ) ;
    end ;
    if( I = 0 ) then
    begin
        exit ;
    end ;
    Count := 0 ;
    while( ( I > 0 ) and ( Source[ I ] = ' ' ) ) do
    begin
        inc( Count ) ;
        if( Count = 3 ) then
        begin
            Count := 1 ;
            Source := copy( Source, 1, I ) + ',' + copy( Source, I + 1, length( Source ) ) ;
        end ;
        dec( I ) ;
    end ;
    Result := Source ;
end ;


function Tab2Space( Count : Integer ; const X : String ) : String ;
{ Convert string with tabs to string with appropriate spaces. }

var C, Dummy : Integer ;
    Y : String ; { Place to hold result }

begin
    Y := '' ;
    C := 1 ;
    for Dummy := 1 to Length( X ) do
    begin
	if( X[ Dummy ] = HT ) then { tab }
        begin
            while( C <= Count ) do
            begin
                Y := Y + ' ' ;
                Inc( C ) ;
            end ;
            C := 1 ;
        end else
        begin
            Y := Y + X[ Dummy ] ;
            Inc( C ) ; { Count position within tab region }
            if( C > Count ) then
            begin
                C := 1 ;
            end ;
        end ;
    end ;
    Tab2Space := Y ;
end ;


{$IFDEF CC_Regression_Test}
procedure Test_Unit ;

    procedure Error ;

    begin
        writeln( 'Invalid result' ) ;
        halt ;
    end ;


    procedure Test_Tab2Space ;

    var S : string ;

    begin
        S := Tab2Space( 8, '1234567'#9'9' ) ;
        if( S <> '1234567 9' ) then
        begin
            Error ;
        end ;
        S := Tab2Space( 8, '12345678'#9'9' ) ;
        if( S <> '12345678        9' ) then
        begin
            Error ;
        end ;
        S := Tab2Space( 4, '1234567'#9'9' ) ;
        if( S <> '1234567 9' ) then
        begin
            Error ;
        end ;
        S := Tab2Space( 3, #9'1234567'#9'9' ) ;
        if( S <> '   1234567  9' ) then
        begin
            Error ;
        end ;
        S := Tab2Space( 1, '1234567'#9'9' ) ;
        if( S <> '1234567 9' ) then
        begin
            Error ;
        end ;
    end ;

begin
    Test_Tab2Space ;
end ;
{$ENDIF}

end.
