{
        Program Name : L10N
        Package Name : LB
        Purpose      : Localization for LB
        Institution  : Conroy & Conroy Co.
        Date Written : 23-August-2010
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2010 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This unit provides for localization of the text used in LB.

}

unit L10n ;

interface

uses _Types ;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

function Get_Text( ID : integer ; const Default : AnsiString ) : AnsiString ;
procedure Load_Text( const N : AnsiString ) ;
function Substitute1( const Value, Sub1 : AnsiString ) : AnsiString ;
function Substitute2( const Value, Sub1, Sub2 : AnsiString ) : AnsiString ;
function Substitute3( const Value, Sub1, Sub2, Sub3 : AnsiString ) : AnsiString ;


function Text_Error_Input_File_Does_Not_Exist : AnsiString ;
function Text_Error_While_Opening_Journal_File_Cant_Recover : AnsiString ;
function Text_Error_Allocation_Table_Load_Failure : AnsiString ;
function Text_Error_Execution_Exceeds_ms : AnsiString ;
function Text_Error_Adding_Existing_Object_Or_Failure_To_Delete_Old_Object : AnsiString ;
function Text_Error_Found_Object_Has_Facility_Mismatch : AnsiString ;
function Text_Error_Facility_Out_Of_Range : AnsiString ;
function Text_Error_Removing_Non_Existant_Object : AnsiString ;
function Text_Error_Facility_Mismatch : AnsiString ;
function Text_Press_Enter_To_Continue : AnsiString ;
function Text_Application : AnsiString ;
function Text_Unsigned : AnsiString ;
function Text_Signed : AnsiString ;
function Text_Byte : AnsiString ;
function Text_Word : AnsiString ;
function Text_Longint : AnsiString ;
function Text_Binary : AnsiString ;
function Text_Octal : AnsiString ;
function Text_Decimal : AnsiString ;
function Text_Hexadecimal : AnsiString ;
function Text_Radix_50 : AnsiString ;
function Text_Base_n : AnsiString ;
function Text_Size_Amp : AnsiString ;
function Text_Base_Amp : AnsiString ;
function Text_Binary_Amp : AnsiString ;
function Text_Octal_Amp : AnsiString ;
function Text_Decimal_Amp : AnsiString ;
function Text_Hexadecimal_Amp : AnsiString ;
function Text_Radix_50_Amp : AnsiString ;
function Text_Err_Writing_To_Log_File : AnsiString ;
function Text_Volume_ID_Is : AnsiString ;
function Text_Error_Invalid_Output_Drive : AnsiString ;
function Text_Error_FAT_Is_Too_Big : AnsiString ;
function Text_Initialization_Error_Correct_And_Press_Any_Key_To_Continue : AnsiString ;
function Text_Initialization_Error : AnsiString ;
function Text_Error_Unknown_Command_Or_Invalid_Drive : AnsiString ;
function Text_Error_Bad_Address_Mark : AnsiString ;
function Text_Error_Sector_Not_Found : AnsiString ;
function Text_Error_DMA_Failure : AnsiString ;
function Text_Error_Data_Error_CRC : AnsiString ;
function Text_Error_Controller_Failure : AnsiString ;
function Text_Error_Seek_Failure : AnsiString ;
function Text_Error_Drive_Does_Not_Respond : AnsiString ;
function Text_Error_Drive_Is_Write_Locked : AnsiString ;
function Text_Error_Unknown_Unit : AnsiString ;
function Text_Error_Drive_Not_Ready : AnsiString ;
function Text_Error_Unknown_Command_In_Absolute_Sector_Write : AnsiString ;
function Text_Error_Bad_Request_Structure_Length : AnsiString ;
function Text_Error_Seek_Error : AnsiString ;
function Text_Error_Unknown_Media_Type : AnsiString ;
function Text_Error_Printer_Out_Of_Paper : AnsiString ;
function Text_Error_Write_Fault : AnsiString ;
function Text_Error_Read_Fault : AnsiString ;
function Text_Error_General_Failure : AnsiString ;
function Text_Error_Error_13_In_Absolute_Sector_Write : AnsiString ;
function Text_Error_Error_14_In_Absolute_Sector_Write : AnsiString ;
function Text_Error_Invalid_Disk_Change : AnsiString ;
function Text_Place_Saveset_Volume_Into_Drive_And_Press_Return : AnsiString ;
function Text_Place_Saveset_Volume_Into_Drive : AnsiString ;
function Text_Success : AnsiString ;
function Text_Error_No_Dictionary_Open : AnsiString ;
function Text_Error_Already_Defined : AnsiString ;
function Text_Error_Invalid_Syntax_Type : AnsiString ;
function Text_Error_Not_Defined : AnsiString ;
function Text_Error_Attach_Failed : AnsiString ;
function Text_Error_Detach_Failed : AnsiString ;
function Text_True : AnsiString ;
function Text_False : AnsiString ;
function Text_Error_Invalid_Base : AnsiString ;
function Text_Error_Numeric_Error : AnsiString ;
function Text_Error_Abstract_Method_Called : AnsiString ;
function Text_Other_Ellipse : AnsiString ;
function Text_Signed_Amp : AnsiString ;
function Text_Byte_Amp : AnsiString ;
function Text_Word_Amp : AnsiString ;
function Text_Long_Amp : AnsiString ;
function Text_Quad_Amp : AnsiString ;
function Text_EBCDIC_Amp : AnsiString ;
function Text_Goto_Address_Ellipse : AnsiString ;
function Text_Find_Ellipse : AnsiString ;
function Text_Modify_Ellipse : AnsiString ;
function Text_Month_Jan : AnsiString ;
function Text_Month_Feb : AnsiString ;
function Text_Month_Mar : AnsiString ;
function Text_Month_Apr : AnsiString ;
function Text_Month_May : AnsiString ;
function Text_Month_Jun : AnsiString ;
function Text_Month_Jul : AnsiString ;
function Text_Month_Aug : AnsiString ;
function Text_Month_Sep : AnsiString ;
function Text_Month_Oct : AnsiString ;
function Text_Month_Nov : AnsiString ;
function Text_Month_Dec : AnsiString ;
function Text_Month_January : AnsiString ;
function Text_Month_February : AnsiString ;
function Text_Month_March : AnsiString ;
function Text_Month_April : AnsiString ;
function Text_Month_June : AnsiString ;
function Text_Month_July : AnsiString ;
function Text_Month_August : AnsiString ;
function Text_Month_September : AnsiString ;
function Text_Month_October : AnsiString ;
function Text_Month_November : AnsiString ;
function Text_Month_December : AnsiString ;
function Text_ASCII_Amp : AnsiString ;
function Text_Nothing_Found : AnsiString ;
function Text_Day_Sunday : AnsiString ;
function Text_Day_Monday : AnsiString ;
function Text_Day_Tuesday : AnsiString ;
function Text_Day_Wednesday : AnsiString ;
function Text_Day_Thursday : AnsiString ;
function Text_Day_Friday : AnsiString ;
function Text_Day_Saturday : AnsiString ;
function Text_Application_x : AnsiString ;
function Text_Operating_System_x : AnsiString ;
function Text_There_Is_No_Debugging_Information_Available : AnsiString ;
function Text_Error_Opening_x : AnsiString ;
function Text_Search_String_Not_Found : AnsiString ;
function Text_Caption_Search : AnsiString ;
function Text_Caption_Replace : AnsiString ;
function Text_Replace_This_Instance : AnsiString ;
function Text_Save_Changes_To : AnsiString ;
function Text_Noname : AnsiString ;
function Text_Unknown_Error_Code : AnsiString ;
function Text_Facility_n_Error_n : AnsiString ;
function Text_Error_Severity_Success : AnsiString ;
function Text_Error_Severity_Notification : AnsiString ;
function Text_Error_Severity_Warning : AnsiString ;
function Text_Error_Severity_Error : AnsiString ;
function Text_Error_Severity_Fatal : AnsiString ;
function Text_DOS_Error_Success : AnsiString ;
function Text_DOS_Error_1 : AnsiString ;
function Text_DOS_Error_2 : AnsiString ;
function Text_DOS_Error_3 : AnsiString ;
function Text_DOS_Error_4 : AnsiString ;
function Text_DOS_Error_5 : AnsiString ;
function Text_DOS_Error_6 : AnsiString ;
function Text_DOS_Error_7 : AnsiString ;
function Text_DOS_Error_8 : AnsiString ;
function Text_DOS_Error_9 : AnsiString ;
function Text_DOS_Error_10 : AnsiString ;
function Text_DOS_Error_11 : AnsiString ;
function Text_DOS_Error_12 : AnsiString ;
function Text_DOS_Error_13 : AnsiString ;
function Text_DOS_Error_14 : AnsiString ;
function Text_DOS_Error_15 : AnsiString ;
function Text_DOS_Error_16 : AnsiString ;
function Text_DOS_Error_17 : AnsiString ;
function Text_DOS_Error_18 : AnsiString ;
function Text_DOS_Error_19 : AnsiString ;
function Text_DOS_Error_20 : AnsiString ;
function Text_DOS_Error_21 : AnsiString ;
function Text_DOS_Error_22 : AnsiString ;
function Text_DOS_Error_23 : AnsiString ;
function Text_DOS_Error_24 : AnsiString ;
function Text_DOS_Error_25 : AnsiString ;
function Text_DOS_Error_26 : AnsiString ;
function Text_DOS_Error_27 : AnsiString ;
function Text_DOS_Error_28 : AnsiString ;
function Text_DOS_Error_29 : AnsiString ;
function Text_DOS_Error_30 : AnsiString ;
function Text_DOS_Error_31 : AnsiString ;
function Text_DOS_Error_32 : AnsiString ;
function Text_DOS_Error_33 : AnsiString ;
function Text_DOS_Error_34 : AnsiString ;
function Text_DOS_Error_35 : AnsiString ;
function Text_DOS_Error_36 : AnsiString ;
function Text_DOS_Error_38 : AnsiString ;
function Text_DOS_Error_50 : AnsiString ;
function Text_DOS_Error_51 : AnsiString ;
function Text_DOS_Error_52 : AnsiString ;
function Text_DOS_Error_53 : AnsiString ;
function Text_DOS_Error_54 : AnsiString ;
function Text_DOS_Error_55 : AnsiString ;
function Text_DOS_Error_56 : AnsiString ;
function Text_DOS_Error_57 : AnsiString ;
function Text_DOS_Error_58 : AnsiString ;
function Text_DOS_Error_59 : AnsiString ;
function Text_DOS_Error_60 : AnsiString ;
function Text_DOS_Error_61 : AnsiString ;
function Text_DOS_Error_62 : AnsiString ;
function Text_DOS_Error_63 : AnsiString ;
function Text_DOS_Error_64 : AnsiString ;
function Text_DOS_Error_65 : AnsiString ;
function Text_DOS_Error_66 : AnsiString ;
function Text_DOS_Error_67 : AnsiString ;
function Text_DOS_Error_68 : AnsiString ;
function Text_DOS_Error_69 : AnsiString ;
function Text_DOS_Error_70 : AnsiString ;
function Text_DOS_Error_71 : AnsiString ;
function Text_DOS_Error_72 : AnsiString ;
function Text_DOS_Error_80 : AnsiString ;
function Text_DOS_Error_81 : AnsiString ;
function Text_DOS_Error_82 : AnsiString ;
function Text_DOS_Error_83 : AnsiString ;
function Text_DOS_Error_84 : AnsiString ;
function Text_DOS_Error_85 : AnsiString ;
function Text_DOS_Error_86 : AnsiString ;
function Text_DOS_Error_87 : AnsiString ;
function Text_DOS_Error_88 : AnsiString ;
function Text_DOS_Error_89 : AnsiString ;
function Text_DOS_Error_90 : AnsiString ;
function Text_DOS_Error_91 : AnsiString ;
function Text_DOS_Error_92 : AnsiString ;
function Text_DOS_Error_93 : AnsiString ;
function Text_DOS_Error_95 : AnsiString ;
function Text_DOS_Error_100 : AnsiString ;
function Text_DOS_Error_101 : AnsiString ;
function Text_DOS_Error_102 : AnsiString ;
function Text_DOS_Error_103 : AnsiString ;
function Text_DOS_Error_104 : AnsiString ;
function Text_DOS_Error_105 : AnsiString ;
function Text_DOS_Error_106 : AnsiString ;
function Text_DOS_Error_107 : AnsiString ;
function Text_DOS_Error_108 : AnsiString ;
function Text_DOS_Error_109 : AnsiString ;
function Text_DOS_Error_110 : AnsiString ;
function Text_DOS_Error_111 : AnsiString ;
function Text_DOS_Error_112 : AnsiString ;
function Text_DOS_Error_113 : AnsiString ;
function Text_DOS_Error_114 : AnsiString ;
function Text_DOS_Error_115 : AnsiString ;
function Text_DOS_Error_116 : AnsiString ;
function Text_DOS_Error_117 : AnsiString ;
function Text_DOS_Error_118 : AnsiString ;
function Text_DOS_Error_119 : AnsiString ;
function Text_DOS_Error_120 : AnsiString ;
function Text_DOS_Error_121 : AnsiString ;
function Text_DOS_Error_122 : AnsiString ;
function Text_DOS_Error_123 : AnsiString ;
function Text_DOS_Error_124 : AnsiString ;
function Text_DOS_Error_125 : AnsiString ;
function Text_DOS_Error_126 : AnsiString ;
function Text_DOS_Error_127 : AnsiString ;
function Text_DOS_Error_128 : AnsiString ;
function Text_DOS_Error_129 : AnsiString ;
function Text_DOS_Error_130 : AnsiString ;
function Text_DOS_Error_131 : AnsiString ;
function Text_DOS_Error_132 : AnsiString ;
function Text_DOS_Error_133 : AnsiString ;
function Text_DOS_Error_134 : AnsiString ;
function Text_DOS_Error_135 : AnsiString ;
function Text_DOS_Error_136 : AnsiString ;
function Text_DOS_Error_137 : AnsiString ;
function Text_DOS_Error_138 : AnsiString ;
function Text_DOS_Error_139 : AnsiString ;
function Text_DOS_Error_140 : AnsiString ;
function Text_DOS_Error_141 : AnsiString ;
function Text_DOS_Error_142 : AnsiString ;
function Text_DOS_Error_143 : AnsiString ;
function Text_DOS_Error_144 : AnsiString ;
function Text_DOS_Error_145 : AnsiString ;
function Text_DOS_Error_146 : AnsiString ;
function Text_DOS_Error_147 : AnsiString ;
function Text_DOS_Error_148 : AnsiString ;
function Text_DOS_Error_149 : AnsiString ;
function Text_DOS_Error_150 : AnsiString ;
function Text_DOS_Error_151 : AnsiString ;
function Text_DOS_Error_152 : AnsiString ;
function Text_DOS_Error_153 : AnsiString ;
function Text_DOS_Error_154 : AnsiString ;
function Text_DOS_Error_155 : AnsiString ;
function Text_DOS_Error_156 : AnsiString ;
function Text_DOS_Error_157 : AnsiString ;
function Text_DOS_Error_158 : AnsiString ;
function Text_DOS_Error_159 : AnsiString ;
function Text_DOS_Error_160 : AnsiString ;
function Text_DOS_Error_161 : AnsiString ;
function Text_DOS_Error_162 : AnsiString ;
function Text_DOS_Error_163 : AnsiString ;
function Text_DOS_Error_164 : AnsiString ;
function Text_DOS_Error_165 : AnsiString ;
function Text_DOS_Error_180 : AnsiString ;
function Text_DOS_Error_181 : AnsiString ;
function Text_DOS_Error_182 : AnsiString ;
function Text_DOS_Error_183 : AnsiString ;
function Text_DOS_Error_184 : AnsiString ;
function Text_DOS_Error_185 : AnsiString ;
function Text_DOS_Error_186 : AnsiString ;
function Text_DOS_Error_187 : AnsiString ;
function Text_DOS_Error_188 : AnsiString ;
function Text_DOS_Error_189 : AnsiString ;
function Text_DOS_Error_190 : AnsiString ;
function Text_DOS_Error_191 : AnsiString ;
function Text_DOS_Error_192 : AnsiString ;
function Text_DOS_Error_193 : AnsiString ;
function Text_DOS_Error_194 : AnsiString ;
function Text_DOS_Error_195 : AnsiString ;
function Text_DOS_Error_196 : AnsiString ;
function Text_DOS_Error_197 : AnsiString ;
function Text_DOS_Error_198 : AnsiString ;
function Text_DOS_Error_199 : AnsiString ;
function Text_DOS_Error_200 : AnsiString ;
function Text_DOS_Error_201 : AnsiString ;
function Text_DOS_Error_202 : AnsiString ;
function Text_DOS_Error_203 : AnsiString ;
function Text_DOS_Error_204 : AnsiString ;
function Text_DOS_Error_205 : AnsiString ;
function Text_DOS_Error_206 : AnsiString ;
function Text_DOS_Error_207 : AnsiString ;
function Text_DOS_Error_208 : AnsiString ;
function Text_DOS_Error_209 : AnsiString ;
function Text_DOS_Error_210 : AnsiString ;
function Text_DOS_Error_211 : AnsiString ;
function Text_DOS_Error_212 : AnsiString ;
function Text_DOS_Error_213 : AnsiString ;
function Text_DOS_Error_214 : AnsiString ;
function Text_DOS_Error_215 : AnsiString ;
function Text_DOS_Error_216 : AnsiString ;
function Text_DOS_Error_600 : AnsiString ;
function Text_DOS_Error_601 : AnsiString ;
function Text_DOS_Error_602 : AnsiString ;
function Text_DOS_Error_603 : AnsiString ;
function Text_DOS_Error_604 : AnsiString ;
function Text_DOS_Error_605 : AnsiString ;
function Text_DOS_Error_606 : AnsiString ;
function Text_DOS_Error_607 : AnsiString ;
function Text_DOS_Error_608 : AnsiString ;
function Text_DOS_Error_609 : AnsiString ;
function Text_DOS_Error_610 : AnsiString ;
function Text_DOS_Error_611 : AnsiString ;
function Text_DOS_Error_612 : AnsiString ;
function Text_DOS_Error_613 : AnsiString ;
function Text_DOS_Error_614 : AnsiString ;
function Text_DOS_Error_615 : AnsiString ;
function Text_DOS_Error_616 : AnsiString ;
function Text_DOS_Error_617 : AnsiString ;
function Text_DOS_Error_618 : AnsiString ;
function Text_DOS_Error_619 : AnsiString ;
function Text_DOS_Error_620 : AnsiString ;
function Text_DOS_Error_621 : AnsiString ;
function Text_DOS_Error_622 : AnsiString ;
function Text_DOS_Error_623 : AnsiString ;
function Text_DOS_Error_624 : AnsiString ;
function Text_DOS_Error_625 : AnsiString ;
function Text_DOS_Error_626 : AnsiString ;
function Text_DOS_Error_627 : AnsiString ;
function Text_DOS_Error_628 : AnsiString ;
function Text_DOS_Error_629 : AnsiString ;
function Text_DOS_Error_630 : AnsiString ;
function Text_DOS_Error_631 : AnsiString ;
function Text_DOS_Error_632 : AnsiString ;
function Text_DOS_Error_633 : AnsiString ;
function Text_DOS_Error_634 : AnsiString ;
function Text_DOS_Error_635 : AnsiString ;
function Text_DOS_Error_636 : AnsiString ;
function Text_DOS_Error_637 : AnsiString ;
function Text_DOS_Error_638 : AnsiString ;
function Text_DOS_Error_639 : AnsiString ;
function Text_DOS_Error_640 : AnsiString ;
function Text_DOS_Error_641 : AnsiString ;
function Text_DOS_Error_642 : AnsiString ;
function Text_DOS_Error_643 : AnsiString ;
function Text_DOS_Error_644 : AnsiString ;
function Text_DOS_Error_645 : AnsiString ;
function Text_DOS_Error_646 : AnsiString ;
function Text_DOS_Error_647 : AnsiString ;
function Text_DOS_Error_648 : AnsiString ;
function Text_DOS_Error_649 : AnsiString ;
function Text_DOS_Error_650 : AnsiString ;
function Text_DOS_Error_651 : AnsiString ;
function Text_DOS_Error_652 : AnsiString ;
function Text_DOS_Error_653 : AnsiString ;
function Text_DOS_Error_654 : AnsiString ;
function Text_DOS_Error_655 : AnsiString ;
function Text_DOS_Error_656 : AnsiString ;
function Text_DOS_Error_657 : AnsiString ;
function Text_DOS_Error_658 : AnsiString ;
function Text_DOS_Error_659 : AnsiString ;
function Text_DOS_Error_660 : AnsiString ;
function Text_DOS_Error_661 : AnsiString ;
function Text_DOS_Error_662 : AnsiString ;
function Text_DOS_Error_663 : AnsiString ;
function Text_DOS_Error_664 : AnsiString ;
function Text_DOS_Error_665 : AnsiString ;
function Text_DOS_Error_666 : AnsiString ;
function Text_DOS_Error_667 : AnsiString ;
function Text_DOS_Error_668 : AnsiString ;
function Text_DOS_Error_669 : AnsiString ;
function Text_DOS_Error_670 : AnsiString ;
function Text_DOS_Error_671 : AnsiString ;
function Text_DOS_Error_672 : AnsiString ;
function Text_DOS_Error_673 : AnsiString ;
function Text_DOS_Error_674 : AnsiString ;
function Text_DOS_Error_675 : AnsiString ;
function Text_DOS_Error_676 : AnsiString ;
function Text_DOS_Error_677 : AnsiString ;
function Text_DOS_Error_678 : AnsiString ;
function Text_DOS_Error_679 : AnsiString ;
function Text_DOS_Error_680 : AnsiString ;
function Text_DOS_Error_681 : AnsiString ;
function Text_DOS_Error_682 : AnsiString ;
function Text_DOS_Error_683 : AnsiString ;
function Text_DOS_Error_684 : AnsiString ;
function Text_DOS_Error_685 : AnsiString ;
function Text_DOS_Error_686 : AnsiString ;
function Text_DOS_Error_687 : AnsiString ;
function Text_DOS_Error_688 : AnsiString ;
function Text_DOS_Error_689 : AnsiString ;
function Text_DOS_Error_690 : AnsiString ;
function Text_DOS_Error_691 : AnsiString ;
function Text_DOS_Error_692 : AnsiString ;
function Text_DOS_Error_693 : AnsiString ;
function Text_DOS_Error_694 : AnsiString ;
function Text_DOS_Error_695 : AnsiString ;
function Text_DOS_Error_696 : AnsiString ;
function Text_DOS_Error_697 : AnsiString ;
function Text_DOS_Error_698 : AnsiString ;
function Text_DOS_Error_699 : AnsiString ;
function Text_DOS_Error_700 : AnsiString ;
function Text_DOS_Error_701 : AnsiString ;
function Text_DOS_Error_702 : AnsiString ;
function Text_DOS_Error_703 : AnsiString ;
function Text_DOS_Error_704 : AnsiString ;
function Text_DOS_Error_705 : AnsiString ;
function Text_DOS_Error_706 : AnsiString ;
function Text_DOS_Error_707 : AnsiString ;
function Text_DOS_Error_708 : AnsiString ;
function Text_DOS_Error_709 : AnsiString ;
function Text_DOS_Error_710 : AnsiString ;
function Text_DOS_Error_711 : AnsiString ;
function Text_DOS_Error_712 : AnsiString ;
function Text_DOS_Error_713 : AnsiString ;
function Text_DOS_Error_714 : AnsiString ;
function Text_DOS_Error_715 : AnsiString ;
function Text_DOS_Error_716 : AnsiString ;
function Text_DOS_Error_717 : AnsiString ;
function Text_DOS_Error_718 : AnsiString ;
function Text_DOS_Error_719 : AnsiString ;
function Text_DOS_Error_720 : AnsiString ;
function Text_DOS_Error_721 : AnsiString ;
function Text_DOS_Error_722 : AnsiString ;
function Text_DOS_Error_723 : AnsiString ;
function Text_DOS_Error_724 : AnsiString ;
function Text_DOS_Error_725 : AnsiString ;
function Text_DOS_Error_726 : AnsiString ;
function Text_DOS_Error_727 : AnsiString ;
function Text_DOS_Error_728 : AnsiString ;
function Text_DOS_Error_729 : AnsiString ;
function Text_DOS_Error_730 : AnsiString ;
function Text_DOS_Error_731 : AnsiString ;
function Text_DOS_Error_732 : AnsiString ;
function Text_DOS_Error_733 : AnsiString ;
function Text_DOS_Error_734 : AnsiString ;
function Text_DOS_Error_735 : AnsiString ;
function Text_DOS_Error_736 : AnsiString ;
function Text_DOS_Error_737 : AnsiString ;
function Text_DOS_Error_738 : AnsiString ;
function Text_DOS_Error_739 : AnsiString ;
function Text_DOS_Error_740 : AnsiString ;
function Text_DOS_Error_741 : AnsiString ;
function Text_DOS_Error_742 : AnsiString ;
function Text_DOS_Error_743 : AnsiString ;
function Text_DOS_Error_744 : AnsiString ;
function Text_DOS_Error_752 : AnsiString ;
function Text_Error_Unused_Error_Number : AnsiString ;
function Text_Express_Error_Expected_Comma : AnsiString ;
function Text_Express_Error_Syntax_Error : AnsiString ;
function Text_Express_Error_Illegal_Symbol : AnsiString ;
function Text_Express_Error_Expected_Left_Parenthesis : AnsiString ;
function Text_Express_Error_Division_By_Zero : AnsiString ;
function Text_Express_Error_Illegal_Number_for_factorial : AnsiString ;
function Text_Express_Error_Floating_point_error : AnsiString ;
function Text_Express_Error_Illegal_Number : AnsiString ;
function Text_Express_Error_Illegal_Argument : AnsiString ;
function Text_Express_Error_Imaginary_Number : AnsiString ;
function Text_Express_Error_Illegal_Argument_in_LOG : AnsiString ;
function Text_Express_Error_Argument_Too_large_in_EXP : AnsiString ;
function Text_Express_Error_Missing_Right_Parenthesis : AnsiString ;
function Text_Error_Invalid_Key_Size : AnsiString ;
function Text_Files_Unit_Was_Not_Compiled_Correctly : AnsiString ;
function Text_Error_FiP_Is_A_Singleton_Object : AnsiString ;
function Text_Prompt_Enter_A_Filename : AnsiString ;
function Text_Error_Filesys_Unit_Was_Not_Compiled_Correctly : AnsiString ;
function Text_Error_Invalid_Syntax : AnsiString ;
function Text_Error_Object_Is_Missing_A_Name : AnsiString ;
function Text_Error_Expected_Colon : AnsiString ;
function Text_Error_Object_Is_Missing_Type : AnsiString ;
function Text_Error_Expected_Equal : AnsiString ;
function Text_FSErr_FileNotOpen : AnsiString ;
function Text_FSErr_EndOfFile : AnsiString ;
function Text_FSErr_FileNotFound : AnsiString ;
function Text_FSErr_FileNameLength : AnsiString ;
function Text_FSErr_FileName : AnsiString ;
function Text_FSErr_DirectoryNotFound : AnsiString ;
function Text_FSErr_InvalidPath : AnsiString ;
function Text_FSErr_NoRoomOnDevice : AnsiString ;
function Text_FSErr_ProtectionViolation : AnsiString ;
function Text_FSErr_DirectoryExists : AnsiString ;
function Text_FSErr_FileNotEmpty : AnsiString ;
function Text_FSErr_DirectoryNotEmpty : AnsiString ;
function Text_FSErr_CorruptedFileStructure : AnsiString ;
function Text_FSErr_FileExists : AnsiString ;
function Text_FSErr_IllegalOperationType : AnsiString ;
function Text_FSErr_LineTooLong : AnsiString ;
function Text_FSErr_InvalidDevice : AnsiString ;
function Text_FSErr_Internal_Duplicate : AnsiString ;
function Text_FSErr_Invalid_Open_Mode : AnsiString ;
function Text_FSErr_Unsupported_Operation : AnsiString ;
function Text_FSErr_Device_In_Use : AnsiString ;
function Text_FSErr_Unknown_Device_Type : AnsiString ;
function Text_FSErr_Internal_Error_On_Add : AnsiString ;
function Text_FSErr_Invalid_Record_Size : AnsiString ;
function Text_FSErr_Internal_Corruption : AnsiString ;
function Text_FSErr_Timeout : AnsiString ;
function Text_FSErr_Invalid_Handle : AnsiString ;
function Text_FSErr_Data_Format_Error : AnsiString ;
function Text_FSErr_Read_Only : AnsiString ;
function Text_FHErr_No_Room_On_Device : AnsiString ;
function Text_FHErr_Corrupted_File_Structure : AnsiString ;
function Text_FHErr_Invalid_Pointer_Operation : AnsiString ;
function Text_FHErr_Deallocation_Error : AnsiString ;
function Text_FHErr_Size_Mismatch : AnsiString ;
function Text_FHErr_Read_Out_Of_Range : AnsiString ;
function Text_FHErr_Read_Size_Error : AnsiString ;
function Text_FHErr_Write_Out_Of_Range : AnsiString ;
function Text_FHErr_Write_Size_Error : AnsiString ;
function Text_FHErr_Bad_Minimum : AnsiString ;
function Text_Error_Heap_Deallocation_Error : AnsiString ;
function Text_Error_Heap_Access_Error : AnsiString ;
function Text_Error_Illegal_Resolution_Size : AnsiString ;
function Text_Error_Invalid_Address : AnsiString ;
function Text_Prompt_Press_Any_Key_To_Continue : AnsiString ;
function Text_Further_Help_Is_Available_On : AnsiString ;
function Text_Sorry_No_Help_For_x_Found_At_This_Level : AnsiString ;
function Text_Warning_Nesting_Exceeds_40_Levels : AnsiString ;
function Text_Prompt_Topic : AnsiString ;
function Text_Error_Help_Not_Available : AnsiString ;
function Text_Error_HTML_No_Content : AnsiString ;
function Text_Error_HTML_Moved_Permanently : AnsiString ;
function Text_Error_HTML_Moved_Temporarily : AnsiString ;
function Text_Error_HTML_Bad_Request : AnsiString ;
function Text_Error_HTML_Unauthorized : AnsiString ;
function Text_Error_HTML_Payment_Required : AnsiString ;
function Text_Error_HTML_Forbidden : AnsiString ;
function Text_Error_HTML_Not_Found : AnsiString ;
function Text_Error_HTML_Method_Not_Allowed : AnsiString ;
function Text_Error_HTML_Proxy_Authentication_Required : AnsiString ;
function Text_Error_HTML_Request_Timeout : AnsiString ;
function Text_Error_HTML_Conflict : AnsiString ;
function Text_Error_HTML_Gone : AnsiString ;
function Text_Error_HTML_Bad_Gateway : AnsiString ;
function Text_Error_HTML_Service_Unavailable : AnsiString ;
function Text_Error_HTML_Gateway_Timeout : AnsiString ;
function Text_LibErr_Invalid_Library_File_Format : AnsiString ;
function Text_LibErr_Module_Not_Found : AnsiString ;
function Text_LibErr_Module_Already_Exists : AnsiString ;
function Text_LibErr_Illegal_Module_Format : AnsiString ;
function Text_Error_Imaginary_Number : AnsiString ;
function Text_Error_Store_Overwrite : AnsiString ;
function Text_Keystroke_Abort : AnsiString ;
function Text_Keystroke_Cancel : AnsiString ;
function Text_Keystroke_Ignore : AnsiString ;
function Text_Keystroke_No : AnsiString ;
function Text_Keystroke_OK : AnsiString ;
function Text_Keystroke_Retry : AnsiString ;
function Text_Keystroke_Yes : AnsiString ;
function Text_Prompt_Abort : AnsiString ;
function Text_Prompt_Cancel : AnsiString ;
function Text_Prompt_Ignore : AnsiString ;
function Text_Prompt_No : AnsiString ;
function Text_Prompt_OK : AnsiString ;
function Text_Prompt_Retry : AnsiString ;
function Text_Prompt_Yes : AnsiString ;
function Text_Prompt_Attempt_To_Delete_Alarm_For_Software_Configuration_Key : AnsiString ;
function Text_Prompt_Attempt_To_Delete_Software_Configuration_Key : AnsiString ;
function Text_Prompt_Attempt_To_Change_Alarm_For_Software_Configuration_Key : AnsiString ;
function Text_Prompt_Attempt_To_Change_Software_Configuration_Key : AnsiString ;
function Text_Prompt_Attempt_To_Read_Software_Configuration_Key : AnsiString ;
function Text_Error_SMU_Error : AnsiString ;
function Text_Error_Too_Many_Windows : AnsiString ;
function Text_Error_Window_Too_Large : AnsiString ;
function Text_Warning_Window_Collision : AnsiString ;
function Text_Pascal_Err_String_100 : AnsiString ;
function Text_Pascal_Err_String_101 : AnsiString ;
function Text_Pascal_Err_String_102 : AnsiString ;
function Text_Pascal_Err_String_103 : AnsiString ;
function Text_Pascal_Err_String_104 : AnsiString ;
function Text_Pascal_Err_String_105 : AnsiString ;
function Text_Pascal_Err_String_106 : AnsiString ;
function Text_Pascal_Err_String_162 : AnsiString ;
function Text_Pascal_Err_String_200 : AnsiString ;
function Text_Pascal_Err_String_201 : AnsiString ;
function Text_Pascal_Err_String_202 : AnsiString ;
function Text_Pascal_Err_String_203 : AnsiString ;
function Text_Pascal_Err_String_204 : AnsiString ;
function Text_Pascal_Err_String_205 : AnsiString ;
function Text_Pascal_Err_String_206 : AnsiString ;
function Text_Pascal_Err_String_207 : AnsiString ;
function Text_Pascal_Err_String_208 : AnsiString ;
function Text_Pascal_Err_String_209 : AnsiString ;
function Text_Pascal_Err_String_210 : AnsiString ;
function Text_Pascal_Err_String_211 : AnsiString ;
function Text_Pascal_Err_String_212 : AnsiString ;
function Text_Pascal_Err_String_213 : AnsiString ;
function Text_Pascal_Err_String_214 : AnsiString ;
function Text_Pascal_Err_String_215 : AnsiString ;
function Text_Pascal_Err_String_216 : AnsiString ;
function Text_Pascal_Err_String_217 : AnsiString ;
function Text_Pascal_Err_String_218 : AnsiString ;
function Text_Pascal_Err_String_219 : AnsiString ;
function Text_Pascal_Err_String_220 : AnsiString ;
function Text_Pascal_Err_String_221 : AnsiString ;
function Text_Pascal_Err_String_222 : AnsiString ;
function Text_Pascal_Err_String_223 : AnsiString ;
function Text_Pascal_Err_String_224 : AnsiString ;
function Text_Pascal_Err_String_225 : AnsiString ;
function Text_Pascal_Err_String_226 : AnsiString ;
function Text_Pascal_Err_String_227 : AnsiString ;
function Text_Pascal_Err_String_228 : AnsiString ;
function Text_Pascal_Err_String_229 : AnsiString ;
function Text_Pascal_Err_String_230 : AnsiString ;
function Text_Pascal_Err_String_231 : AnsiString ;
function Text_Pascal_Err_String_232 : AnsiString ;
function Text_Error_Invalid_List_Index : AnsiString ;
function Text_SHErr_No_Room_On_Device : AnsiString ;
function Text_SHErr_Corrupted_File_Structure : AnsiString ;
function Text_SHErr_Invalid_Pointer_Operation : AnsiString ;
function Text_SHErr_Deallocation_Error : AnsiString ;
function Text_SHErr_Size_Mismatch : AnsiString ;
function Text_SHErr_Read_Out_Of_Range : AnsiString ;
function Text_SHErr_Read_Size_Error : AnsiString ;
function Text_SHErr_Write_Out_Of_Range : AnsiString ;
function Text_SHErr_Write_Size_Error : AnsiString ;
function Text_SHErr_Bad_Minimum : AnsiString ;
function Text_Template_Illegally_Referenced : AnsiString ;
function Text_Object_Cannot_Call_Routine : AnsiString ;
function Text_Objects_In_Arrays_Must_Be_Size_4 : AnsiString ;
function Text_Maximum_Size_Of_Array_Object_Data_Exceeded : AnsiString ;
function Text_Error_Subscript_Out_Of_Range_In : AnsiString ;
function Text_Error_Static_Array_Is_Invalid : AnsiString ;
function Text_Error_Maximum_EMS_Array_Element_Size_Is_16384 : AnsiString ;
function Text_Error_Expanded_Memory_Device_Not_Responding : AnsiString ;
function Text_Error_Expanded_Memory_Device_Not_Present : AnsiString ;
function Text_Error_Incompatible_Version_Of_Expanded_Memory_Driver : AnsiString ;
function Text_Error_Requested_Array_Size_Is_Zero_Pages : AnsiString ;
function Text_Error_Insufficient_Expanded_Memory_Available_For_Array : AnsiString ;
function Text_Error_Static_EMS_Array_Is_Invalid : AnsiString ;
function Text_Error_Maximum_Stack_Size_Is_Exceeded : AnsiString ;
function Text_Stack_Overflow_In : AnsiString ;
function Text_Error_Stack_Is_Empty_In : AnsiString ;
function Text_Error_Dynamic_Array_Is_Invalid : AnsiString ;
function Text_Error_Maximum_Dynamic_Stack_Size_Is_Exceeded : AnsiString ;
function Text_Error_While_Opening_Virtual_Array_Image_File : AnsiString ;
function Text_Error_Virtual_Array_Is_Invalid : AnsiString ;
function Text_Error_Maximum_Virtual_Stack_Size_Is_Exceeded : AnsiString ;
function Text_Error_Maximum_Size_Of_List_Object_Data_Is_Exceeded : AnsiString ;
function Text_Error_Objects_In_Lists_Must_Be_Size_4 : AnsiString ;
function Text_Error_End_Of_List_In : AnsiString ;
function Text_Error_No_Context_In : AnsiString ;
function Text_Error_Beginning_Of_List_In : AnsiString ;
function Text_Error_Empty_List_In : AnsiString ;
function Text_Error_Queue_Is_Empty_In : AnsiString ;
function Text_Error_Maximum_Size_Of_Array_Object_Data_Is_Exceeded : AnsiString ;
function Text_Error_Objects_In_Trees_Must_Be_Size_4 : AnsiString ;
function Text_Error_Maximum_Size_Of_B_Tree_Object_Data_Is_Exceeded : AnsiString ;
function Text_Error_Maximum_Size_Of_B_Tree_Bucket_Is_Exceeded : AnsiString ;
function Text_Error_Illegal_Record_Context : AnsiString ;
function Text_Dynamic_Stack : AnsiString ;
function Text_Virtual_Stack : AnsiString ;
function Text_List_Stack : AnsiString ;
function Text_Sparse_Array : AnsiString ;
function Text_Error_Key_Size_Cannot_Exceed_Total_Tree_Object_Data_Size : AnsiString ;
function Text_Error_Maximum_Size_Of_Tree_Object_Data_Is_Exceeded : AnsiString ;
function Text_Error_Duplicate_Items_Encountered_In_Tree : AnsiString ;
function Text_Error_Tree_Error : AnsiString ;
function Text_Error_Tree_is_Empty_In : AnsiString ;
function Text_Error_End_Of_Tree_In : AnsiString ;
function Text_Error_While_Padding_Virtual_Array_Image_File : AnsiString ;
function Text_Invalid_Symbol_Name : AnsiString ;
function Text_Reserved_Name : AnsiString ;
function Text_Multiply_Defined_Symbol : AnsiString ;
function Text_Undefined_Reference : AnsiString ;
function Text_No_More_Matches : AnsiString ;
function Text_Unknown_Symbol_Error : AnsiString ;
function Text_Error_TEU_Not_Enough_Memory : AnsiString ;
function Text_Error_TEU_Backup_Past_Beginning_Of_Buffer : AnsiString ;
function Text_Error_TEU_Advance_Beyond_End_Of_Buffer : AnsiString ;
function Text_Error_TEU_Line_Length_Exceeds_255_Characters : AnsiString ;
function Text_Error_TEU_Text_Not_Found : AnsiString ;
function Text_Error_TEU_Nothing_Selected : AnsiString ;
function Text_Error_TEU_Selection_In_Progress : AnsiString ;
function Text_Error_Maximum_Memory_Exceeded : AnsiString ;
function Text_Error_Opening : AnsiString ;
function Text_Warning_Some_Lines_Too_Long : AnsiString ;
function Text_Press_Enter_To_Continue1 : AnsiString ;
function Text_Searching_For : AnsiString ;
function Text_Store_Aborted : AnsiString ;
function Text_Modifications_Will_No_Be_Saved_Continue_Quitting_NO : AnsiString ;
function Text_1_Line : AnsiString ;
function Text_n_Lines : AnsiString ;
function Text_Error_Illegal_Command : AnsiString ;
function Text_Missing_Parameter : AnsiString ;
function Text_Error_Missing_Operand : AnsiString ;
function Text_Error_Invalid_Line_Number : AnsiString ;
function Text_Text_To_Search_For : AnsiString ;
function Text_Error_Nested_Key_Definitions_Are_Not_Allowed : AnsiString ;
function Text_Line : AnsiString ;
function Text_Column : AnsiString ;
function Text_Error_No_Keystrokes_Are_Being_Recorded : AnsiString ;
function Text_Error_No_Keystrokes_Were_Recorded : AnsiString ;
function Text_Press_The_Key_To_Which_To_Assign_The_Keystrokes : AnsiString ;
function Text_Keystrokes_Remembered : AnsiString ;
function Text_Error_Previous_Key_Macro_Recording_Must_Be_Finished : AnsiString ;
function Text_Enter_The_Keystrokes_To_Record : AnsiString ;
function Text_Command : AnsiString ;
function Text_Control_C_Ignored : AnsiString ;
function Text_Modified : AnsiString ;
function Text_File : AnsiString ;
function Text_n_Bytes_Available : AnsiString ;
function Text_Line_Column : AnsiString ;
function Text_Sun : AnsiString ;
function Text_Mon : AnsiString ;
function Text_Tue : AnsiString ;
function Text_Wed : AnsiString ;
function Text_Thu : AnsiString ;
function Text_Fri : AnsiString ;
function Text_Sat : AnsiString ;
function Text_Address : AnsiString ;
function Text_Data : AnsiString ;
function Text_Caption_Modify_Memory : AnsiString ;
function Text_Literal_Text : AnsiString ;
function Text_Caption_Size : AnsiString ;
function Text_Byte1 : AnsiString ;
function Text_Word1 : AnsiString ;
function Text_Long1 : AnsiString ;
function Text_Button_Caption_OK : AnsiString ;
function Text_Button_Caption_Cancel : AnsiString ;
function Text_Button_Caption_Help : AnsiString ;
function Text_New : AnsiString ;
function Text_Button_Caption_Delete : AnsiString ;
function Text_Button_Caption_New_Folder : AnsiString ;
function Text_Caption_Internals : AnsiString ;
function Text_Persistant_Selection_Blocks : AnsiString ;
function Text_Bounded_Caret : AnsiString ;
function Text_Inactive_Selection : AnsiString ;
function Text_Tab_Processing : AnsiString ;
function Text_Sub_Window : AnsiString ;
function Text_Auto_Indent : AnsiString ;
function Text_Wrap_Caret : AnsiString ;
function Text_Menu_Caption_Edit_Amp : AnsiString ;
function Text_Menu_Caption_Undo_Amp : AnsiString ;
function Text_Menu_Undo_Hint : AnsiString ;
function Text_Menu_Caption_Cut_Amp : AnsiString ;
function Text_Menu_Cut_Hint : AnsiString ;
function Text_Menu_Caption_Copy_Amp : AnsiString ;
function Text_Menu_Copy_Hint : AnsiString ;
function Text_Menu_Caption_Paste_Amp : AnsiString ;
function Text_Menu_Paste_Hint : AnsiString ;
function Text_Menu_Caption_Delete_Amp : AnsiString ;
function Text_Menu_Delete_Hint : AnsiString ;
function Text_Menu_Caption_Include_Amp : AnsiString ;
function Text_Menu_Include_Hint : AnsiString ;
function Text_Menu_Caption_Search_Amp : AnsiString ;
function Text_Menu_Caption_Find_Amp : AnsiString ;
function Text_Menu_Find_Hint : AnsiString ;
function Text_Menu_Caption_Replace_Amp : AnsiString ;
function Text_Menu_Replace_Hint : AnsiString ;
function Text_Menu_Caption_Find_Next_Amp : AnsiString ;
function Text_Menu_Find_Next_Hint : AnsiString ;
function Text_Menu_Caption_Goto_Amp : AnsiString ;
function Text_Caption_Include_File : AnsiString ;
function Text_Caption_Find_Data : AnsiString ;
function Text_Search_For : AnsiString ;
function Text_Bytes : AnsiString ;
function Text_Case_Sensitive : AnsiString ;
function Text_Little_Endian : AnsiString ;
function Text_Caption_Editor_Preferences : AnsiString ;
function Text_Search_Options : AnsiString ;
function Text_Caption_Enter_Numeric_Value : AnsiString ;
function Text_Enter_The_Value : AnsiString ;
function Text_ASCII : AnsiString ;
function Text_EBCDIC : AnsiString ;
function Text_Other : AnsiString ;
function Text_Caption_Goto_Address : AnsiString ;
function Text_Enter_New_Address : AnsiString ;
function Text_Button_Caption_Abort : AnsiString ;
function Text_Caption_Go_To_Line_Number : AnsiString ;
function Text_Enter_New_Line_Number_Amp : AnsiString ;
function Text_Caption_Outline_Editor : AnsiString ;
function Text_Button_Caption_Rename : AnsiString ;
function Text_Button_Caption_Add : AnsiString ;
function Text_Button_Caption_Create_Sub : AnsiString ;
function Text_Button_Caption_Move : AnsiString ;
function Text_Caption_Choose_Radix : AnsiString ;
function Text_Choose_The_Radix_For_Numeric_Display : AnsiString ;
function Text_Button_Caption_Help_Amp : AnsiString ;
function Text_Caption_File_Has_Changed : AnsiString ;
function Text_Save_Changes_To1 : AnsiString ;
function Text_Button_Caption_Yes : AnsiString ;
function Text_Button_Caption_No : AnsiString ;
function Text_Text_To_Substitute : AnsiString ;
function Text_Scope : AnsiString ;
function Text_Search_From_Current_Position : AnsiString ;
function Text_Search_Entire_File : AnsiString ;
function Text_Button_Caption_Replace : AnsiString ;
function Text_Prompt_On_Replace : AnsiString ;
function Text_Search : AnsiString ;
function Text_Error_Creating : AnsiString ;
function Text_More : AnsiString ;
function Text_Enter_Keystroke_Whose_Definition_You_Wish_To_Save : AnsiString ;
function Text_Editing_File_x_Confirm : AnsiString ;
function Text_Parameters_Are_Not_Allowed_On : AnsiString ;
function Text_Recover_And_Read_Only_Are_Incompatible_Switches : AnsiString ;
function Text_Invalid_Switch : AnsiString ;


implementation

uses { C&C... }
     Collect ; { PString_Collection }

function Substitute( const Value, Sub, X : AnsiString ) : AnsiString ;

var Dummy : integer ;
    Recursed : boolean ;

begin
    Result := Value ;
    Recursed := pos( X, Sub ) > 0 ;
    Dummy := pos( X, Result ) ;
    while( Dummy > 0 ) do
    begin
        Result := copy( Result, 1, Dummy - 1 ) + Sub + copy( Result, Dummy + 2, length( Result ) ) ;
        if( Recursed ) then
        begin
            break ; { Only expand once }
        end ;
        Dummy := pos( X, Result ) ;
    end ;
end ;


function Substitute1( const Value, Sub1 : AnsiString ) : AnsiString ;

begin
    Result := Substitute( Value, Sub1, '$1' ) ;
end ;


function Substitute2( const Value, Sub1, Sub2 : AnsiString ) : AnsiString ;

begin
    Result := Substitute1( Value, Sub1 ) ;
    Result := Substitute( Result, Sub2, '$2' ) ;
end ;


function Substitute3( const Value, Sub1, Sub2, Sub3 : AnsiString ) : AnsiString ;

begin
    Result := Substitute2( Value, Sub1, Sub2 ) ;
    Result := Substitute( Result, Sub3, '$3' ) ;
end ;


{$I L10n.inc}

var Texts : PString_Collection ;

function Get_Text( ID : integer ; const Default : Ansistring ) : AnsiString ;

begin
    if( ( Texts = nil ) or ( Texts.Count <= ID ) or ( ID < 0 ) ) then
    begin
        Get_Text := Default ;
    end else
    begin
        Get_Text := Texts^.At( ID ) ;
    end ;
end ;


procedure Load_Text( const N : AnsiString ) ;

var Dummy : integer ;
    F : textfile ;
    S : AnsiString ;
    Saved : integer ;

begin
    assign( F, N ) ;
    Saved := FileMode ;
    FileMode := 0 ; { Readonly }
    {$I-}
    reset( F ) ;
    {$I+}
    Dummy := IOResult ;
    FileMode := Saved ;
    if( Dummy = 0 ) then
    begin
        if( Texts = nil ) then
        begin
            Texts := new( PString_Collection, Init( 0, 4 ) ) ;
        end else
        begin
            Texts.DeleteAll ;
        end ;
        while( not eof( F ) ) do
        begin
            readln( F, S ) ;
            Texts^.Insert( S ) ;
        end ;
        {$I-}
        closefile( F ) ;
        {$I+}
        IOResult ;
    end ;
end ;


function Text_Error_Allocation_Table_Load_Failure : AnsiString ;

begin
    Text_Error_Allocation_Table_Load_Failure :=
        Get_Text( ID_Text_Error_Allocation_Table_Load_Failure, _Text_Error_Allocation_Table_Load_Failure ) ;
end ;


function Text_Error_Execution_Exceeds_ms : AnsiString ;

begin
    Text_Error_Execution_Exceeds_ms :=
        Get_Text( ID_Text_Error_Execution_Exceeds_ms, _Text_Error_Execution_Exceeds_ms ) ;
end ;


function Text_Error_Adding_Existing_Object_Or_Failure_To_Delete_Old_Object : AnsiString ;

begin
    Text_Error_Adding_Existing_Object_Or_Failure_To_Delete_Old_Object :=
        Get_Text( ID_Text_Error_Adding_Existing_Object_Or_Failure_To_Delete_Old_Object, _Text_Error_Adding_Existing_Object_Or_Failure_To_Delete_Old_Object ) ;
end ;


function Text_Error_Found_Object_Has_Facility_Mismatch : AnsiString ;

begin
    Text_Error_Found_Object_Has_Facility_Mismatch :=
        Get_Text( ID_Text_Error_Found_Object_Has_Facility_Mismatch, _Text_Error_Found_Object_Has_Facility_Mismatch ) ;
end ;


function Text_Error_Facility_Out_Of_Range : AnsiString ;

begin
    Text_Error_Facility_Out_Of_Range :=
        Get_Text( ID_Text_Error_Facility_Out_Of_Range, _Text_Error_Facility_Out_Of_Range ) ;
end ;


function Text_Error_Removing_Non_Existant_Object : AnsiString ;

begin
    Text_Error_Removing_Non_Existant_Object :=
        Get_Text( ID_Text_Error_Removing_Non_Existant_Object, _Text_Error_Removing_Non_Existant_Object ) ;
end ;


function Text_Error_Facility_Mismatch : AnsiString ;

begin
    Text_Error_Facility_Mismatch :=
        Get_Text( ID_Text_Error_Facility_Mismatch, _Text_Error_Facility_Mismatch ) ;
end ;


function Text_Press_Enter_To_Continue : AnsiString ;

begin
    Text_Press_Enter_To_Continue :=
        Get_Text( ID_Text_Press_Enter_To_Continue, _Text_Press_Enter_To_Continue ) ;
end ;


function Text_Application : AnsiString ;

begin
    Text_Application :=
        Get_Text( ID_Text_Application, _Text_Application ) ;
end ;


function Text_Unsigned : AnsiString ;

begin
    Text_Unsigned :=
        Get_Text( ID_Text_Unsigned, _Text_Unsigned ) ;
end ;


function Text_Signed : AnsiString ;

begin
    Text_Signed := Get_Text( ID_Text_Signed, _Text_Signed ) ;
end ;


function Text_Byte : AnsiString ;

begin
    Text_Byte := Get_Text( ID_Text_Byte, _Text_Byte ) ;
end ;


function Text_Word : AnsiString ;

begin
    Text_Word := Get_Text( ID_Text_Word, _Text_Word ) ;
end ;


function Text_Longint : AnsiString ;

begin
    Text_Longint := Get_Text( ID_Text_Longint, _Text_Longint ) ;
end ;


function Text_Binary : AnsiString ;

begin
    Text_Binary := Get_Text( ID_Text_Binary, _Text_Binary ) ;
end ;


function Text_Octal : AnsiString ;

begin
    Text_Octal := Get_Text( ID_Text_Octal, _Text_Octal ) ;
end ;


function Text_Decimal : AnsiString ;

begin
    Text_Decimal := Get_Text( ID_Text_Decimal, _Text_Decimal ) ;
end ;


function Text_Hexadecimal : AnsiString ;

begin
    Text_Hexadecimal := Get_Text( ID_Text_Hexadecimal, _Text_Hexadecimal ) ;
end ;


function Text_Radix_50 : AnsiString ;

begin
    Text_Radix_50 := Get_Text( ID_Text_Radix_50, _Text_Radix_50 ) ;
end ;


function Text_Base_n : AnsiString ;

begin
    Text_Base_n := Get_Text( ID_Text_Base_n, _Text_Base_n ) ;
end ;


function Text_Size_Amp : AnsiString ;

begin
    Text_Size_Amp := Get_Text( ID_Text_Size_Amp, _Text_Size_Amp ) ;
end ;


function Text_Base_Amp : AnsiString ;

begin
    Text_Base_Amp := Get_Text( ID_Text_Base_Amp, _Text_Base_Amp ) ;
end ;


function Text_Binary_Amp : AnsiString ;

begin
    Text_Binary_Amp := Get_Text( ID_Text_Binary_Amp, _Text_Binary_Amp ) ;
end ;


function Text_Octal_Amp : AnsiString ;

begin
    Text_Octal_Amp := Get_Text( ID_Text_Octal_Amp, _Text_Octal_Amp ) ;
end ;


function Text_Decimal_Amp : AnsiString ;

begin
    Text_Decimal_Amp := Get_Text( ID_Text_Decimal_Amp, _Text_Decimal_Amp ) ;
end ;


function Text_Hexadecimal_Amp : AnsiString ;

begin
    Text_Hexadecimal_Amp :=
        Get_Text( ID_Text_Hexadecimal_Amp, _Text_Hexadecimal_Amp ) ;
end ;


function Text_Radix_50_Amp : AnsiString ;

begin
    Text_Radix_50_Amp := Get_Text( ID_Text_Radix_50_Amp, _Text_Radix_50_Amp ) ;
end ;


function Text_Err_Writing_To_Log_File : AnsiString ;

begin
    Text_Err_Writing_To_Log_File :=
        Get_Text( ID_Text_Err_Writing_To_Log_File, _Text_Err_Writing_To_Log_File ) ;
end ;


function Text_Volume_ID_Is : AnsiString ;

begin
    Text_Volume_ID_Is := Get_Text( ID_Text_Volume_ID_Is, _Text_Volume_ID_Is ) ;
end ;


function Text_Error_Invalid_Output_Drive : AnsiString ;

begin
    Text_Error_Invalid_Output_Drive :=
        Get_Text( ID_Text_Error_Invalid_Output_Drive, _Text_Error_Invalid_Output_Drive ) ;
end ;


function Text_Error_FAT_Is_Too_Big : AnsiString ;

begin
    Text_Error_FAT_Is_Too_Big :=
        Get_Text( ID_Text_Error_FAT_Is_Too_Big, _Text_Error_FAT_Is_Too_Big ) ;
end ;


function Text_Initialization_Error_Correct_And_Press_Any_Key_To_Continue : AnsiString ;

begin
    Text_Initialization_Error_Correct_And_Press_Any_Key_To_Continue :=
        Get_Text( ID_Text_Initialization_Error_Correct_And_Press_Any_Key_To_Continue, _Text_Initialization_Error_Correct_And_Press_Any_Key_To_Continue ) ;
end ;


function Text_Initialization_Error : AnsiString ;

begin
    Text_Initialization_Error :=
        Get_Text( ID_Text_Initialization_Error, _Text_Initialization_Error ) ;
end ;


function Text_Error_Unknown_Command_Or_Invalid_Drive : AnsiString ;

begin
    Text_Error_Unknown_Command_Or_Invalid_Drive :=
        Get_Text( ID_Text_Error_Unknown_Command_Or_Invalid_Drive, _Text_Error_Unknown_Command_Or_Invalid_Drive ) ;
end ;


function Text_Error_Bad_Address_Mark : AnsiString ;

begin
    Text_Error_Bad_Address_Mark :=
        Get_Text( ID_Text_Error_Bad_Address_Mark, _Text_Error_Bad_Address_Mark ) ;
end ;


function Text_Error_Sector_Not_Found : AnsiString ;

begin
    Text_Error_Sector_Not_Found :=
        Get_Text( ID_Text_Error_Sector_Not_Found, _Text_Error_Sector_Not_Found ) ;
end ;


function Text_Error_DMA_Failure : AnsiString ;

begin
    Text_Error_DMA_Failure :=
        Get_Text( ID_Text_Error_DMA_Failure, _Text_Error_DMA_Failure ) ;
end ;


function Text_Error_Data_Error_CRC : AnsiString ;

begin
    Text_Error_Data_Error_CRC :=
        Get_Text( ID_Text_Error_Data_Error_CRC, _Text_Error_Data_Error_CRC ) ;
end ;


function Text_Error_Controller_Failure : AnsiString ;

begin
    Text_Error_Controller_Failure :=
        Get_Text( ID_Text_Error_Controller_Failure, _Text_Error_Controller_Failure ) ;
end ;


function Text_Error_Seek_Failure : AnsiString ;

begin
    Text_Error_Seek_Failure :=
        Get_Text( ID_Text_Error_Seek_Failure, _Text_Error_Seek_Failure ) ;
end ;


function Text_Error_Drive_Does_Not_Respond : AnsiString ;

begin
    Text_Error_Drive_Does_Not_Respond :=
        Get_Text( ID_Text_Error_Drive_Does_Not_Respond, _Text_Error_Drive_Does_Not_Respond ) ;
end ;


function Text_Error_Drive_Is_Write_Locked : AnsiString ;

begin
    Text_Error_Drive_Is_Write_Locked :=
        Get_Text( ID_Text_Error_Drive_Is_Write_Locked, _Text_Error_Drive_Is_Write_Locked ) ;
end ;


function Text_Error_Unknown_Unit : AnsiString ;

begin
    Text_Error_Unknown_Unit :=
        Get_Text( ID_Text_Error_Unknown_Unit, _Text_Error_Unknown_Unit ) ;
end ;


function Text_Error_Drive_Not_Ready : AnsiString ;

begin
    Text_Error_Drive_Not_Ready :=
        Get_Text( ID_Text_Error_Drive_Not_Ready, _Text_Error_Drive_Not_Ready ) ;
end ;


function Text_Error_Unknown_Command_In_Absolute_Sector_Write : AnsiString ;

begin
    Text_Error_Unknown_Command_In_Absolute_Sector_Write :=
        Get_Text( ID_Text_Error_Unknown_Command_In_Absolute_Sector_Write, _Text_Error_Unknown_Command_In_Absolute_Sector_Write ) ;
end ;


function Text_Error_Bad_Request_Structure_Length : AnsiString ;

begin
    Text_Error_Bad_Request_Structure_Length :=
        Get_Text( ID_Text_Error_Bad_Request_Structure_Length, _Text_Error_Bad_Request_Structure_Length ) ;
end ;


function Text_Error_Seek_Error : AnsiString ;

begin
    Text_Error_Seek_Error :=
        Get_Text( ID_Text_Error_Seek_Error, _Text_Error_Seek_Error ) ;
end ;


function Text_Error_Unknown_Media_Type : AnsiString ;

begin
    Text_Error_Unknown_Media_Type :=
        Get_Text( ID_Text_Error_Unknown_Media_Type, _Text_Error_Unknown_Media_Type ) ;
end ;


function Text_Error_Printer_Out_Of_Paper : AnsiString ;

begin
    Text_Error_Printer_Out_Of_Paper :=
        Get_Text( ID_Text_Error_Printer_Out_Of_Paper, _Text_Error_Printer_Out_Of_Paper ) ;
end ;


function Text_Error_Write_Fault : AnsiString ;

begin
    Text_Error_Write_Fault :=
        Get_Text( ID_Text_Error_Write_Fault, _Text_Error_Write_Fault ) ;
end ;


function Text_Error_Read_Fault : AnsiString ;

begin
    Text_Error_Read_Fault :=
        Get_Text( ID_Text_Error_Read_Fault, _Text_Error_Read_Fault ) ;
end ;


function Text_Error_General_Failure : AnsiString ;

begin
    Text_Error_General_Failure :=
        Get_Text( ID_Text_Error_General_Failure, _Text_Error_General_Failure ) ;
end ;


function Text_Error_Error_13_In_Absolute_Sector_Write : AnsiString ;

begin
    Text_Error_Error_13_In_Absolute_Sector_Write :=
        Get_Text( ID_Text_Error_Error_13_In_Absolute_Sector_Write, _Text_Error_Error_13_In_Absolute_Sector_Write ) ;
end ;


function Text_Error_Error_14_In_Absolute_Sector_Write : AnsiString ;

begin
    Text_Error_Error_14_In_Absolute_Sector_Write :=
        Get_Text( ID_Text_Error_Error_14_In_Absolute_Sector_Write, _Text_Error_Error_14_In_Absolute_Sector_Write ) ;
end ;


function Text_Error_Invalid_Disk_Change : AnsiString ;

begin
    Text_Error_Invalid_Disk_Change :=
        Get_Text( ID_Text_Error_Invalid_Disk_Change, _Text_Error_Invalid_Disk_Change ) ;
end ;


function Text_Place_Saveset_Volume_Into_Drive_And_Press_Return : AnsiString ;

begin
    Text_Place_Saveset_Volume_Into_Drive_And_Press_Return :=
        Get_Text( ID_Text_Place_Saveset_Volume_Into_Drive_And_Press_Return, _Text_Place_Saveset_Volume_Into_Drive_And_Press_Return ) ;
end ;


function Text_Place_Saveset_Volume_Into_Drive : AnsiString ;

begin
    Text_Place_Saveset_Volume_Into_Drive :=
        Get_Text( ID_Text_Place_Saveset_Volume_Into_Drive, _Text_Place_Saveset_Volume_Into_Drive ) ;
end ;


function Text_Success : AnsiString ;

begin
    Text_Success :=
        Get_Text( ID_Text_Success, _Text_Success ) ;
end ;


function Text_Error_No_Dictionary_Open : AnsiString ;

begin
    Text_Error_No_Dictionary_Open :=
        Get_Text( ID_Text_Error_No_Dictionary_Open, _Text_Error_No_Dictionary_Open ) ;
end ;


function Text_Error_Already_Defined : AnsiString ;

begin
    Text_Error_Already_Defined :=
        Get_Text( ID_Text_Error_Already_Defined, _Text_Error_Already_Defined ) ;
end ;


function Text_Error_Invalid_Syntax_Type : AnsiString ;

begin
    Text_Error_Invalid_Syntax_Type :=
        Get_Text( ID_Text_Error_Invalid_Syntax_Type, _Text_Error_Invalid_Syntax_Type ) ;
end ;


function Text_Error_Not_Defined : AnsiString ;

begin
    Text_Error_Not_Defined :=
        Get_Text( ID_Text_Error_Not_Defined, _Text_Error_Not_Defined ) ;
end ;


function Text_Error_Attach_Failed : AnsiString ;

begin
    Text_Error_Attach_Failed :=
        Get_Text( ID_Text_Error_Attach_Failed, _Text_Error_Attach_Failed ) ;
end ;


function Text_Error_Detach_Failed : AnsiString ;

begin
    Text_Error_Detach_Failed :=
        Get_Text( ID_Text_Error_Detach_Failed, _Text_Error_Detach_Failed ) ;
end ;


function Text_True : AnsiString ;

begin
    Text_True := Get_Text( ID_Text_True, _Text_True ) ;
end ;


function Text_False : AnsiString ;

begin
    Text_False := Get_Text( ID_Text_False, _Text_False ) ;
end ;


function Text_Error_Invalid_Base : AnsiString ;

begin
    Text_Error_Invalid_Base :=
        Get_Text( ID_Text_Error_Invalid_Base, _Text_Error_Invalid_Base ) ;
end ;


function Text_Error_Numeric_Error : AnsiString ;

begin
    Text_Error_Numeric_Error :=
        Get_Text( ID_Text_Error_Numeric_Error, _Text_Error_Numeric_Error ) ;
end ;


function Text_Error_Abstract_Method_Called : AnsiString ;

begin
    Text_Error_Abstract_Method_Called :=
        Get_Text( ID_Text_Error_Abstract_Method_Called, _Text_Error_Abstract_Method_Called ) ;
end ;


function Text_Other_Ellipse : AnsiString ;

begin
    Text_Other_Ellipse :=
        Get_Text( ID_Text_Other_Ellipse, _Text_Other_Ellipse ) ;
end ;


function Text_Signed_Amp : AnsiString ;

begin
    Text_Signed_Amp := Get_Text( ID_Text_Signed_Amp, _Text_Signed_Amp ) ;
end ;


function Text_Byte_Amp : AnsiString ;

begin
    Text_Byte_Amp := Get_Text( ID_Text_Byte_Amp, _Text_Byte_Amp ) ;
end ;


function Text_Word_Amp : AnsiString ;

begin
    Text_Word_Amp := Get_Text( ID_Text_Word_Amp, _Text_Word_Amp ) ;
end ;


function Text_Long_Amp : AnsiString ;

begin
    Text_Long_Amp := Get_Text( ID_Text_Long_Amp, _Text_Long_Amp ) ;
end ;


function Text_Quad_Amp : AnsiString ;

begin
    Text_Quad_Amp := Get_Text( ID_Text_Quad_Amp, _Text_Quad_Amp ) ;
end ;


function Text_EBCDIC_Amp : AnsiString ;

begin
    Text_EBCDIC_Amp := Get_Text( ID_Text_EBCDIC_Amp, _Text_EBCDIC_Amp ) ;
end ;


function Text_Goto_Address_Ellipse : AnsiString ;

begin
    Text_Goto_Address_Ellipse :=
        Get_Text( ID_Text_Goto_Address_Ellipse, _Text_Goto_Address_Ellipse ) ;
end ;


function Text_Find_Ellipse : AnsiString ;

begin
    Text_Find_Ellipse := Get_Text( ID_Text_Find_Ellipse, _Text_Find_Ellipse ) ;
end ;


function Text_Modify_Ellipse : AnsiString ;

begin
    Text_Modify_Ellipse :=
        Get_Text( ID_Text_Modify_Ellipse, _Text_Modify_Ellipse ) ;
end ;


function Text_Nothing_Found : AnsiString ;

begin
    Text_Nothing_Found :=
        Get_Text( ID_Text_Nothing_Found, _Text_Nothing_Found ) ;
end ;


function Text_Month_Jan : AnsiString ;

begin
    Text_Month_Jan := Get_Text( ID_Text_Month_Jan, _Text_Month_Jan ) ;
end ;


function Text_Month_Feb : AnsiString ;

begin
    Text_Month_Feb := Get_Text( ID_Text_Month_Feb, _Text_Month_Feb ) ;
end ;


function Text_Month_Mar : AnsiString ;

begin
    Text_Month_Mar := Get_Text( ID_Text_Month_Mar, _Text_Month_Mar ) ;
end ;


function Text_Month_Apr : AnsiString ;

begin
    Text_Month_Apr := Get_Text( ID_Text_Month_Apr, _Text_Month_Apr ) ;
end ;


function Text_Month_May : AnsiString ;

begin
    Text_Month_May := Get_Text( ID_Text_Month_May, _Text_Month_May ) ;
end ;


function Text_Month_Jun : AnsiString ;

begin
    Text_Month_Jun := Get_Text( ID_Text_Month_Jun, _Text_Month_Jun ) ;
end ;


function Text_Month_Jul : AnsiString ;

begin
    Text_Month_Jul := Get_Text( ID_Text_Month_Jul, _Text_Month_Jul ) ;
end ;


function Text_Month_Aug : AnsiString ;

begin
    Text_Month_Aug := Get_Text( ID_Text_Month_Aug, _Text_Month_Aug ) ;
end ;


function Text_Month_Sep : AnsiString ;

begin
    Text_Month_Sep := Get_Text( ID_Text_Month_Sep, _Text_Month_Sep ) ;
end ;


function Text_Month_Oct : AnsiString ;

begin
    Text_Month_Oct := Get_Text( ID_Text_Month_Oct, _Text_Month_Oct ) ;
end ;


function Text_Month_Nov : AnsiString ;

begin
    Text_Month_Nov := Get_Text( ID_Text_Month_Nov, _Text_Month_Nov ) ;
end ;


function Text_Month_Dec : AnsiString ;

begin
    Text_Month_Dec := Get_Text( ID_Text_Month_Dec, _Text_Month_Dec ) ;
end ;


function Text_Month_January : AnsiString ;

begin
    Text_Month_January :=
        Get_Text( ID_Text_Month_January, _Text_Month_January ) ;
end ;


function Text_Month_February : AnsiString ;

begin
    Text_Month_February :=
        Get_Text( ID_Text_Month_February, _Text_Month_February ) ;
end ;


function Text_Month_March : AnsiString ;

begin
    Text_Month_March :=
        Get_Text( ID_Text_Month_March, _Text_Month_March ) ;
end ;


function Text_Month_April : AnsiString ;

begin
    Text_Month_April :=
        Get_Text( ID_Text_Month_April, _Text_Month_April ) ;
end ;


function Text_Month_June : AnsiString ;

begin
    Text_Month_June :=
        Get_Text( ID_Text_Month_June, _Text_Month_June ) ;
end ;


function Text_Month_July : AnsiString ;

begin
    Text_Month_July :=
        Get_Text( ID_Text_Month_July, _Text_Month_July ) ;
end ;


function Text_Month_August : AnsiString ;

begin
    Text_Month_August :=
        Get_Text( ID_Text_Month_August, _Text_Month_August ) ;
end ;


function Text_Month_September : AnsiString ;

begin
    Text_Month_September :=
        Get_Text( ID_Text_Month_September, _Text_Month_September ) ;
end ;


function Text_Month_October : AnsiString ;

begin
    Text_Month_October :=
        Get_Text( ID_Text_Month_October, _Text_Month_October ) ;
end ;


function Text_Month_November : AnsiString ;

begin
    Text_Month_November :=
        Get_Text( ID_Text_Month_November, _Text_Month_November ) ;
end ;


function Text_Month_December : AnsiString ;

begin
    Text_Month_December :=
        Get_Text( ID_Text_Month_December, _Text_Month_December ) ;
end ;


function Text_ASCII_Amp : AnsiString ;

begin
    Text_ASCII_Amp := Get_Text( ID_Text_ASCII_Amp, _Text_ASCII_Amp ) ;
end ;


function Text_Day_Sunday : AnsiString ;

begin
    Text_Day_Sunday :=
        Get_Text( ID_Text_Day_Sunday, _Text_Day_Sunday ) ;
end ;


function Text_Day_Monday : AnsiString ;

begin
    Text_Day_Monday :=
        Get_Text( ID_Text_Day_Monday, _Text_Day_Monday ) ;
end ;


function Text_Day_Tuesday : AnsiString ;

begin
    Text_Day_Tuesday :=
        Get_Text( ID_Text_Day_Tuesday, _Text_Day_Tuesday ) ;
end ;


function Text_Day_Wednesday : AnsiString ;

begin
    Text_Day_Wednesday :=
        Get_Text( ID_Text_Day_Wednesday, _Text_Day_Wednesday ) ;
end ;


function Text_Day_Thursday : AnsiString ;

begin
    Text_Day_Thursday :=
        Get_Text( ID_Text_Day_Thursday, _Text_Day_Thursday ) ;
end ;


function Text_Day_Friday : AnsiString ;

begin
    Text_Day_Friday :=
        Get_Text( ID_Text_Day_Friday, _Text_Day_Friday ) ;
end ;


function Text_Day_Saturday : AnsiString ;

begin
    Text_Day_Saturday :=
        Get_Text( ID_Text_Day_Saturday, _Text_Day_Saturday ) ;
end ;


function Text_Application_x : AnsiString ;

begin
    Text_Application_x :=
        Get_Text( ID_Text_Application_x, _Text_Application_x ) ;
end ;


function Text_Operating_System_x : AnsiString ;

begin
    Text_Operating_System_x :=
        Get_Text( ID_Text_Operating_System_x, _Text_Operating_System_x ) ;
end ;


function Text_There_Is_No_Debugging_Information_Available : AnsiString ;

begin
    Text_There_Is_No_Debugging_Information_Available :=
        Get_Text( ID_Text_There_Is_No_Debugging_Information_Available, _Text_There_Is_No_Debugging_Information_Available ) ;
end ;


function Text_Error_Opening_x : AnsiString ;

begin
    Text_Error_Opening_x :=
        Get_Text( ID_Text_Error_Opening_x, _Text_Error_Opening_x ) ;
end ;


function Text_Search_String_Not_Found : AnsiString ;

begin
    Text_Search_String_Not_Found :=
        Get_Text( ID_Text_Search_String_Not_Found, _Text_Search_String_Not_Found ) ;
end ;


function Text_Error_Creating : AnsiString ;

begin
    Text_Error_Creating :=
        Get_Text( ID_Text_Error_Creating, _Text_Error_Creating ) ;
end ;


function Text_Caption_Search : AnsiString ;

begin
    Text_Caption_Search :=
        Get_Text( ID_Text_Caption_Search, _Text_Caption_Search ) ;
end ;


function Text_Caption_Replace : AnsiString ;

begin
    Text_Caption_Replace :=
        Get_Text( ID_Text_Caption_Replace, _Text_Caption_Replace ) ;
end ;


function Text_Replace_This_Instance : AnsiString ;

begin
    Text_Replace_This_Instance :=
        Get_Text( ID_Text_Replace_This_Instance, _Text_Replace_This_Instance ) ;
end ;


function Text_Save_Changes_To : AnsiString ;

begin
    Text_Save_Changes_To :=
        Get_Text( ID_Text_Save_Changes_To, _Text_Save_Changes_To ) ;
end ;


function Text_Noname : AnsiString ;

begin
    Text_Noname := Get_Text( ID_Text_Noname, _Text_Noname ) ;
end ;


function Text_Unknown_Error_Code : AnsiString ;

begin
    Text_Unknown_Error_Code := Get_Text( ID_Text_Unknown_Error_Code, _Text_Unknown_Error_Code ) ;
end ;


function Text_Facility_n_Error_n : AnsiString ;

begin
    Text_Facility_n_Error_n := Get_Text( ID_Text_Facility_n_Error_n, _Text_Facility_n_Error_n ) ;
end ;


function Text_Error_Severity_Success : AnsiString ;

begin
    Text_Error_Severity_Success :=
        Get_Text( ID_Text_Error_Severity_Success, _Text_Error_Severity_Success ) ;
end ;


function Text_Error_Severity_Notification : AnsiString ;

begin
    Text_Error_Severity_Notification :=
        Get_Text( ID_Text_Error_Severity_Notification, _Text_Error_Severity_Notification ) ;
end ;


function Text_Error_Severity_Warning : AnsiString ;

begin
    Text_Error_Severity_Warning :=
        Get_Text( ID_Text_Error_Severity_Warning, _Text_Error_Severity_Warning ) ;
end ;


function Text_Error_Severity_Error : AnsiString ;

begin
    Text_Error_Severity_Error :=
        Get_Text( ID_Text_Error_Severity_Error, _Text_Error_Severity_Error ) ;
end ;


function Text_Error_Severity_Fatal : AnsiString ;

begin
    Text_Error_Severity_Fatal :=
        Get_Text( ID_Text_Error_Severity_Fatal, _Text_Error_Severity_Fatal ) ;
end ;


function Text_DOS_Error_Success : AnsiString ;

begin
    Text_DOS_Error_Success :=
        Get_Text( ID_Text_DOS_Error_Success, _Text_DOS_Error_Success ) ;
end ;


function Text_DOS_Error_1 : AnsiString ;

begin
    Text_DOS_Error_1 :=
        Get_Text( ID_Text_DOS_Error_1, _Text_DOS_Error_1 ) ;
end ;


function Text_DOS_Error_2 : AnsiString ;

begin
    Text_DOS_Error_2 :=
        Get_Text( ID_Text_DOS_Error_2, _Text_DOS_Error_2 ) ;
end ;


function Text_DOS_Error_3 : AnsiString ;

begin
    Text_DOS_Error_3 :=
        Get_Text( ID_Text_DOS_Error_3, _Text_DOS_Error_3 ) ;
end ;


function Text_DOS_Error_4 : AnsiString ;

begin
    Text_DOS_Error_4 :=
        Get_Text( ID_Text_DOS_Error_4, _Text_DOS_Error_4 ) ;
end ;


function Text_DOS_Error_5 : AnsiString ;

begin
    Text_DOS_Error_5 :=
        Get_Text( ID_Text_DOS_Error_5, _Text_DOS_Error_5 ) ;
end ;


function Text_DOS_Error_6 : AnsiString ;

begin
    Text_DOS_Error_6 :=
        Get_Text( ID_Text_DOS_Error_6, _Text_DOS_Error_6 ) ;
end ;


function Text_DOS_Error_7 : AnsiString ;

begin
    Text_DOS_Error_7 :=
        Get_Text( ID_Text_DOS_Error_7, _Text_DOS_Error_7 ) ;
end ;


function Text_DOS_Error_8 : AnsiString ;

begin
    Text_DOS_Error_8 :=
        Get_Text( ID_Text_DOS_Error_8, _Text_DOS_Error_8 ) ;
end ;


function Text_DOS_Error_9 : AnsiString ;

begin
    Text_DOS_Error_9 :=
        Get_Text( ID_Text_DOS_Error_9, _Text_DOS_Error_9 ) ;
end ;


function Text_DOS_Error_10 : AnsiString ;

begin
    Text_DOS_Error_10 :=
        Get_Text( ID_Text_DOS_Error_10, _Text_DOS_Error_10 ) ;
end ;


function Text_DOS_Error_11 : AnsiString ;

begin
    Text_DOS_Error_11 :=
        Get_Text( ID_Text_DOS_Error_11, _Text_DOS_Error_11 ) ;
end ;


function Text_DOS_Error_12 : AnsiString ;

begin
    Text_DOS_Error_12 :=
        Get_Text( ID_Text_DOS_Error_12, _Text_DOS_Error_12 ) ;
end ;


function Text_DOS_Error_13 : AnsiString ;

begin
    Text_DOS_Error_13 :=
        Get_Text( ID_Text_DOS_Error_13, _Text_DOS_Error_13 ) ;
end ;


function Text_DOS_Error_14 : AnsiString ;

begin
    Text_DOS_Error_14 :=
        Get_Text( ID_Text_DOS_Error_14, _Text_DOS_Error_14 ) ;
end ;


function Text_DOS_Error_15 : AnsiString ;

begin
    Text_DOS_Error_15 :=
        Get_Text( ID_Text_DOS_Error_15, _Text_DOS_Error_15 ) ;
end ;


function Text_DOS_Error_16 : AnsiString ;

begin
    Text_DOS_Error_16 :=
        Get_Text( ID_Text_DOS_Error_16, _Text_DOS_Error_16 ) ;
end ;


function Text_DOS_Error_17 : AnsiString ;

begin
    Text_DOS_Error_17 :=
        Get_Text( ID_Text_DOS_Error_17, _Text_DOS_Error_17 ) ;
end ;


function Text_DOS_Error_18 : AnsiString ;

begin
    Text_DOS_Error_18 :=
        Get_Text( ID_Text_DOS_Error_18, _Text_DOS_Error_18 ) ;
end ;


function Text_DOS_Error_19 : AnsiString ;

begin
    Text_DOS_Error_19 :=
        Get_Text( ID_Text_DOS_Error_19, _Text_DOS_Error_19 ) ;
end ;


function Text_DOS_Error_20 : AnsiString ;

begin
    Text_DOS_Error_20 :=
        Get_Text( ID_Text_DOS_Error_20, _Text_DOS_Error_20 ) ;
end ;


function Text_DOS_Error_21 : AnsiString ;

begin
    Text_DOS_Error_21 :=
        Get_Text( ID_Text_DOS_Error_21, _Text_DOS_Error_21 ) ;
end ;


function Text_DOS_Error_22 : AnsiString ;

begin
    Text_DOS_Error_22 :=
        Get_Text( ID_Text_DOS_Error_22, _Text_DOS_Error_22 ) ;
end ;


function Text_DOS_Error_23 : AnsiString ;

begin
    Text_DOS_Error_23 :=
        Get_Text( ID_Text_DOS_Error_23, _Text_DOS_Error_23 ) ;
end ;


function Text_DOS_Error_24 : AnsiString ;

begin
    Text_DOS_Error_24 :=
        Get_Text( ID_Text_DOS_Error_24, _Text_DOS_Error_24 ) ;
end ;


function Text_DOS_Error_25 : AnsiString ;

begin
    Text_DOS_Error_25 :=
        Get_Text( ID_Text_DOS_Error_25, _Text_DOS_Error_25 ) ;
end ;


function Text_DOS_Error_26 : AnsiString ;

begin
    Text_DOS_Error_26 :=
        Get_Text( ID_Text_DOS_Error_26, _Text_DOS_Error_26 ) ;
end ;


function Text_DOS_Error_27 : AnsiString ;

begin
    Text_DOS_Error_27 :=
        Get_Text( ID_Text_DOS_Error_27, _Text_DOS_Error_27 ) ;
end ;


function Text_DOS_Error_28 : AnsiString ;

begin
    Text_DOS_Error_28 :=
        Get_Text( ID_Text_DOS_Error_28, _Text_DOS_Error_28 ) ;
end ;


function Text_DOS_Error_29 : AnsiString ;

begin
    Text_DOS_Error_29 :=
        Get_Text( ID_Text_DOS_Error_29, _Text_DOS_Error_29 ) ;
end ;


function Text_DOS_Error_30 : AnsiString ;

begin
    Text_DOS_Error_30 :=
        Get_Text( ID_Text_DOS_Error_30, _Text_DOS_Error_30 ) ;
end ;


function Text_DOS_Error_31 : AnsiString ;

begin
    Text_DOS_Error_31 :=
        Get_Text( ID_Text_DOS_Error_31, _Text_DOS_Error_31 ) ;
end ;


function Text_DOS_Error_32 : AnsiString ;

begin
    Text_DOS_Error_32 :=
        Get_Text( ID_Text_DOS_Error_32, _Text_DOS_Error_32 ) ;
end ;


function Text_DOS_Error_33 : AnsiString ;

begin
    Text_DOS_Error_33 :=
        Get_Text( ID_Text_DOS_Error_33, _Text_DOS_Error_33 ) ;
end ;


function Text_DOS_Error_34 : AnsiString ;

begin
    Text_DOS_Error_34 :=
        Get_Text( ID_Text_DOS_Error_34, _Text_DOS_Error_34 ) ;
end ;


function Text_DOS_Error_35 : AnsiString ;

begin
    Text_DOS_Error_35 :=
        Get_Text( ID_Text_DOS_Error_35, _Text_DOS_Error_35 ) ;
end ;


function Text_DOS_Error_36 : AnsiString ;

begin
    Text_DOS_Error_36 :=
        Get_Text( ID_Text_DOS_Error_36, _Text_DOS_Error_36 ) ;
end ;


function Text_DOS_Error_38 : AnsiString ;

begin
    Text_DOS_Error_38 :=
        Get_Text( ID_Text_DOS_Error_38, _Text_DOS_Error_38 ) ;
end ;


function Text_DOS_Error_50 : AnsiString ;

begin
    Text_DOS_Error_50 :=
        Get_Text( ID_Text_DOS_Error_50, _Text_DOS_Error_50 ) ;
end ;


function Text_DOS_Error_51 : AnsiString ;

begin
    Text_DOS_Error_51 :=
        Get_Text( ID_Text_DOS_Error_51, _Text_DOS_Error_51 ) ;
end ;


function Text_DOS_Error_52 : AnsiString ;

begin
    Text_DOS_Error_52 :=
        Get_Text( ID_Text_DOS_Error_52, _Text_DOS_Error_52 ) ;
end ;


function Text_DOS_Error_53 : AnsiString ;

begin
    Text_DOS_Error_53 :=
        Get_Text( ID_Text_DOS_Error_53, _Text_DOS_Error_53 ) ;
end ;


function Text_DOS_Error_54 : AnsiString ;

begin
    Text_DOS_Error_54 :=
        Get_Text( ID_Text_DOS_Error_54, _Text_DOS_Error_54 ) ;
end ;


function Text_DOS_Error_55 : AnsiString ;

begin
    Text_DOS_Error_55 :=
        Get_Text( ID_Text_DOS_Error_55, _Text_DOS_Error_55 ) ;
end ;


function Text_DOS_Error_56 : AnsiString ;

begin
    Text_DOS_Error_56 :=
        Get_Text( ID_Text_DOS_Error_56, _Text_DOS_Error_56 ) ;
end ;


function Text_DOS_Error_57 : AnsiString ;

begin
    Text_DOS_Error_57 :=
        Get_Text( ID_Text_DOS_Error_57, _Text_DOS_Error_57 ) ;
end ;


function Text_DOS_Error_58 : AnsiString ;

begin
    Text_DOS_Error_58 :=
        Get_Text( ID_Text_DOS_Error_58, _Text_DOS_Error_58 ) ;
end ;


function Text_DOS_Error_59 : AnsiString ;

begin
    Text_DOS_Error_59 :=
        Get_Text( ID_Text_DOS_Error_59, _Text_DOS_Error_59 ) ;
end ;


function Text_DOS_Error_60 : AnsiString ;

begin
    Text_DOS_Error_60 :=
        Get_Text( ID_Text_DOS_Error_60, _Text_DOS_Error_60 ) ;
end ;


function Text_DOS_Error_61 : AnsiString ;

begin
    Text_DOS_Error_61 :=
        Get_Text( ID_Text_DOS_Error_61, _Text_DOS_Error_61 ) ;
end ;


function Text_DOS_Error_62 : AnsiString ;

begin
    Text_DOS_Error_62 :=
        Get_Text( ID_Text_DOS_Error_62, _Text_DOS_Error_62 ) ;
end ;


function Text_DOS_Error_63 : AnsiString ;

begin
    Text_DOS_Error_63 :=
        Get_Text( ID_Text_DOS_Error_63, _Text_DOS_Error_63 ) ;
end ;


function Text_DOS_Error_64 : AnsiString ;

begin
    Text_DOS_Error_64 :=
        Get_Text( ID_Text_DOS_Error_64, _Text_DOS_Error_64 ) ;
end ;


function Text_DOS_Error_65 : AnsiString ;

begin
    Text_DOS_Error_65 :=
        Get_Text( ID_Text_DOS_Error_65, _Text_DOS_Error_65 ) ;
end ;


function Text_DOS_Error_66 : AnsiString ;

begin
    Text_DOS_Error_66 :=
        Get_Text( ID_Text_DOS_Error_66, _Text_DOS_Error_66 ) ;
end ;


function Text_DOS_Error_67 : AnsiString ;

begin
    Text_DOS_Error_67 :=
        Get_Text( ID_Text_DOS_Error_67, _Text_DOS_Error_67 ) ;
end ;


function Text_DOS_Error_68 : AnsiString ;

begin
    Text_DOS_Error_68 :=
        Get_Text( ID_Text_DOS_Error_68, _Text_DOS_Error_68 ) ;
end ;


function Text_DOS_Error_69 : AnsiString ;

begin
    Text_DOS_Error_69 :=
        Get_Text( ID_Text_DOS_Error_69, _Text_DOS_Error_69 ) ;
end ;


function Text_DOS_Error_70 : AnsiString ;

begin
    Text_DOS_Error_70 :=
        Get_Text( ID_Text_DOS_Error_70, _Text_DOS_Error_70 ) ;
end ;


function Text_DOS_Error_71 : AnsiString ;

begin
    Text_DOS_Error_71 :=
        Get_Text( ID_Text_DOS_Error_71, _Text_DOS_Error_71 ) ;
end ;


function Text_DOS_Error_72 : AnsiString ;

begin
    Text_DOS_Error_72 :=
        Get_Text( ID_Text_DOS_Error_72, _Text_DOS_Error_72 ) ;
end ;


function Text_DOS_Error_80 : AnsiString ;

begin
    Text_DOS_Error_80 :=
        Get_Text( ID_Text_DOS_Error_80, _Text_DOS_Error_80 ) ;
end ;


function Text_DOS_Error_81 : AnsiString ;

begin
    Text_DOS_Error_81 :=
        Get_Text( ID_Text_DOS_Error_81, _Text_DOS_Error_81 ) ;
end ;


function Text_DOS_Error_82 : AnsiString ;

begin
    Text_DOS_Error_82 :=
        Get_Text( ID_Text_DOS_Error_82, _Text_DOS_Error_82 ) ;
end ;


function Text_DOS_Error_83 : AnsiString ;

begin
    Text_DOS_Error_83 :=
        Get_Text( ID_Text_DOS_Error_83, _Text_DOS_Error_83 ) ;
end ;


function Text_DOS_Error_84 : AnsiString ;

begin
    Text_DOS_Error_84 :=
        Get_Text( ID_Text_DOS_Error_84, _Text_DOS_Error_84 ) ;
end ;


function Text_DOS_Error_85 : AnsiString ;

begin
    Text_DOS_Error_85 :=
        Get_Text( ID_Text_DOS_Error_85, _Text_DOS_Error_85 ) ;
end ;


function Text_DOS_Error_86 : AnsiString ;

begin
    Text_DOS_Error_86 :=
        Get_Text( ID_Text_DOS_Error_86, _Text_DOS_Error_86 ) ;
end ;


function Text_DOS_Error_87 : AnsiString ;

begin
    Text_DOS_Error_87 :=
        Get_Text( ID_Text_DOS_Error_87, _Text_DOS_Error_87 ) ;
end ;


function Text_DOS_Error_88 : AnsiString ;

begin
    Text_DOS_Error_88 :=
        Get_Text( ID_Text_DOS_Error_88, _Text_DOS_Error_88 ) ;
end ;


function Text_DOS_Error_89 : AnsiString ;

begin
    Text_DOS_Error_89 :=
        Get_Text( ID_Text_DOS_Error_89, _Text_DOS_Error_89 ) ;
end ;


function Text_DOS_Error_90 : AnsiString ;

begin
    Text_DOS_Error_90 :=
        Get_Text( ID_Text_DOS_Error_90, _Text_DOS_Error_90 ) ;
end ;


function Text_DOS_Error_91 : AnsiString ;

begin
    Text_DOS_Error_91 :=
        Get_Text( ID_Text_DOS_Error_91, _Text_DOS_Error_91 ) ;
end ;


function Text_DOS_Error_92 : AnsiString ;

begin
    Text_DOS_Error_92 :=
        Get_Text( ID_Text_DOS_Error_92, _Text_DOS_Error_92 ) ;
end ;


function Text_DOS_Error_93 : AnsiString ;

begin
    Text_DOS_Error_93 :=
        Get_Text( ID_Text_DOS_Error_93, _Text_DOS_Error_93 ) ;
end ;


function Text_DOS_Error_95 : AnsiString ;

begin
    Text_DOS_Error_95 :=
        Get_Text( ID_Text_DOS_Error_95, _Text_DOS_Error_95 ) ;
end ;


function Text_DOS_Error_100 : AnsiString ;

begin
    Text_DOS_Error_100 :=
        Get_Text( ID_Text_DOS_Error_100, _Text_DOS_Error_100 ) ;
end ;


function Text_DOS_Error_101 : AnsiString ;

begin
    Text_DOS_Error_101 :=
        Get_Text( ID_Text_DOS_Error_101, _Text_DOS_Error_101 ) ;
end ;


function Text_DOS_Error_102 : AnsiString ;

begin
    Text_DOS_Error_102 :=
        Get_Text( ID_Text_DOS_Error_102, _Text_DOS_Error_102 ) ;
end ;


function Text_DOS_Error_103 : AnsiString ;

begin
    Text_DOS_Error_103 :=
        Get_Text( ID_Text_DOS_Error_103, _Text_DOS_Error_103 ) ;
end ;


function Text_DOS_Error_104 : AnsiString ;

begin
    Text_DOS_Error_104 :=
        Get_Text( ID_Text_DOS_Error_104, _Text_DOS_Error_104 ) ;
end ;


function Text_DOS_Error_105 : AnsiString ;

begin
    Text_DOS_Error_105 :=
        Get_Text( ID_Text_DOS_Error_105, _Text_DOS_Error_105 ) ;
end ;


function Text_DOS_Error_106 : AnsiString ;

begin
    Text_DOS_Error_106 :=
        Get_Text( ID_Text_DOS_Error_106, _Text_DOS_Error_106 ) ;
end ;


function Text_DOS_Error_107 : AnsiString ;

begin
    Text_DOS_Error_107 :=
        Get_Text( ID_Text_DOS_Error_107, _Text_DOS_Error_107 ) ;
end ;


function Text_DOS_Error_108 : AnsiString ;

begin
    Text_DOS_Error_108 :=
        Get_Text( ID_Text_DOS_Error_108, _Text_DOS_Error_108 ) ;
end ;


function Text_DOS_Error_109 : AnsiString ;

begin
    Text_DOS_Error_109 :=
        Get_Text( ID_Text_DOS_Error_109, _Text_DOS_Error_109 ) ;
end ;


function Text_DOS_Error_110 : AnsiString ;

begin
    Text_DOS_Error_110 :=
        Get_Text( ID_Text_DOS_Error_110, _Text_DOS_Error_110 ) ;
end ;


function Text_DOS_Error_111 : AnsiString ;

begin
    Text_DOS_Error_111 :=
        Get_Text( ID_Text_DOS_Error_111, _Text_DOS_Error_111 ) ;
end ;


function Text_DOS_Error_112 : AnsiString ;

begin
    Text_DOS_Error_112 :=
        Get_Text( ID_Text_DOS_Error_112, _Text_DOS_Error_112 ) ;
end ;


function Text_DOS_Error_113 : AnsiString ;

begin
    Text_DOS_Error_113 :=
        Get_Text( ID_Text_DOS_Error_113, _Text_DOS_Error_113 ) ;
end ;


function Text_DOS_Error_114 : AnsiString ;

begin
    Text_DOS_Error_114 :=
        Get_Text( ID_Text_DOS_Error_114, _Text_DOS_Error_114 ) ;
end ;


function Text_DOS_Error_115 : AnsiString ;

begin
    Text_DOS_Error_115 :=
        Get_Text( ID_Text_DOS_Error_115, _Text_DOS_Error_115 ) ;
end ;


function Text_DOS_Error_116 : AnsiString ;

begin
    Text_DOS_Error_116 :=
        Get_Text( ID_Text_DOS_Error_116, _Text_DOS_Error_116 ) ;
end ;


function Text_DOS_Error_117 : AnsiString ;

begin
    Text_DOS_Error_117 :=
        Get_Text( ID_Text_DOS_Error_117, _Text_DOS_Error_117 ) ;
end ;


function Text_DOS_Error_118 : AnsiString ;

begin
    Text_DOS_Error_118 :=
        Get_Text( ID_Text_DOS_Error_118, _Text_DOS_Error_118 ) ;
end ;


function Text_DOS_Error_119 : AnsiString ;

begin
    Text_DOS_Error_119 :=
        Get_Text( ID_Text_DOS_Error_119, _Text_DOS_Error_119 ) ;
end ;


function Text_DOS_Error_120 : AnsiString ;

begin
    Text_DOS_Error_120 :=
        Get_Text( ID_Text_DOS_Error_120, _Text_DOS_Error_120 ) ;
end ;


function Text_DOS_Error_121 : AnsiString ;

begin
    Text_DOS_Error_121 :=
        Get_Text( ID_Text_DOS_Error_121, _Text_DOS_Error_121 ) ;
end ;


function Text_DOS_Error_122 : AnsiString ;

begin
    Text_DOS_Error_122 :=
        Get_Text( ID_Text_DOS_Error_122, _Text_DOS_Error_122 ) ;
end ;


function Text_DOS_Error_123 : AnsiString ;

begin
    Text_DOS_Error_123 :=
        Get_Text( ID_Text_DOS_Error_123, _Text_DOS_Error_123 ) ;
end ;


function Text_DOS_Error_124 : AnsiString ;

begin
    Text_DOS_Error_124 :=
        Get_Text( ID_Text_DOS_Error_124, _Text_DOS_Error_124 ) ;
end ;


function Text_DOS_Error_125 : AnsiString ;

begin
    Text_DOS_Error_125 :=
        Get_Text( ID_Text_DOS_Error_125, _Text_DOS_Error_125 ) ;
end ;


function Text_DOS_Error_126 : AnsiString ;

begin
    Text_DOS_Error_126 :=
        Get_Text( ID_Text_DOS_Error_126, _Text_DOS_Error_126 ) ;
end ;


function Text_DOS_Error_127 : AnsiString ;

begin
    Text_DOS_Error_127 :=
        Get_Text( ID_Text_DOS_Error_127, _Text_DOS_Error_127 ) ;
end ;


function Text_DOS_Error_128 : AnsiString ;

begin
    Text_DOS_Error_128 :=
        Get_Text( ID_Text_DOS_Error_128, _Text_DOS_Error_128 ) ;
end ;


function Text_DOS_Error_129 : AnsiString ;

begin
    Text_DOS_Error_129 :=
        Get_Text( ID_Text_DOS_Error_129, _Text_DOS_Error_129 ) ;
end ;


function Text_DOS_Error_130 : AnsiString ;

begin
    Text_DOS_Error_130 :=
        Get_Text( ID_Text_DOS_Error_130, _Text_DOS_Error_130 ) ;
end ;


function Text_DOS_Error_131 : AnsiString ;

begin
    Text_DOS_Error_131 :=
        Get_Text( ID_Text_DOS_Error_131, _Text_DOS_Error_131 ) ;
end ;


function Text_DOS_Error_132 : AnsiString ;

begin
    Text_DOS_Error_132 :=
        Get_Text( ID_Text_DOS_Error_132, _Text_DOS_Error_132 ) ;
end ;


function Text_DOS_Error_133 : AnsiString ;

begin
    Text_DOS_Error_133 :=
        Get_Text( ID_Text_DOS_Error_133, _Text_DOS_Error_133 ) ;
end ;


function Text_DOS_Error_134 : AnsiString ;

begin
    Text_DOS_Error_134 :=
        Get_Text( ID_Text_DOS_Error_134, _Text_DOS_Error_134 ) ;
end ;


function Text_DOS_Error_135 : AnsiString ;

begin
    Text_DOS_Error_135 :=
        Get_Text( ID_Text_DOS_Error_135, _Text_DOS_Error_135 ) ;
end ;


function Text_DOS_Error_136 : AnsiString ;

begin
    Text_DOS_Error_136 :=
        Get_Text( ID_Text_DOS_Error_136, _Text_DOS_Error_136 ) ;
end ;


function Text_DOS_Error_137 : AnsiString ;

begin
    Text_DOS_Error_137 :=
        Get_Text( ID_Text_DOS_Error_137, _Text_DOS_Error_137 ) ;
end ;


function Text_DOS_Error_138 : AnsiString ;

begin
    Text_DOS_Error_138 :=
        Get_Text( ID_Text_DOS_Error_138, _Text_DOS_Error_138 ) ;
end ;


function Text_DOS_Error_139 : AnsiString ;

begin
    Text_DOS_Error_139 :=
        Get_Text( ID_Text_DOS_Error_139, _Text_DOS_Error_139 ) ;
end ;


function Text_DOS_Error_140 : AnsiString ;

begin
    Text_DOS_Error_140 :=
        Get_Text( ID_Text_DOS_Error_140, _Text_DOS_Error_140 ) ;
end ;


function Text_DOS_Error_141 : AnsiString ;

begin
    Text_DOS_Error_141 :=
        Get_Text( ID_Text_DOS_Error_141, _Text_DOS_Error_141 ) ;
end ;


function Text_DOS_Error_142 : AnsiString ;

begin
    Text_DOS_Error_142 :=
        Get_Text( ID_Text_DOS_Error_142, _Text_DOS_Error_142 ) ;
end ;


function Text_DOS_Error_143 : AnsiString ;

begin
    Text_DOS_Error_143 :=
        Get_Text( ID_Text_DOS_Error_143, _Text_DOS_Error_143 ) ;
end ;


function Text_DOS_Error_144 : AnsiString ;

begin
    Text_DOS_Error_144 :=
        Get_Text( ID_Text_DOS_Error_144, _Text_DOS_Error_144 ) ;
end ;


function Text_DOS_Error_145 : AnsiString ;

begin
    Text_DOS_Error_145 :=
        Get_Text( ID_Text_DOS_Error_145, _Text_DOS_Error_145 ) ;
end ;


function Text_DOS_Error_146 : AnsiString ;

begin
    Text_DOS_Error_146 :=
        Get_Text( ID_Text_DOS_Error_146, _Text_DOS_Error_146 ) ;
end ;


function Text_DOS_Error_147 : AnsiString ;

begin
    Text_DOS_Error_147 :=
        Get_Text( ID_Text_DOS_Error_147, _Text_DOS_Error_147 ) ;
end ;


function Text_DOS_Error_148 : AnsiString ;

begin
    Text_DOS_Error_148 :=
        Get_Text( ID_Text_DOS_Error_148, _Text_DOS_Error_148 ) ;
end ;


function Text_DOS_Error_149 : AnsiString ;

begin
    Text_DOS_Error_149 :=
        Get_Text( ID_Text_DOS_Error_149, _Text_DOS_Error_149 ) ;
end ;


function Text_DOS_Error_150 : AnsiString ;

begin
    Text_DOS_Error_150 :=
        Get_Text( ID_Text_DOS_Error_150, _Text_DOS_Error_150 ) ;
end ;


function Text_DOS_Error_151 : AnsiString ;

begin
    Text_DOS_Error_151 :=
        Get_Text( ID_Text_DOS_Error_151, _Text_DOS_Error_151 ) ;
end ;


function Text_DOS_Error_152 : AnsiString ;

begin
    Text_DOS_Error_152 :=
        Get_Text( ID_Text_DOS_Error_152, _Text_DOS_Error_152 ) ;
end ;


function Text_DOS_Error_153 : AnsiString ;

begin
    Text_DOS_Error_153 :=
        Get_Text( ID_Text_DOS_Error_153, _Text_DOS_Error_153 ) ;
end ;


function Text_DOS_Error_154 : AnsiString ;

begin
    Text_DOS_Error_154 :=
        Get_Text( ID_Text_DOS_Error_154, _Text_DOS_Error_154 ) ;
end ;


function Text_DOS_Error_155 : AnsiString ;

begin
    Text_DOS_Error_155 :=
        Get_Text( ID_Text_DOS_Error_155, _Text_DOS_Error_155 ) ;
end ;


function Text_DOS_Error_156 : AnsiString ;

begin
    Text_DOS_Error_156 :=
        Get_Text( ID_Text_DOS_Error_156, _Text_DOS_Error_156 ) ;
end ;


function Text_DOS_Error_157 : AnsiString ;

begin
    Text_DOS_Error_157 :=
        Get_Text( ID_Text_DOS_Error_157, _Text_DOS_Error_157 ) ;
end ;


function Text_DOS_Error_158 : AnsiString ;

begin
    Text_DOS_Error_158 :=
        Get_Text( ID_Text_DOS_Error_158, _Text_DOS_Error_158 ) ;
end ;


function Text_DOS_Error_159 : AnsiString ;

begin
    Text_DOS_Error_159 :=
        Get_Text( ID_Text_DOS_Error_159, _Text_DOS_Error_159 ) ;
end ;


function Text_DOS_Error_160 : AnsiString ;

begin
    Text_DOS_Error_160 :=
        Get_Text( ID_Text_DOS_Error_160, _Text_DOS_Error_160 ) ;
end ;


function Text_DOS_Error_161 : AnsiString ;

begin
    Text_DOS_Error_161 :=
        Get_Text( ID_Text_DOS_Error_161, _Text_DOS_Error_161 ) ;
end ;


function Text_DOS_Error_162 : AnsiString ;

begin
    Text_DOS_Error_162 :=
        Get_Text( ID_Text_DOS_Error_162, _Text_DOS_Error_162 ) ;
end ;


function Text_DOS_Error_163 : AnsiString ;

begin
    Text_DOS_Error_163 :=
        Get_Text( ID_Text_DOS_Error_163, _Text_DOS_Error_163 ) ;
end ;


function Text_DOS_Error_164 : AnsiString ;

begin
    Text_DOS_Error_164 :=
        Get_Text( ID_Text_DOS_Error_164, _Text_DOS_Error_164 ) ;
end ;


function Text_DOS_Error_165 : AnsiString ;

begin
    Text_DOS_Error_165 :=
        Get_Text( ID_Text_DOS_Error_165, _Text_DOS_Error_165 ) ;
end ;


function Text_DOS_Error_180 : AnsiString ;

begin
    Text_DOS_Error_180 :=
        Get_Text( ID_Text_DOS_Error_180, _Text_DOS_Error_180 ) ;
end ;


function Text_DOS_Error_181 : AnsiString ;

begin
    Text_DOS_Error_181 :=
        Get_Text( ID_Text_DOS_Error_181, _Text_DOS_Error_181 ) ;
end ;


function Text_DOS_Error_182 : AnsiString ;

begin
    Text_DOS_Error_182 :=
        Get_Text( ID_Text_DOS_Error_182, _Text_DOS_Error_182 ) ;
end ;


function Text_DOS_Error_183 : AnsiString ;

begin
    Text_DOS_Error_183 :=
        Get_Text( ID_Text_DOS_Error_183, _Text_DOS_Error_183 ) ;
end ;


function Text_DOS_Error_184 : AnsiString ;

begin
    Text_DOS_Error_184 :=
        Get_Text( ID_Text_DOS_Error_184, _Text_DOS_Error_184 ) ;
end ;


function Text_DOS_Error_185 : AnsiString ;

begin
    Text_DOS_Error_185 :=
        Get_Text( ID_Text_DOS_Error_185, _Text_DOS_Error_185 ) ;
end ;


function Text_DOS_Error_186 : AnsiString ;

begin
    Text_DOS_Error_186 :=
        Get_Text( ID_Text_DOS_Error_186, _Text_DOS_Error_186 ) ;
end ;


function Text_DOS_Error_187 : AnsiString ;

begin
    Text_DOS_Error_187 :=
        Get_Text( ID_Text_DOS_Error_187, _Text_DOS_Error_187 ) ;
end ;


function Text_DOS_Error_188 : AnsiString ;

begin
    Text_DOS_Error_188 :=
        Get_Text( ID_Text_DOS_Error_188, _Text_DOS_Error_188 ) ;
end ;


function Text_DOS_Error_189 : AnsiString ;

begin
    Text_DOS_Error_189 :=
        Get_Text( ID_Text_DOS_Error_189, _Text_DOS_Error_189 ) ;
end ;


function Text_DOS_Error_190 : AnsiString ;

begin
    Text_DOS_Error_190 :=
        Get_Text( ID_Text_DOS_Error_190, _Text_DOS_Error_190 ) ;
end ;


function Text_DOS_Error_191 : AnsiString ;

begin
    Text_DOS_Error_191 :=
        Get_Text( ID_Text_DOS_Error_191, _Text_DOS_Error_191 ) ;
end ;


function Text_DOS_Error_192 : AnsiString ;

begin
    Text_DOS_Error_192 :=
        Get_Text( ID_Text_DOS_Error_192, _Text_DOS_Error_192 ) ;
end ;


function Text_DOS_Error_193 : AnsiString ;

begin
    Text_DOS_Error_193 :=
        Get_Text( ID_Text_DOS_Error_193, _Text_DOS_Error_193 ) ;
end ;


function Text_DOS_Error_194 : AnsiString ;

begin
    Text_DOS_Error_194 :=
        Get_Text( ID_Text_DOS_Error_194, _Text_DOS_Error_194 ) ;
end ;


function Text_DOS_Error_195 : AnsiString ;

begin
    Text_DOS_Error_195 :=
        Get_Text( ID_Text_DOS_Error_195, _Text_DOS_Error_195 ) ;
end ;


function Text_DOS_Error_196 : AnsiString ;

begin
    Text_DOS_Error_196 :=
        Get_Text( ID_Text_DOS_Error_196, _Text_DOS_Error_196 ) ;
end ;


function Text_DOS_Error_197 : AnsiString ;

begin
    Text_DOS_Error_197 :=
        Get_Text( ID_Text_DOS_Error_197, _Text_DOS_Error_197 ) ;
end ;


function Text_DOS_Error_198 : AnsiString ;

begin
    Text_DOS_Error_198 :=
        Get_Text( ID_Text_DOS_Error_198, _Text_DOS_Error_198 ) ;
end ;


function Text_DOS_Error_199 : AnsiString ;

begin
    Text_DOS_Error_199 :=
        Get_Text( ID_Text_DOS_Error_199, _Text_DOS_Error_199 ) ;
end ;


function Text_DOS_Error_200 : AnsiString ;

begin
    Text_DOS_Error_200 :=
        Get_Text( ID_Text_DOS_Error_200, _Text_DOS_Error_200 ) ;
end ;


function Text_DOS_Error_201 : AnsiString ;

begin
    Text_DOS_Error_201 :=
        Get_Text( ID_Text_DOS_Error_201, _Text_DOS_Error_201 ) ;
end ;


function Text_DOS_Error_202 : AnsiString ;

begin
    Text_DOS_Error_202 :=
        Get_Text( ID_Text_DOS_Error_202, _Text_DOS_Error_202 ) ;
end ;


function Text_DOS_Error_203 : AnsiString ;

begin
    Text_DOS_Error_203 :=
        Get_Text( ID_Text_DOS_Error_203, _Text_DOS_Error_203 ) ;
end ;


function Text_DOS_Error_204 : AnsiString ;

begin
    Text_DOS_Error_204 :=
        Get_Text( ID_Text_DOS_Error_204, _Text_DOS_Error_204 ) ;
end ;


function Text_DOS_Error_205 : AnsiString ;

begin
    Text_DOS_Error_205 :=
        Get_Text( ID_Text_DOS_Error_205, _Text_DOS_Error_205 ) ;
end ;


function Text_DOS_Error_206 : AnsiString ;

begin
    Text_DOS_Error_206 :=
        Get_Text( ID_Text_DOS_Error_206, _Text_DOS_Error_206 ) ;
end ;


function Text_DOS_Error_207 : AnsiString ;

begin
    Text_DOS_Error_207 :=
        Get_Text( ID_Text_DOS_Error_207, _Text_DOS_Error_207 ) ;
end ;


function Text_DOS_Error_208 : AnsiString ;

begin
    Text_DOS_Error_208 :=
        Get_Text( ID_Text_DOS_Error_208, _Text_DOS_Error_208 ) ;
end ;


function Text_DOS_Error_209 : AnsiString ;

begin
    Text_DOS_Error_209 :=
        Get_Text( ID_Text_DOS_Error_209, _Text_DOS_Error_209 ) ;
end ;


function Text_DOS_Error_210 : AnsiString ;

begin
    Text_DOS_Error_210 :=
        Get_Text( ID_Text_DOS_Error_210, _Text_DOS_Error_210 ) ;
end ;


function Text_DOS_Error_211 : AnsiString ;

begin
    Text_DOS_Error_211 :=
        Get_Text( ID_Text_DOS_Error_211, _Text_DOS_Error_211 ) ;
end ;


function Text_DOS_Error_212 : AnsiString ;

begin
    Text_DOS_Error_212 :=
        Get_Text( ID_Text_DOS_Error_212, _Text_DOS_Error_212 ) ;
end ;


function Text_DOS_Error_213 : AnsiString ;

begin
    Text_DOS_Error_213 :=
        Get_Text( ID_Text_DOS_Error_213, _Text_DOS_Error_213 ) ;
end ;


function Text_DOS_Error_214 : AnsiString ;

begin
    Text_DOS_Error_214 :=
        Get_Text( ID_Text_DOS_Error_214, _Text_DOS_Error_214 ) ;
end ;


function Text_DOS_Error_215 : AnsiString ;

begin
    Text_DOS_Error_215 :=
        Get_Text( ID_Text_DOS_Error_215, _Text_DOS_Error_215 ) ;
end ;


function Text_DOS_Error_216 : AnsiString ;

begin
    Text_DOS_Error_216 :=
        Get_Text( ID_Text_DOS_Error_216, _Text_DOS_Error_216 ) ;
end ;


function Text_DOS_Error_600 : AnsiString ;

begin
    Text_DOS_Error_600 :=
        Get_Text( ID_Text_DOS_Error_600, _Text_DOS_Error_600 ) ;
end ;


function Text_DOS_Error_601 : AnsiString ;

begin
    Text_DOS_Error_601 :=
        Get_Text( ID_Text_DOS_Error_601, _Text_DOS_Error_601 ) ;
end ;


function Text_DOS_Error_602 : AnsiString ;

begin
    Text_DOS_Error_602 :=
        Get_Text( ID_Text_DOS_Error_602, _Text_DOS_Error_602 ) ;
end ;


function Text_DOS_Error_603 : AnsiString ;

begin
    Text_DOS_Error_603 :=
        Get_Text( ID_Text_DOS_Error_603, _Text_DOS_Error_603 ) ;
end ;


function Text_DOS_Error_604 : AnsiString ;

begin
    Text_DOS_Error_604 :=
        Get_Text( ID_Text_DOS_Error_604, _Text_DOS_Error_604 ) ;
end ;


function Text_DOS_Error_605 : AnsiString ;

begin
    Text_DOS_Error_605 :=
        Get_Text( ID_Text_DOS_Error_605, _Text_DOS_Error_605 ) ;
end ;


function Text_DOS_Error_606 : AnsiString ;

begin
    Text_DOS_Error_606 :=
        Get_Text( ID_Text_DOS_Error_606, _Text_DOS_Error_606 ) ;
end ;


function Text_DOS_Error_607 : AnsiString ;

begin
    Text_DOS_Error_607 :=
        Get_Text( ID_Text_DOS_Error_607, _Text_DOS_Error_607 ) ;
end ;


function Text_DOS_Error_608 : AnsiString ;

begin
    Text_DOS_Error_608 :=
        Get_Text( ID_Text_DOS_Error_608, _Text_DOS_Error_608 ) ;
end ;


function Text_DOS_Error_609 : AnsiString ;

begin
    Text_DOS_Error_609 :=
        Get_Text( ID_Text_DOS_Error_609, _Text_DOS_Error_609 ) ;
end ;


function Text_DOS_Error_610 : AnsiString ;

begin
    Text_DOS_Error_610 :=
        Get_Text( ID_Text_DOS_Error_610, _Text_DOS_Error_610 ) ;
end ;


function Text_DOS_Error_611 : AnsiString ;

begin
    Text_DOS_Error_611 :=
        Get_Text( ID_Text_DOS_Error_611, _Text_DOS_Error_611 ) ;
end ;


function Text_DOS_Error_612 : AnsiString ;

begin
    Text_DOS_Error_612 :=
        Get_Text( ID_Text_DOS_Error_612, _Text_DOS_Error_612 ) ;
end ;


function Text_DOS_Error_613 : AnsiString ;

begin
    Text_DOS_Error_613 :=
        Get_Text( ID_Text_DOS_Error_613, _Text_DOS_Error_613 ) ;
end ;


function Text_DOS_Error_614 : AnsiString ;

begin
    Text_DOS_Error_614 :=
        Get_Text( ID_Text_DOS_Error_614, _Text_DOS_Error_614 ) ;
end ;


function Text_DOS_Error_615 : AnsiString ;

begin
    Text_DOS_Error_615 :=
        Get_Text( ID_Text_DOS_Error_615, _Text_DOS_Error_615 ) ;
end ;


function Text_DOS_Error_616 : AnsiString ;

begin
    Text_DOS_Error_616 :=
        Get_Text( ID_Text_DOS_Error_616, _Text_DOS_Error_616 ) ;
end ;


function Text_DOS_Error_617 : AnsiString ;

begin
    Text_DOS_Error_617 :=
        Get_Text( ID_Text_DOS_Error_617, _Text_DOS_Error_617 ) ;
end ;


function Text_DOS_Error_618 : AnsiString ;

begin
    Text_DOS_Error_618 :=
        Get_Text( ID_Text_DOS_Error_618, _Text_DOS_Error_618 ) ;
end ;


function Text_DOS_Error_619 : AnsiString ;

begin
    Text_DOS_Error_619 :=
        Get_Text( ID_Text_DOS_Error_619, _Text_DOS_Error_619 ) ;
end ;


function Text_DOS_Error_620 : AnsiString ;

begin
    Text_DOS_Error_620 :=
        Get_Text( ID_Text_DOS_Error_620, _Text_DOS_Error_620 ) ;
end ;


function Text_DOS_Error_621 : AnsiString ;

begin
    Text_DOS_Error_621 :=
        Get_Text( ID_Text_DOS_Error_621, _Text_DOS_Error_621 ) ;
end ;


function Text_DOS_Error_622 : AnsiString ;

begin
    Text_DOS_Error_622 :=
        Get_Text( ID_Text_DOS_Error_622, _Text_DOS_Error_622 ) ;
end ;


function Text_DOS_Error_623 : AnsiString ;

begin
    Text_DOS_Error_623 :=
        Get_Text( ID_Text_DOS_Error_623, _Text_DOS_Error_623 ) ;
end ;


function Text_DOS_Error_624 : AnsiString ;

begin
    Text_DOS_Error_624 :=
        Get_Text( ID_Text_DOS_Error_624, _Text_DOS_Error_624 ) ;
end ;


function Text_DOS_Error_625 : AnsiString ;

begin
    Text_DOS_Error_625 :=
        Get_Text( ID_Text_DOS_Error_625, _Text_DOS_Error_625 ) ;
end ;


function Text_DOS_Error_626 : AnsiString ;

begin
    Text_DOS_Error_626 :=
        Get_Text( ID_Text_DOS_Error_626, _Text_DOS_Error_626 ) ;
end ;


function Text_DOS_Error_627 : AnsiString ;

begin
    Text_DOS_Error_627 :=
        Get_Text( ID_Text_DOS_Error_627, _Text_DOS_Error_627 ) ;
end ;


function Text_DOS_Error_628 : AnsiString ;

begin
    Text_DOS_Error_628 :=
        Get_Text( ID_Text_DOS_Error_628, _Text_DOS_Error_628 ) ;
end ;


function Text_DOS_Error_629 : AnsiString ;

begin
    Text_DOS_Error_629 :=
        Get_Text( ID_Text_DOS_Error_629, _Text_DOS_Error_629 ) ;
end ;


function Text_DOS_Error_630 : AnsiString ;

begin
    Text_DOS_Error_630 :=
        Get_Text( ID_Text_DOS_Error_630, _Text_DOS_Error_630 ) ;
end ;


function Text_DOS_Error_631 : AnsiString ;

begin
    Text_DOS_Error_631 :=
        Get_Text( ID_Text_DOS_Error_631, _Text_DOS_Error_631 ) ;
end ;


function Text_DOS_Error_632 : AnsiString ;

begin
    Text_DOS_Error_632 :=
        Get_Text( ID_Text_DOS_Error_632, _Text_DOS_Error_632 ) ;
end ;


function Text_DOS_Error_633 : AnsiString ;

begin
    Text_DOS_Error_633 :=
        Get_Text( ID_Text_DOS_Error_633, _Text_DOS_Error_633 ) ;
end ;


function Text_DOS_Error_634 : AnsiString ;

begin
    Text_DOS_Error_634 :=
        Get_Text( ID_Text_DOS_Error_634, _Text_DOS_Error_634 ) ;
end ;


function Text_DOS_Error_635 : AnsiString ;

begin
    Text_DOS_Error_635 :=
        Get_Text( ID_Text_DOS_Error_635, _Text_DOS_Error_635 ) ;
end ;


function Text_DOS_Error_636 : AnsiString ;

begin
    Text_DOS_Error_636 :=
        Get_Text( ID_Text_DOS_Error_636, _Text_DOS_Error_636 ) ;
end ;


function Text_DOS_Error_637 : AnsiString ;

begin
    Text_DOS_Error_637 :=
        Get_Text( ID_Text_DOS_Error_637, _Text_DOS_Error_637 ) ;
end ;


function Text_DOS_Error_638 : AnsiString ;

begin
    Text_DOS_Error_638 :=
        Get_Text( ID_Text_DOS_Error_638, _Text_DOS_Error_638 ) ;
end ;


function Text_DOS_Error_639 : AnsiString ;

begin
    Text_DOS_Error_639 :=
        Get_Text( ID_Text_DOS_Error_639, _Text_DOS_Error_639 ) ;
end ;


function Text_DOS_Error_640 : AnsiString ;

begin
    Text_DOS_Error_640 :=
        Get_Text( ID_Text_DOS_Error_640, _Text_DOS_Error_640 ) ;
end ;


function Text_DOS_Error_641 : AnsiString ;

begin
    Text_DOS_Error_641 :=
        Get_Text( ID_Text_DOS_Error_641, _Text_DOS_Error_641 ) ;
end ;


function Text_DOS_Error_642 : AnsiString ;

begin
    Text_DOS_Error_642 :=
        Get_Text( ID_Text_DOS_Error_642, _Text_DOS_Error_642 ) ;
end ;


function Text_DOS_Error_643 : AnsiString ;

begin
    Text_DOS_Error_643 :=
        Get_Text( ID_Text_DOS_Error_643, _Text_DOS_Error_643 ) ;
end ;


function Text_DOS_Error_644 : AnsiString ;

begin
    Text_DOS_Error_644 :=
        Get_Text( ID_Text_DOS_Error_644, _Text_DOS_Error_644 ) ;
end ;


function Text_DOS_Error_645 : AnsiString ;

begin
    Text_DOS_Error_645 :=
        Get_Text( ID_Text_DOS_Error_645, _Text_DOS_Error_645 ) ;
end ;


function Text_DOS_Error_646 : AnsiString ;

begin
    Text_DOS_Error_646 :=
        Get_Text( ID_Text_DOS_Error_646, _Text_DOS_Error_646 ) ;
end ;


function Text_DOS_Error_647 : AnsiString ;

begin
    Text_DOS_Error_647 :=
        Get_Text( ID_Text_DOS_Error_647, _Text_DOS_Error_647 ) ;
end ;


function Text_DOS_Error_648 : AnsiString ;

begin
    Text_DOS_Error_648 :=
        Get_Text( ID_Text_DOS_Error_648, _Text_DOS_Error_648 ) ;
end ;


function Text_DOS_Error_649 : AnsiString ;

begin
    Text_DOS_Error_649 :=
        Get_Text( ID_Text_DOS_Error_649, _Text_DOS_Error_649 ) ;
end ;


function Text_DOS_Error_650 : AnsiString ;

begin
    Text_DOS_Error_650 :=
        Get_Text( ID_Text_DOS_Error_650, _Text_DOS_Error_650 ) ;
end ;


function Text_DOS_Error_651 : AnsiString ;

begin
    Text_DOS_Error_651 :=
        Get_Text( ID_Text_DOS_Error_651, _Text_DOS_Error_651 ) ;
end ;


function Text_DOS_Error_652 : AnsiString ;

begin
    Text_DOS_Error_652 :=
        Get_Text( ID_Text_DOS_Error_652, _Text_DOS_Error_652 ) ;
end ;


function Text_DOS_Error_653 : AnsiString ;

begin
    Text_DOS_Error_653 :=
        Get_Text( ID_Text_DOS_Error_653, _Text_DOS_Error_653 ) ;
end ;


function Text_DOS_Error_654 : AnsiString ;

begin
    Text_DOS_Error_654 :=
        Get_Text( ID_Text_DOS_Error_654, _Text_DOS_Error_654 ) ;
end ;


function Text_DOS_Error_655 : AnsiString ;

begin
    Text_DOS_Error_655 :=
        Get_Text( ID_Text_DOS_Error_655, _Text_DOS_Error_655 ) ;
end ;


function Text_DOS_Error_656 : AnsiString ;

begin
    Text_DOS_Error_656 :=
        Get_Text( ID_Text_DOS_Error_656, _Text_DOS_Error_656 ) ;
end ;


function Text_DOS_Error_657 : AnsiString ;

begin
    Text_DOS_Error_657 :=
        Get_Text( ID_Text_DOS_Error_657, _Text_DOS_Error_657 ) ;
end ;


function Text_DOS_Error_658 : AnsiString ;

begin
    Text_DOS_Error_658 :=
        Get_Text( ID_Text_DOS_Error_658, _Text_DOS_Error_658 ) ;
end ;


function Text_DOS_Error_659 : AnsiString ;

begin
    Text_DOS_Error_659 :=
        Get_Text( ID_Text_DOS_Error_659, _Text_DOS_Error_659 ) ;
end ;


function Text_DOS_Error_660 : AnsiString ;

begin
    Text_DOS_Error_660 :=
        Get_Text( ID_Text_DOS_Error_660, _Text_DOS_Error_660 ) ;
end ;


function Text_DOS_Error_661 : AnsiString ;

begin
    Text_DOS_Error_661 :=
        Get_Text( ID_Text_DOS_Error_661, _Text_DOS_Error_661 ) ;
end ;


function Text_DOS_Error_662 : AnsiString ;

begin
    Text_DOS_Error_662 :=
        Get_Text( ID_Text_DOS_Error_662, _Text_DOS_Error_662 ) ;
end ;


function Text_DOS_Error_663 : AnsiString ;

begin
    Text_DOS_Error_663 :=
        Get_Text( ID_Text_DOS_Error_663, _Text_DOS_Error_663 ) ;
end ;


function Text_DOS_Error_664 : AnsiString ;

begin
    Text_DOS_Error_664 :=
        Get_Text( ID_Text_DOS_Error_664, _Text_DOS_Error_664 ) ;
end ;


function Text_DOS_Error_665 : AnsiString ;

begin
    Text_DOS_Error_665 :=
        Get_Text( ID_Text_DOS_Error_665, _Text_DOS_Error_665 ) ;
end ;


function Text_DOS_Error_666 : AnsiString ;

begin
    Text_DOS_Error_666 :=
        Get_Text( ID_Text_DOS_Error_666, _Text_DOS_Error_666 ) ;
end ;


function Text_DOS_Error_667 : AnsiString ;

begin
    Text_DOS_Error_667 :=
        Get_Text( ID_Text_DOS_Error_667, _Text_DOS_Error_667 ) ;
end ;


function Text_DOS_Error_668 : AnsiString ;

begin
    Text_DOS_Error_668 :=
        Get_Text( ID_Text_DOS_Error_668, _Text_DOS_Error_668 ) ;
end ;


function Text_DOS_Error_669 : AnsiString ;

begin
    Text_DOS_Error_669 :=
        Get_Text( ID_Text_DOS_Error_669, _Text_DOS_Error_669 ) ;
end ;


function Text_DOS_Error_670 : AnsiString ;

begin
    Text_DOS_Error_670 :=
        Get_Text( ID_Text_DOS_Error_670, _Text_DOS_Error_670 ) ;
end ;


function Text_DOS_Error_671 : AnsiString ;

begin
    Text_DOS_Error_671 :=
        Get_Text( ID_Text_DOS_Error_671, _Text_DOS_Error_671 ) ;
end ;


function Text_DOS_Error_672 : AnsiString ;

begin
    Text_DOS_Error_672 :=
        Get_Text( ID_Text_DOS_Error_672, _Text_DOS_Error_672 ) ;
end ;


function Text_DOS_Error_673 : AnsiString ;

begin
    Text_DOS_Error_673 :=
        Get_Text( ID_Text_DOS_Error_673, _Text_DOS_Error_673 ) ;
end ;


function Text_DOS_Error_674 : AnsiString ;

begin
    Text_DOS_Error_674 :=
        Get_Text( ID_Text_DOS_Error_674, _Text_DOS_Error_674 ) ;
end ;


function Text_DOS_Error_675 : AnsiString ;

begin
    Text_DOS_Error_675 :=
        Get_Text( ID_Text_DOS_Error_675, _Text_DOS_Error_675 ) ;
end ;


function Text_DOS_Error_676 : AnsiString ;

begin
    Text_DOS_Error_676 :=
        Get_Text( ID_Text_DOS_Error_676, _Text_DOS_Error_676 ) ;
end ;


function Text_DOS_Error_677 : AnsiString ;

begin
    Text_DOS_Error_677 :=
        Get_Text( ID_Text_DOS_Error_677, _Text_DOS_Error_677 ) ;
end ;


function Text_DOS_Error_678 : AnsiString ;

begin
    Text_DOS_Error_678 :=
        Get_Text( ID_Text_DOS_Error_678, _Text_DOS_Error_678 ) ;
end ;


function Text_DOS_Error_679 : AnsiString ;

begin
    Text_DOS_Error_679 :=
        Get_Text( ID_Text_DOS_Error_679, _Text_DOS_Error_679 ) ;
end ;


function Text_DOS_Error_680 : AnsiString ;

begin
    Text_DOS_Error_680 :=
        Get_Text( ID_Text_DOS_Error_680, _Text_DOS_Error_680 ) ;
end ;


function Text_DOS_Error_681 : AnsiString ;

begin
    Text_DOS_Error_681 :=
        Get_Text( ID_Text_DOS_Error_681, _Text_DOS_Error_681 ) ;
end ;


function Text_DOS_Error_682 : AnsiString ;

begin
    Text_DOS_Error_682 :=
        Get_Text( ID_Text_DOS_Error_682, _Text_DOS_Error_682 ) ;
end ;


function Text_DOS_Error_683 : AnsiString ;

begin
    Text_DOS_Error_683 :=
        Get_Text( ID_Text_DOS_Error_683, _Text_DOS_Error_683 ) ;
end ;


function Text_DOS_Error_684 : AnsiString ;

begin
    Text_DOS_Error_684 :=
        Get_Text( ID_Text_DOS_Error_684, _Text_DOS_Error_684 ) ;
end ;


function Text_DOS_Error_685 : AnsiString ;

begin
    Text_DOS_Error_685 :=
        Get_Text( ID_Text_DOS_Error_685, _Text_DOS_Error_685 ) ;
end ;


function Text_DOS_Error_686 : AnsiString ;

begin
    Text_DOS_Error_686 :=
        Get_Text( ID_Text_DOS_Error_686, _Text_DOS_Error_686 ) ;
end ;


function Text_DOS_Error_687 : AnsiString ;

begin
    Text_DOS_Error_687 :=
        Get_Text( ID_Text_DOS_Error_687, _Text_DOS_Error_687 ) ;
end ;


function Text_DOS_Error_688 : AnsiString ;

begin
    Text_DOS_Error_688 :=
        Get_Text( ID_Text_DOS_Error_688, _Text_DOS_Error_688 ) ;
end ;


function Text_DOS_Error_689 : AnsiString ;

begin
    Text_DOS_Error_689 :=
        Get_Text( ID_Text_DOS_Error_689, _Text_DOS_Error_689 ) ;
end ;


function Text_DOS_Error_690 : AnsiString ;

begin
    Text_DOS_Error_690 :=
        Get_Text( ID_Text_DOS_Error_690, _Text_DOS_Error_690 ) ;
end ;


function Text_DOS_Error_691 : AnsiString ;

begin
    Text_DOS_Error_691 :=
        Get_Text( ID_Text_DOS_Error_691, _Text_DOS_Error_691 ) ;
end ;


function Text_DOS_Error_692 : AnsiString ;

begin
    Text_DOS_Error_692 :=
        Get_Text( ID_Text_DOS_Error_692, _Text_DOS_Error_692 ) ;
end ;


function Text_DOS_Error_693 : AnsiString ;

begin
    Text_DOS_Error_693 :=
        Get_Text( ID_Text_DOS_Error_693, _Text_DOS_Error_693 ) ;
end ;


function Text_DOS_Error_694 : AnsiString ;

begin
    Text_DOS_Error_694 :=
        Get_Text( ID_Text_DOS_Error_694, _Text_DOS_Error_694 ) ;
end ;


function Text_DOS_Error_695 : AnsiString ;

begin
    Text_DOS_Error_695 :=
        Get_Text( ID_Text_DOS_Error_695, _Text_DOS_Error_695 ) ;
end ;


function Text_DOS_Error_696 : AnsiString ;

begin
    Text_DOS_Error_696 :=
        Get_Text( ID_Text_DOS_Error_696, _Text_DOS_Error_696 ) ;
end ;


function Text_DOS_Error_697 : AnsiString ;

begin
    Text_DOS_Error_697 :=
        Get_Text( ID_Text_DOS_Error_697, _Text_DOS_Error_697 ) ;
end ;


function Text_DOS_Error_698 : AnsiString ;

begin
    Text_DOS_Error_698 :=
        Get_Text( ID_Text_DOS_Error_698, _Text_DOS_Error_698 ) ;
end ;


function Text_DOS_Error_699 : AnsiString ;

begin
    Text_DOS_Error_699 :=
        Get_Text( ID_Text_DOS_Error_699, _Text_DOS_Error_699 ) ;
end ;


function Text_DOS_Error_700 : AnsiString ;

begin
    Text_DOS_Error_700 :=
        Get_Text( ID_Text_DOS_Error_700, _Text_DOS_Error_700 ) ;
end ;


function Text_DOS_Error_701 : AnsiString ;

begin
    Text_DOS_Error_701 :=
        Get_Text( ID_Text_DOS_Error_701, _Text_DOS_Error_701 ) ;
end ;


function Text_DOS_Error_702 : AnsiString ;

begin
    Text_DOS_Error_702 :=
        Get_Text( ID_Text_DOS_Error_702, _Text_DOS_Error_702 ) ;
end ;


function Text_DOS_Error_703 : AnsiString ;

begin
    Text_DOS_Error_703 :=
        Get_Text( ID_Text_DOS_Error_703, _Text_DOS_Error_703 ) ;
end ;


function Text_DOS_Error_704 : AnsiString ;

begin
    Text_DOS_Error_704 :=
        Get_Text( ID_Text_DOS_Error_704, _Text_DOS_Error_704 ) ;
end ;


function Text_DOS_Error_705 : AnsiString ;

begin
    Text_DOS_Error_705 :=
        Get_Text( ID_Text_DOS_Error_705, _Text_DOS_Error_705 ) ;
end ;


function Text_DOS_Error_706 : AnsiString ;

begin
    Text_DOS_Error_706 :=
        Get_Text( ID_Text_DOS_Error_706, _Text_DOS_Error_706 ) ;
end ;


function Text_DOS_Error_707 : AnsiString ;

begin
    Text_DOS_Error_707 :=
        Get_Text( ID_Text_DOS_Error_707, _Text_DOS_Error_707 ) ;
end ;


function Text_DOS_Error_708 : AnsiString ;

begin
    Text_DOS_Error_708 :=
        Get_Text( ID_Text_DOS_Error_708, _Text_DOS_Error_708 ) ;
end ;


function Text_DOS_Error_709 : AnsiString ;

begin
    Text_DOS_Error_709 :=
        Get_Text( ID_Text_DOS_Error_709, _Text_DOS_Error_709 ) ;
end ;


function Text_DOS_Error_710 : AnsiString ;

begin
    Text_DOS_Error_710 :=
        Get_Text( ID_Text_DOS_Error_710, _Text_DOS_Error_710 ) ;
end ;


function Text_DOS_Error_711 : AnsiString ;

begin
    Text_DOS_Error_711 :=
        Get_Text( ID_Text_DOS_Error_711, _Text_DOS_Error_711 ) ;
end ;


function Text_DOS_Error_712 : AnsiString ;

begin
    Text_DOS_Error_712 :=
        Get_Text( ID_Text_DOS_Error_712, _Text_DOS_Error_712 ) ;
end ;


function Text_DOS_Error_713 : AnsiString ;

begin
    Text_DOS_Error_713 :=
        Get_Text( ID_Text_DOS_Error_713, _Text_DOS_Error_713 ) ;
end ;


function Text_DOS_Error_714 : AnsiString ;

begin
    Text_DOS_Error_714 :=
        Get_Text( ID_Text_DOS_Error_714, _Text_DOS_Error_714 ) ;
end ;


function Text_DOS_Error_715 : AnsiString ;

begin
    Text_DOS_Error_715 :=
        Get_Text( ID_Text_DOS_Error_715, _Text_DOS_Error_715 ) ;
end ;


function Text_DOS_Error_716 : AnsiString ;

begin
    Text_DOS_Error_716 :=
        Get_Text( ID_Text_DOS_Error_716, _Text_DOS_Error_716 ) ;
end ;


function Text_DOS_Error_717 : AnsiString ;

begin
    Text_DOS_Error_717 :=
        Get_Text( ID_Text_DOS_Error_717, _Text_DOS_Error_717 ) ;
end ;


function Text_DOS_Error_718 : AnsiString ;

begin
    Text_DOS_Error_718 :=
        Get_Text( ID_Text_DOS_Error_718, _Text_DOS_Error_718 ) ;
end ;


function Text_DOS_Error_719 : AnsiString ;

begin
    Text_DOS_Error_719 :=
        Get_Text( ID_Text_DOS_Error_719, _Text_DOS_Error_719 ) ;
end ;


function Text_DOS_Error_720 : AnsiString ;

begin
    Text_DOS_Error_720 :=
        Get_Text( ID_Text_DOS_Error_720, _Text_DOS_Error_720 ) ;
end ;


function Text_DOS_Error_721 : AnsiString ;

begin
    Text_DOS_Error_721 :=
        Get_Text( ID_Text_DOS_Error_721, _Text_DOS_Error_721 ) ;
end ;


function Text_DOS_Error_722 : AnsiString ;

begin
    Text_DOS_Error_722 :=
        Get_Text( ID_Text_DOS_Error_722, _Text_DOS_Error_722 ) ;
end ;


function Text_DOS_Error_723 : AnsiString ;

begin
    Text_DOS_Error_723 :=
        Get_Text( ID_Text_DOS_Error_723, _Text_DOS_Error_723 ) ;
end ;


function Text_DOS_Error_724 : AnsiString ;

begin
    Text_DOS_Error_724 :=
        Get_Text( ID_Text_DOS_Error_724, _Text_DOS_Error_724 ) ;
end ;


function Text_DOS_Error_725 : AnsiString ;

begin
    Text_DOS_Error_725 :=
        Get_Text( ID_Text_DOS_Error_725, _Text_DOS_Error_725 ) ;
end ;


function Text_DOS_Error_726 : AnsiString ;

begin
    Text_DOS_Error_726 :=
        Get_Text( ID_Text_DOS_Error_726, _Text_DOS_Error_726 ) ;
end ;


function Text_DOS_Error_727 : AnsiString ;

begin
    Text_DOS_Error_727 :=
        Get_Text( ID_Text_DOS_Error_727, _Text_DOS_Error_727 ) ;
end ;


function Text_DOS_Error_728 : AnsiString ;

begin
    Text_DOS_Error_728 :=
        Get_Text( ID_Text_DOS_Error_728, _Text_DOS_Error_728 ) ;
end ;


function Text_DOS_Error_729 : AnsiString ;

begin
    Text_DOS_Error_729 :=
        Get_Text( ID_Text_DOS_Error_729, _Text_DOS_Error_729 ) ;
end ;


function Text_DOS_Error_730 : AnsiString ;

begin
    Text_DOS_Error_730 :=
        Get_Text( ID_Text_DOS_Error_730, _Text_DOS_Error_730 ) ;
end ;


function Text_DOS_Error_731 : AnsiString ;

begin
    Text_DOS_Error_731 :=
        Get_Text( ID_Text_DOS_Error_731, _Text_DOS_Error_731 ) ;
end ;


function Text_DOS_Error_732 : AnsiString ;

begin
    Text_DOS_Error_732 :=
        Get_Text( ID_Text_DOS_Error_732, _Text_DOS_Error_732 ) ;
end ;


function Text_DOS_Error_733 : AnsiString ;

begin
    Text_DOS_Error_733 :=
        Get_Text( ID_Text_DOS_Error_733, _Text_DOS_Error_733 ) ;
end ;


function Text_DOS_Error_734 : AnsiString ;

begin
    Text_DOS_Error_734 :=
        Get_Text( ID_Text_DOS_Error_734, _Text_DOS_Error_734 ) ;
end ;


function Text_DOS_Error_735 : AnsiString ;

begin
    Text_DOS_Error_735 :=
        Get_Text( ID_Text_DOS_Error_735, _Text_DOS_Error_735 ) ;
end ;


function Text_DOS_Error_736 : AnsiString ;

begin
    Text_DOS_Error_736 :=
        Get_Text( ID_Text_DOS_Error_736, _Text_DOS_Error_736 ) ;
end ;


function Text_DOS_Error_737 : AnsiString ;

begin
    Text_DOS_Error_737 :=
        Get_Text( ID_Text_DOS_Error_737, _Text_DOS_Error_737 ) ;
end ;


function Text_DOS_Error_738 : AnsiString ;

begin
    Text_DOS_Error_738 :=
        Get_Text( ID_Text_DOS_Error_738, _Text_DOS_Error_738 ) ;
end ;


function Text_DOS_Error_739 : AnsiString ;

begin
    Text_DOS_Error_739 :=
        Get_Text( ID_Text_DOS_Error_739, _Text_DOS_Error_739 ) ;
end ;


function Text_DOS_Error_740 : AnsiString ;

begin
    Text_DOS_Error_740 :=
        Get_Text( ID_Text_DOS_Error_740, _Text_DOS_Error_740 ) ;
end ;


function Text_DOS_Error_741 : AnsiString ;

begin
    Text_DOS_Error_741 :=
        Get_Text( ID_Text_DOS_Error_741, _Text_DOS_Error_741 ) ;
end ;


function Text_DOS_Error_742 : AnsiString ;

begin
    Text_DOS_Error_742 :=
        Get_Text( ID_Text_DOS_Error_742, _Text_DOS_Error_742 ) ;
end ;


function Text_DOS_Error_743 : AnsiString ;

begin
    Text_DOS_Error_743 :=
        Get_Text( ID_Text_DOS_Error_743, _Text_DOS_Error_743 ) ;
end ;


function Text_DOS_Error_744 : AnsiString ;

begin
    Text_DOS_Error_744 :=
        Get_Text( ID_Text_DOS_Error_744, _Text_DOS_Error_744 ) ;
end ;


function Text_DOS_Error_752 : AnsiString ;

begin
    Text_DOS_Error_752 :=
        Get_Text( ID_Text_DOS_Error_752, _Text_DOS_Error_752 ) ;
end ;


function Text_Error_Unused_Error_Number : AnsiString ;

begin
    Text_Error_Unused_Error_Number :=
        Get_Text( ID_Text_Error_Unused_Error_Number, _Text_Error_Unused_Error_Number ) ;
end ;


function Text_Express_Error_Expected_Comma : AnsiString ;

begin
    Text_Express_Error_Expected_Comma :=
        Get_Text( ID_Text_Express_Error_Expected_Comma, _Text_Express_Error_Expected_Comma ) ;
end ;


function Text_Express_Error_Syntax_Error : AnsiString ;

begin
    Text_Express_Error_Syntax_Error :=
        Get_Text( ID_Text_Express_Error_Syntax_Error, _Text_Express_Error_Syntax_Error ) ;
end ;


function Text_Express_Error_Illegal_Symbol : AnsiString ;

begin
    Text_Express_Error_Illegal_Symbol :=
        Get_Text( ID_Text_Express_Error_Illegal_Symbol, _Text_Express_Error_Illegal_Symbol ) ;
end ;


function Text_Express_Error_Expected_Left_Parenthesis : AnsiString ;

begin
    Text_Express_Error_Expected_Left_Parenthesis :=
        Get_Text( ID_Text_Express_Error_Expected_Left_Parenthesis, _Text_Express_Error_Expected_Left_Parenthesis ) ;
end ;


function Text_Express_Error_Division_By_Zero : AnsiString ;

begin
    Text_Express_Error_Division_By_Zero :=
        Get_Text( ID_Text_Express_Error_Division_By_Zero, _Text_Express_Error_Division_By_Zero ) ;
end ;


function Text_Express_Error_Illegal_Number_for_factorial : AnsiString ;

begin
    Text_Express_Error_Illegal_Number_for_factorial :=
        Get_Text( ID_Text_Express_Error_Illegal_Number_for_factorial, _Text_Express_Error_Illegal_Number_for_factorial ) ;
end ;


function Text_Express_Error_Floating_point_error : AnsiString ;

begin
    Text_Express_Error_Floating_point_error :=
        Get_Text( ID_Text_Express_Error_Floating_point_error, _Text_Express_Error_Floating_point_error ) ;
end ;


function Text_Express_Error_Illegal_Number : AnsiString ;

begin
    Text_Express_Error_Illegal_Number :=
        Get_Text( ID_Text_Express_Error_Illegal_Number, _Text_Express_Error_Illegal_Number ) ;
end ;


function Text_Express_Error_Illegal_Argument : AnsiString ;

begin
    Text_Express_Error_Illegal_Argument :=
        Get_Text( ID_Text_Express_Error_Illegal_Argument, _Text_Express_Error_Illegal_Argument ) ;
end ;


function Text_Express_Error_Imaginary_Number : AnsiString ;

begin
    Text_Express_Error_Imaginary_Number :=
        Get_Text( ID_Text_Express_Error_Imaginary_Number, _Text_Express_Error_Imaginary_Number ) ;
end ;


function Text_Express_Error_Illegal_Argument_in_LOG : AnsiString ;

begin
    Text_Express_Error_Illegal_Argument_in_LOG :=
        Get_Text( ID_Text_Express_Error_Illegal_Argument_in_LOG, _Text_Express_Error_Illegal_Argument_in_LOG ) ;
end ;


function Text_Express_Error_Argument_Too_large_in_EXP : AnsiString ;

begin
    Text_Express_Error_Argument_Too_large_in_EXP :=
        Get_Text( ID_Text_Express_Error_Argument_Too_large_in_EXP, _Text_Express_Error_Argument_Too_large_in_EXP ) ;
end ;


function Text_Express_Error_Missing_Right_Parenthesis : AnsiString ;

begin
    Text_Express_Error_Missing_Right_Parenthesis :=
        Get_Text( ID_Text_Express_Error_Missing_Right_Parenthesis, _Text_Express_Error_Missing_Right_Parenthesis ) ;
end ;


function Text_Error_Invalid_Key_Size : AnsiString ;

begin
    Text_Error_Invalid_Key_Size :=
        Get_Text( ID_Text_Error_Invalid_Key_Size, _Text_Error_Invalid_Key_Size ) ;
end ;


function Text_Files_Unit_Was_Not_Compiled_Correctly : AnsiString ;

begin
    Text_Files_Unit_Was_Not_Compiled_Correctly :=
        Get_Text( ID_Text_Files_Unit_Was_Not_Compiled_Correctly, _Text_Files_Unit_Was_Not_Compiled_Correctly ) ;
end ;


function Text_Error_FiP_Is_A_Singleton_Object : AnsiString ;

begin
    Text_Error_FiP_Is_A_Singleton_Object :=
        Get_Text( ID_Text_Error_FiP_Is_A_Singleton_Object, _Text_Error_FiP_Is_A_Singleton_Object ) ;
end ;


function Text_Prompt_Enter_A_Filename : AnsiString ;

begin
    Text_Prompt_Enter_A_Filename :=
        Get_Text( ID_Text_Prompt_Enter_A_Filename, _Text_Prompt_Enter_A_Filename ) ;
end ;


function Text_Error_Filesys_Unit_Was_Not_Compiled_Correctly : AnsiString ;

begin
    Text_Error_Filesys_Unit_Was_Not_Compiled_Correctly :=
        Get_Text( ID_Text_Error_Filesys_Unit_Was_Not_Compiled_Correctly, _Text_Error_Filesys_Unit_Was_Not_Compiled_Correctly ) ;
end ;


function Text_Error_Invalid_Syntax : AnsiString ;

begin
    Text_Error_Invalid_Syntax :=
        Get_Text( ID_Text_Error_Invalid_Syntax, _Text_Error_Invalid_Syntax ) ;
end ;


function Text_Error_Object_Is_Missing_A_Name : AnsiString ;

begin
    Text_Error_Object_Is_Missing_A_Name :=
        Get_Text( ID_Text_Error_Object_Is_Missing_A_Name, _Text_Error_Object_Is_Missing_A_Name ) ;
end ;


function Text_Error_Expected_Colon : AnsiString ;

begin
    Text_Error_Expected_Colon :=
        Get_Text( ID_Text_Error_Expected_Colon, _Text_Error_Expected_Colon ) ;
end ;


function Text_Error_Object_Is_Missing_Type : AnsiString ;

begin
    Text_Error_Object_Is_Missing_Type :=
        Get_Text( ID_Text_Error_Object_Is_Missing_Type, _Text_Error_Object_Is_Missing_Type ) ;
end ;


function Text_Error_Expected_Equal : AnsiString ;

begin
    Text_Error_Expected_Equal :=
        Get_Text( ID_Text_Error_Expected_Equal, _Text_Error_Expected_Equal ) ;
end ;


function Text_FSErr_FileNotOpen : AnsiString ;

begin
    Text_FSErr_FileNotOpen :=
        Get_Text( ID_Text_FSErr_FileNotOpen, _Text_FSErr_FileNotOpen ) ;
end ;


function Text_FSErr_EndOfFile : AnsiString ;

begin
    Text_FSErr_EndOfFile :=
        Get_Text( ID_Text_FSErr_EndOfFile, _Text_FSErr_EndOfFile ) ;
end ;


function Text_FSErr_FileNotFound : AnsiString ;

begin
    Text_FSErr_FileNotFound :=
        Get_Text( ID_Text_FSErr_FileNotFound, _Text_FSErr_FileNotFound ) ;
end ;


function Text_FSErr_FileNameLength : AnsiString ;

begin
    Text_FSErr_FileNameLength :=
        Get_Text( ID_Text_FSErr_FileNameLength, _Text_FSErr_FileNameLength ) ;
end ;


function Text_FSErr_FileName : AnsiString ;

begin
    Text_FSErr_FileName :=
        Get_Text( ID_Text_FSErr_FileName, _Text_FSErr_FileName ) ;
end ;


function Text_FSErr_DirectoryNotFound : AnsiString ;

begin
    Text_FSErr_DirectoryNotFound :=
        Get_Text( ID_Text_FSErr_DirectoryNotFound, _Text_FSErr_DirectoryNotFound ) ;
end ;


function Text_FSErr_InvalidPath : AnsiString ;

begin
    Text_FSErr_InvalidPath :=
        Get_Text( ID_Text_FSErr_InvalidPath, _Text_FSErr_InvalidPath ) ;
end ;


function Text_FSErr_NoRoomOnDevice : AnsiString ;

begin
    Text_FSErr_NoRoomOnDevice :=
        Get_Text( ID_Text_FSErr_NoRoomOnDevice, _Text_FSErr_NoRoomOnDevice ) ;
end ;


function Text_FSErr_ProtectionViolation : AnsiString ;

begin
    Text_FSErr_ProtectionViolation :=
        Get_Text( ID_Text_FSErr_ProtectionViolation, _Text_FSErr_ProtectionViolation ) ;
end ;


function Text_FSErr_DirectoryExists : AnsiString ;

begin
    Text_FSErr_DirectoryExists :=
        Get_Text( ID_Text_FSErr_DirectoryExists, _Text_FSErr_DirectoryExists ) ;
end ;


function Text_FSErr_FileNotEmpty : AnsiString ;

begin
    Text_FSErr_FileNotEmpty :=
        Get_Text( ID_Text_FSErr_FileNotEmpty, _Text_FSErr_FileNotEmpty ) ;
end ;


function Text_FSErr_DirectoryNotEmpty : AnsiString ;

begin
    Text_FSErr_DirectoryNotEmpty :=
        Get_Text( ID_Text_FSErr_DirectoryNotEmpty, _Text_FSErr_DirectoryNotEmpty ) ;
end ;


function Text_FSErr_CorruptedFileStructure : AnsiString ;

begin
    Text_FSErr_CorruptedFileStructure :=
        Get_Text( ID_Text_FSErr_CorruptedFileStructure, _Text_FSErr_CorruptedFileStructure ) ;
end ;


function Text_FSErr_FileExists : AnsiString ;

begin
    Text_FSErr_FileExists :=
        Get_Text( ID_Text_FSErr_FileExists, _Text_FSErr_FileExists ) ;
end ;


function Text_FSErr_IllegalOperationType : AnsiString ;

begin
    Text_FSErr_IllegalOperationType :=
        Get_Text( ID_Text_FSErr_IllegalOperationType, _Text_FSErr_IllegalOperationType ) ;
end ;


function Text_FSErr_LineTooLong : AnsiString ;

begin
    Text_FSErr_LineTooLong :=
        Get_Text( ID_Text_FSErr_LineTooLong, _Text_FSErr_LineTooLong ) ;
end ;


function Text_FSErr_InvalidDevice : AnsiString ;

begin
    Text_FSErr_InvalidDevice :=
        Get_Text( ID_Text_FSErr_InvalidDevice, _Text_FSErr_InvalidDevice ) ;
end ;


function Text_FSErr_Internal_Duplicate : AnsiString ;

begin
    Text_FSErr_Internal_Duplicate :=
        Get_Text( ID_Text_FSErr_Internal_Duplicate, _Text_FSErr_Internal_Duplicate ) ;
end ;


function Text_FSErr_Invalid_Open_Mode : AnsiString ;

begin
    Text_FSErr_Invalid_Open_Mode :=
        Get_Text( ID_Text_FSErr_Invalid_Open_Mode, _Text_FSErr_Invalid_Open_Mode ) ;
end ;


function Text_FSErr_Unsupported_Operation : AnsiString ;

begin
    Text_FSErr_Unsupported_Operation :=
        Get_Text( ID_Text_FSErr_Unsupported_Operation, _Text_FSErr_Unsupported_Operation ) ;
end ;


function Text_FSErr_Device_In_Use : AnsiString ;

begin
    Text_FSErr_Device_In_Use :=
        Get_Text( ID_Text_FSErr_Device_In_Use, _Text_FSErr_Device_In_Use ) ;
end ;


function Text_FSErr_Unknown_Device_Type : AnsiString ;

begin
    Text_FSErr_Unknown_Device_Type :=
        Get_Text( ID_Text_FSErr_Unknown_Device_Type, _Text_FSErr_Unknown_Device_Type ) ;
end ;


function Text_FSErr_Internal_Error_On_Add : AnsiString ;

begin
    Text_FSErr_Internal_Error_On_Add :=
        Get_Text( ID_Text_FSErr_Internal_Error_On_Add, _Text_FSErr_Internal_Error_On_Add ) ;
end ;


function Text_FSErr_Invalid_Record_Size : AnsiString ;

begin
    Text_FSErr_Invalid_Record_Size :=
        Get_Text( ID_Text_FSErr_Invalid_Record_Size, _Text_FSErr_Invalid_Record_Size ) ;
end ;


function Text_FSErr_Internal_Corruption : AnsiString ;

begin
    Text_FSErr_Internal_Corruption :=
        Get_Text( ID_Text_FSErr_Internal_Corruption, _Text_FSErr_Internal_Corruption ) ;
end ;


function Text_FSErr_Timeout : AnsiString ;

begin
    Text_FSErr_Timeout :=
        Get_Text( ID_Text_FSErr_Timeout, _Text_FSErr_Timeout ) ;
end ;


function Text_FSErr_Invalid_Handle : AnsiString ;

begin
    Text_FSErr_Invalid_Handle :=
        Get_Text( ID_Text_FSErr_Invalid_Handle, _Text_FSErr_Invalid_Handle ) ;
end ;


function Text_FSErr_Data_Format_Error : AnsiString ;

begin
    Text_FSErr_Data_Format_Error :=
        Get_Text( ID_Text_FSErr_Data_Format_Error, _Text_FSErr_Data_Format_Error ) ;
end ;


function Text_FSErr_Read_Only : AnsiString ;

begin
    Text_FSErr_Read_Only :=
        Get_Text( ID_Text_FSErr_Read_Only, _Text_FSErr_Read_Only ) ;
end ;


function Text_FHErr_No_Room_On_Device : AnsiString ;

begin
    Text_FHErr_No_Room_On_Device :=
        Get_Text( ID_Text_FHErr_No_Room_On_Device, _Text_FHErr_No_Room_On_Device ) ;
end ;


function Text_FHErr_Corrupted_File_Structure : AnsiString ;

begin
    Text_FHErr_Corrupted_File_Structure :=
        Get_Text( ID_Text_FHErr_Corrupted_File_Structure, _Text_FHErr_Corrupted_File_Structure ) ;
end ;


function Text_FHErr_Invalid_Pointer_Operation : AnsiString ;

begin
    Text_FHErr_Invalid_Pointer_Operation :=
        Get_Text( ID_Text_FHErr_Invalid_Pointer_Operation, _Text_FHErr_Invalid_Pointer_Operation ) ;
end ;


function Text_FHErr_Deallocation_Error : AnsiString ;

begin
    Text_FHErr_Deallocation_Error :=
        Get_Text( ID_Text_FHErr_Deallocation_Error, _Text_FHErr_Deallocation_Error ) ;
end ;


function Text_FHErr_Size_Mismatch : AnsiString ;

begin
    Text_FHErr_Size_Mismatch :=
        Get_Text( ID_Text_FHErr_Size_Mismatch, _Text_FHErr_Size_Mismatch ) ;
end ;


function Text_FHErr_Read_Out_Of_Range : AnsiString ;

begin
    Text_FHErr_Read_Out_Of_Range :=
        Get_Text( ID_Text_FHErr_Read_Out_Of_Range, _Text_FHErr_Read_Out_Of_Range ) ;
end ;


function Text_FHErr_Read_Size_Error : AnsiString ;

begin
    Text_FHErr_Read_Size_Error :=
        Get_Text( ID_Text_FHErr_Read_Size_Error, _Text_FHErr_Read_Size_Error ) ;
end ;


function Text_FHErr_Write_Out_Of_Range : AnsiString ;

begin
    Text_FHErr_Write_Out_Of_Range :=
        Get_Text( ID_Text_FHErr_Write_Out_Of_Range, _Text_FHErr_Write_Out_Of_Range ) ;
end ;


function Text_FHErr_Write_Size_Error : AnsiString ;

begin
    Text_FHErr_Write_Size_Error :=
        Get_Text( ID_Text_FHErr_Write_Size_Error, _Text_FHErr_Write_Size_Error ) ;
end ;


function Text_FHErr_Bad_Minimum : AnsiString ;

begin
    Text_FHErr_Bad_Minimum :=
        Get_Text( ID_Text_FHErr_Bad_Minimum, _Text_FHErr_Bad_Minimum ) ;
end ;


function Text_Error_Heap_Deallocation_Error : AnsiString ;

begin
    Text_Error_Heap_Deallocation_Error :=
        Get_Text( ID_Text_Error_Heap_Deallocation_Error, _Text_Error_Heap_Deallocation_Error ) ;
end ;


function Text_Error_Heap_Access_Error : AnsiString ;

begin
    Text_Error_Heap_Access_Error :=
        Get_Text( ID_Text_Error_Heap_Access_Error, _Text_Error_Heap_Access_Error ) ;
end ;


function Text_Error_Illegal_Resolution_Size : AnsiString ;

begin
    Text_Error_Illegal_Resolution_Size :=
        Get_Text( ID_Text_Error_Illegal_Resolution_Size, _Text_Error_Illegal_Resolution_Size ) ;
end ;


function Text_Error_Invalid_Address : AnsiString ;

begin
    Text_Error_Invalid_Address :=
        Get_Text( ID_Text_Error_Invalid_Address, _Text_Error_Invalid_Address ) ;
end ;


function Text_Prompt_Press_Any_Key_To_Continue : AnsiString ;

begin
    Text_Prompt_Press_Any_Key_To_Continue :=
        Get_Text( ID_Text_Prompt_Press_Any_Key_To_Continue, _Text_Prompt_Press_Any_Key_To_Continue ) ;
end ;


function Text_Further_Help_Is_Available_On : AnsiString ;

begin
    Text_Further_Help_Is_Available_On :=
        Get_Text( ID_Text_Further_Help_Is_Available_On, _Text_Further_Help_Is_Available_On ) ;
end ;


function Text_Sorry_No_Help_For_x_Found_At_This_Level : AnsiString ;

begin
    Text_Sorry_No_Help_For_x_Found_At_This_Level :=
        Get_Text( ID_Text_Sorry_No_Help_For_x_Found_At_This_Level, _Text_Sorry_No_Help_For_x_Found_At_This_Level ) ;
end ;


function Text_Warning_Nesting_Exceeds_40_Levels : AnsiString ;

begin
    Text_Warning_Nesting_Exceeds_40_Levels :=
        Get_Text( ID_Text_Warning_Nesting_Exceeds_40_Levels, _Text_Warning_Nesting_Exceeds_40_Levels ) ;
end ;


function Text_Prompt_Topic : AnsiString ;

begin
    Text_Prompt_Topic :=
        Get_Text( ID_Text_Prompt_Topic, _Text_Prompt_Topic ) ;
end ;


function Text_Error_Help_Not_Available : AnsiString ;

begin
    Text_Error_Help_Not_Available :=
        Get_Text( ID_Text_Error_Help_Not_Available, _Text_Error_Help_Not_Available ) ;
end ;


function Text_Error_HTML_No_Content : AnsiString ;

begin
    Text_Error_HTML_No_Content :=
        Get_Text( ID_Text_Error_HTML_No_Content, _Text_Error_HTML_No_Content ) ;
end ;


function Text_Error_HTML_Moved_Permanently : AnsiString ;

begin
    Text_Error_HTML_Moved_Permanently :=
        Get_Text( ID_Text_Error_HTML_Moved_Permanently, _Text_Error_HTML_Moved_Permanently ) ;
end ;


function Text_Error_HTML_Moved_Temporarily : AnsiString ;

begin
    Text_Error_HTML_Moved_Temporarily :=
        Get_Text( ID_Text_Error_HTML_Moved_Temporarily, _Text_Error_HTML_Moved_Temporarily ) ;
end ;


function Text_Error_HTML_Bad_Request : AnsiString ;

begin
    Text_Error_HTML_Bad_Request :=
        Get_Text( ID_Text_Error_HTML_Bad_Request, _Text_Error_HTML_Bad_Request ) ;
end ;


function Text_Error_HTML_Unauthorized : AnsiString ;

begin
    Text_Error_HTML_Unauthorized :=
        Get_Text( ID_Text_Error_HTML_Unauthorized, _Text_Error_HTML_Unauthorized ) ;
end ;


function Text_Error_HTML_Payment_Required : AnsiString ;

begin
    Text_Error_HTML_Payment_Required :=
        Get_Text( ID_Text_Error_HTML_Payment_Required, _Text_Error_HTML_Payment_Required ) ;
end ;


function Text_Error_HTML_Forbidden : AnsiString ;

begin
    Text_Error_HTML_Forbidden :=
        Get_Text( ID_Text_Error_HTML_Forbidden, _Text_Error_HTML_Forbidden ) ;
end ;


function Text_Error_HTML_Not_Found : AnsiString ;

begin
    Text_Error_HTML_Not_Found :=
        Get_Text( ID_Text_Error_HTML_Not_Found, _Text_Error_HTML_Not_Found ) ;
end ;


function Text_Error_HTML_Method_Not_Allowed : AnsiString ;

begin
    Text_Error_HTML_Method_Not_Allowed :=
        Get_Text( ID_Text_Error_HTML_Method_Not_Allowed, _Text_Error_HTML_Method_Not_Allowed ) ;
end ;


function Text_Error_HTML_Proxy_Authentication_Required : AnsiString ;

begin
    Text_Error_HTML_Proxy_Authentication_Required :=
        Get_Text( ID_Text_Error_HTML_Proxy_Authentication_Required, _Text_Error_HTML_Proxy_Authentication_Required ) ;
end ;


function Text_Error_HTML_Request_Timeout : AnsiString ;

begin
    Text_Error_HTML_Request_Timeout :=
        Get_Text( ID_Text_Error_HTML_Request_Timeout, _Text_Error_HTML_Request_Timeout ) ;
end ;


function Text_Error_HTML_Conflict : AnsiString ;

begin
    Text_Error_HTML_Conflict :=
        Get_Text( ID_Text_Error_HTML_Conflict, _Text_Error_HTML_Conflict ) ;
end ;


function Text_Error_HTML_Gone : AnsiString ;

begin
    Text_Error_HTML_Gone :=
        Get_Text( ID_Text_Error_HTML_Gone, _Text_Error_HTML_Gone ) ;
end ;


function Text_Error_HTML_Bad_Gateway : AnsiString ;

begin
    Text_Error_HTML_Bad_Gateway :=
        Get_Text( ID_Text_Error_HTML_Bad_Gateway, _Text_Error_HTML_Bad_Gateway ) ;
end ;


function Text_Error_HTML_Service_Unavailable : AnsiString ;

begin
    Text_Error_HTML_Service_Unavailable :=
        Get_Text( ID_Text_Error_HTML_Service_Unavailable, _Text_Error_HTML_Service_Unavailable ) ;
end ;


function Text_Error_HTML_Gateway_Timeout : AnsiString ;

begin
    Text_Error_HTML_Gateway_Timeout :=
        Get_Text( ID_Text_Error_HTML_Gateway_Timeout, _Text_Error_HTML_Gateway_Timeout ) ;
end ;


function Text_LibErr_Invalid_Library_File_Format : AnsiString ;

begin
    Text_LibErr_Invalid_Library_File_Format :=
        Get_Text( ID_Text_LibErr_Invalid_Library_File_Format, _Text_LibErr_Invalid_Library_File_Format ) ;
end ;


function Text_LibErr_Module_Not_Found : AnsiString ;

begin
    Text_LibErr_Module_Not_Found :=
        Get_Text( ID_Text_LibErr_Module_Not_Found, _Text_LibErr_Module_Not_Found ) ;
end ;


function Text_LibErr_Module_Already_Exists : AnsiString ;

begin
    Text_LibErr_Module_Already_Exists :=
        Get_Text( ID_Text_LibErr_Module_Already_Exists, _Text_LibErr_Module_Already_Exists ) ;
end ;


function Text_LibErr_Illegal_Module_Format : AnsiString ;

begin
    Text_LibErr_Illegal_Module_Format :=
        Get_Text( ID_Text_LibErr_Illegal_Module_Format, _Text_LibErr_Illegal_Module_Format ) ;
end ;


function Text_Error_Imaginary_Number : AnsiString ;

begin
    Text_Error_Imaginary_Number :=
        Get_Text( ID_Text_Error_Imaginary_Number, _Text_Error_Imaginary_Number ) ;
end ;


function Text_Error_Store_Overwrite : AnsiString ;

begin
    Text_Error_Store_Overwrite :=
        Get_Text( ID_Text_Error_Store_Overwrite, _Text_Error_Store_Overwrite ) ;
end ;


function Text_Keystroke_Abort : AnsiString ;

begin
    Text_Keystroke_Abort :=
        Get_Text( ID_Text_Keystroke_Abort, _Text_Keystroke_Abort ) ;
end ;


function Text_Keystroke_Cancel : AnsiString ;

begin
    Text_Keystroke_Cancel :=
        Get_Text( ID_Text_Keystroke_Cancel, _Text_Keystroke_Cancel ) ;
end ;


function Text_Keystroke_Ignore : AnsiString ;

begin
    Text_Keystroke_Ignore :=
        Get_Text( ID_Text_Keystroke_Ignore, _Text_Keystroke_Ignore ) ;
end ;


function Text_Keystroke_No : AnsiString ;

begin
    Text_Keystroke_No :=
        Get_Text( ID_Text_Keystroke_No, _Text_Keystroke_No ) ;
end ;


function Text_Keystroke_OK : AnsiString ;

begin
    Text_Keystroke_OK :=
        Get_Text( ID_Text_Keystroke_OK, _Text_Keystroke_OK ) ;
end ;


function Text_Keystroke_Retry : AnsiString ;

begin
    Text_Keystroke_Retry :=
        Get_Text( ID_Text_Keystroke_Retry, _Text_Keystroke_Retry ) ;
end ;


function Text_Keystroke_Yes : AnsiString ;

begin
    Text_Keystroke_Yes :=
        Get_Text( ID_Text_Keystroke_Yes, _Text_Keystroke_Yes ) ;
end ;


function Text_Prompt_Abort : AnsiString ;

begin
    Text_Prompt_Abort :=
        Get_Text( ID_Text_Prompt_Abort, _Text_Prompt_Abort ) ;
end ;


function Text_Prompt_Cancel : AnsiString ;

begin
    Text_Prompt_Cancel :=
        Get_Text( ID_Text_Prompt_Cancel, _Text_Prompt_Cancel ) ;
end ;


function Text_Prompt_Ignore : AnsiString ;

begin
    Text_Prompt_Ignore :=
        Get_Text( ID_Text_Prompt_Ignore, _Text_Prompt_Ignore ) ;
end ;


function Text_Prompt_No : AnsiString ;

begin
    Text_Prompt_No :=
        Get_Text( ID_Text_Prompt_No, _Text_Prompt_No ) ;
end ;


function Text_Prompt_OK : AnsiString ;

begin
    Text_Prompt_OK :=
        Get_Text( ID_Text_Prompt_OK, _Text_Prompt_OK ) ;
end ;


function Text_Prompt_Retry : AnsiString ;

begin
    Text_Prompt_Retry :=
        Get_Text( ID_Text_Prompt_Retry, _Text_Prompt_Retry ) ;
end ;


function Text_Prompt_Yes : AnsiString ;

begin
    Text_Prompt_Yes :=
        Get_Text( ID_Text_Prompt_Yes, _Text_Prompt_Yes ) ;
end ;


function Text_Prompt_Attempt_To_Delete_Alarm_For_Software_Configuration_Key : AnsiString ;

begin
    Text_Prompt_Attempt_To_Delete_Alarm_For_Software_Configuration_Key :=
        Get_Text( ID_Text_Prompt_Attempt_To_Delete_Alarm_For_Software_Configuration_Key, _Text_Prompt_Attempt_To_Delete_Alarm_For_Software_Configuration_Key ) ;
end ;


function Text_Prompt_Attempt_To_Delete_Software_Configuration_Key : AnsiString ;

begin
    Text_Prompt_Attempt_To_Delete_Software_Configuration_Key :=
        Get_Text( ID_Text_Prompt_Attempt_To_Delete_Software_Configuration_Key, _Text_Prompt_Attempt_To_Delete_Software_Configuration_Key ) ;
end ;


function Text_Prompt_Attempt_To_Change_Alarm_For_Software_Configuration_Key : AnsiString ;

begin
    Text_Prompt_Attempt_To_Change_Alarm_For_Software_Configuration_Key :=
        Get_Text( ID_Text_Prompt_Attempt_To_Change_Alarm_For_Software_Configuration_Key, _Text_Prompt_Attempt_To_Change_Alarm_For_Software_Configuration_Key ) ;
end ;


function Text_Prompt_Attempt_To_Change_Software_Configuration_Key : AnsiString ;

begin
    Text_Prompt_Attempt_To_Change_Software_Configuration_Key :=
        Get_Text( ID_Text_Prompt_Attempt_To_Change_Software_Configuration_Key, _Text_Prompt_Attempt_To_Change_Software_Configuration_Key ) ;
end ;


function Text_Prompt_Attempt_To_Read_Software_Configuration_Key : AnsiString ;

begin
    Text_Prompt_Attempt_To_Read_Software_Configuration_Key :=
        Get_Text( ID_Text_Prompt_Attempt_To_Read_Software_Configuration_Key, _Text_Prompt_Attempt_To_Read_Software_Configuration_Key ) ;
end ;


function Text_Error_SMU_Error : AnsiString ;

begin
    Text_Error_SMU_Error :=
        Get_Text( ID_Text_Error_SMU_Error, _Text_Error_SMU_Error ) ;
end ;


function Text_Error_Too_Many_Windows : AnsiString ;

begin
    Text_Error_Too_Many_Windows :=
        Get_Text( ID_Text_Error_Too_Many_Windows, _Text_Error_Too_Many_Windows ) ;
end ;


function Text_Error_Window_Too_Large : AnsiString ;

begin
    Text_Error_Window_Too_Large :=
        Get_Text( ID_Text_Error_Window_Too_Large, _Text_Error_Window_Too_Large ) ;
end ;


function Text_Warning_Window_Collision : AnsiString ;

begin
    Text_Warning_Window_Collision :=
        Get_Text( ID_Text_Warning_Window_Collision, _Text_Warning_Window_Collision ) ;
end ;


function Text_Pascal_Err_String_100 : AnsiString ;

begin
    Text_Pascal_Err_String_100 :=
        Get_Text( ID_Text_Pascal_Err_String_100, _Text_Pascal_Err_String_100 ) ;
end ;


function Text_Pascal_Err_String_101 : AnsiString ;

begin
    Text_Pascal_Err_String_101 :=
        Get_Text( ID_Text_Pascal_Err_String_101, _Text_Pascal_Err_String_101 ) ;
end ;


function Text_Pascal_Err_String_102 : AnsiString ;

begin
    Text_Pascal_Err_String_102 :=
        Get_Text( ID_Text_Pascal_Err_String_102, _Text_Pascal_Err_String_102 ) ;
end ;


function Text_Pascal_Err_String_103 : AnsiString ;

begin
    Text_Pascal_Err_String_103 :=
        Get_Text( ID_Text_Pascal_Err_String_103, _Text_Pascal_Err_String_103 ) ;
end ;


function Text_Pascal_Err_String_104 : AnsiString ;

begin
    Text_Pascal_Err_String_104 :=
        Get_Text( ID_Text_Pascal_Err_String_104, _Text_Pascal_Err_String_104 ) ;
end ;


function Text_Pascal_Err_String_105 : AnsiString ;

begin
    Text_Pascal_Err_String_105 :=
        Get_Text( ID_Text_Pascal_Err_String_105, _Text_Pascal_Err_String_105 ) ;
end ;


function Text_Pascal_Err_String_106 : AnsiString ;

begin
    Text_Pascal_Err_String_106 :=
        Get_Text( ID_Text_Pascal_Err_String_106, _Text_Pascal_Err_String_106 ) ;
end ;


function Text_Pascal_Err_String_162 : AnsiString ;

begin
    Text_Pascal_Err_String_162 :=
        Get_Text( ID_Text_Pascal_Err_String_162, _Text_Pascal_Err_String_162 ) ;
end ;


function Text_Pascal_Err_String_200 : AnsiString ;

begin
    Text_Pascal_Err_String_200 :=
        Get_Text( ID_Text_Pascal_Err_String_200, _Text_Pascal_Err_String_200 ) ;
end ;


function Text_Pascal_Err_String_201 : AnsiString ;

begin
    Text_Pascal_Err_String_201 :=
        Get_Text( ID_Text_Pascal_Err_String_201, _Text_Pascal_Err_String_201 ) ;
end ;


function Text_Pascal_Err_String_202 : AnsiString ;

begin
    Text_Pascal_Err_String_202 :=
        Get_Text( ID_Text_Pascal_Err_String_202, _Text_Pascal_Err_String_202 ) ;
end ;


function Text_Pascal_Err_String_203 : AnsiString ;

begin
    Text_Pascal_Err_String_203 :=
        Get_Text( ID_Text_Pascal_Err_String_203, _Text_Pascal_Err_String_203 ) ;
end ;


function Text_Pascal_Err_String_204 : AnsiString ;

begin
    Text_Pascal_Err_String_204 :=
        Get_Text( ID_Text_Pascal_Err_String_204, _Text_Pascal_Err_String_204 ) ;
end ;


function Text_Pascal_Err_String_205 : AnsiString ;

begin
    Text_Pascal_Err_String_205 :=
        Get_Text( ID_Text_Pascal_Err_String_205, _Text_Pascal_Err_String_205 ) ;
end ;


function Text_Pascal_Err_String_206 : AnsiString ;

begin
    Text_Pascal_Err_String_206 :=
        Get_Text( ID_Text_Pascal_Err_String_206, _Text_Pascal_Err_String_206 ) ;
end ;


function Text_Pascal_Err_String_207 : AnsiString ;

begin
    Text_Pascal_Err_String_207 :=
        Get_Text( ID_Text_Pascal_Err_String_207, _Text_Pascal_Err_String_207 ) ;
end ;


function Text_Pascal_Err_String_208 : AnsiString ;

begin
    Text_Pascal_Err_String_208 :=
        Get_Text( ID_Text_Pascal_Err_String_208, _Text_Pascal_Err_String_208 ) ;
end ;


function Text_Pascal_Err_String_209 : AnsiString ;

begin
    Text_Pascal_Err_String_209 :=
        Get_Text( ID_Text_Pascal_Err_String_209, _Text_Pascal_Err_String_209 ) ;
end ;


function Text_Pascal_Err_String_210 : AnsiString ;

begin
    Text_Pascal_Err_String_210 :=
        Get_Text( ID_Text_Pascal_Err_String_210, _Text_Pascal_Err_String_210 ) ;
end ;


function Text_Pascal_Err_String_211 : AnsiString ;

begin
    Text_Pascal_Err_String_211 :=
        Get_Text( ID_Text_Pascal_Err_String_211, _Text_Pascal_Err_String_211 ) ;
end ;


function Text_Pascal_Err_String_212 : AnsiString ;

begin
    Text_Pascal_Err_String_212 :=
        Get_Text( ID_Text_Pascal_Err_String_212, _Text_Pascal_Err_String_212 ) ;
end ;


function Text_Pascal_Err_String_213 : AnsiString ;

begin
    Text_Pascal_Err_String_213 :=
        Get_Text( ID_Text_Pascal_Err_String_213, _Text_Pascal_Err_String_213 ) ;
end ;


function Text_Pascal_Err_String_214 : AnsiString ;

begin
    Text_Pascal_Err_String_214 :=
        Get_Text( ID_Text_Pascal_Err_String_214, _Text_Pascal_Err_String_214 ) ;
end ;


function Text_Pascal_Err_String_215 : AnsiString ;

begin
    Text_Pascal_Err_String_215 :=
        Get_Text( ID_Text_Pascal_Err_String_215, _Text_Pascal_Err_String_215 ) ;
end ;


function Text_Pascal_Err_String_216 : AnsiString ;

begin
    Text_Pascal_Err_String_216 :=
        Get_Text( ID_Text_Pascal_Err_String_216, _Text_Pascal_Err_String_216 ) ;
end ;


function Text_Pascal_Err_String_217 : AnsiString ;

begin
    Text_Pascal_Err_String_217 :=
        Get_Text( ID_Text_Pascal_Err_String_217, _Text_Pascal_Err_String_217 ) ;
end ;


function Text_Pascal_Err_String_218 : AnsiString ;

begin
    Text_Pascal_Err_String_218 :=
        Get_Text( ID_Text_Pascal_Err_String_218, _Text_Pascal_Err_String_218 ) ;
end ;


function Text_Pascal_Err_String_219 : AnsiString ;

begin
    Text_Pascal_Err_String_219 :=
        Get_Text( ID_Text_Pascal_Err_String_219, _Text_Pascal_Err_String_219 ) ;
end ;


function Text_Pascal_Err_String_220 : AnsiString ;

begin
    Text_Pascal_Err_String_220 :=
        Get_Text( ID_Text_Pascal_Err_String_220, _Text_Pascal_Err_String_220 ) ;
end ;


function Text_Pascal_Err_String_221 : AnsiString ;

begin
    Text_Pascal_Err_String_221 :=
        Get_Text( ID_Text_Pascal_Err_String_221, _Text_Pascal_Err_String_221 ) ;
end ;


function Text_Pascal_Err_String_222 : AnsiString ;

begin
    Text_Pascal_Err_String_222 :=
        Get_Text( ID_Text_Pascal_Err_String_222, _Text_Pascal_Err_String_222 ) ;
end ;


function Text_Pascal_Err_String_223 : AnsiString ;

begin
    Text_Pascal_Err_String_223 :=
        Get_Text( ID_Text_Pascal_Err_String_223, _Text_Pascal_Err_String_223 ) ;
end ;


function Text_Pascal_Err_String_224 : AnsiString ;

begin
    Text_Pascal_Err_String_224 :=
        Get_Text( ID_Text_Pascal_Err_String_224, _Text_Pascal_Err_String_224 ) ;
end ;


function Text_Pascal_Err_String_225 : AnsiString ;

begin
    Text_Pascal_Err_String_225 :=
        Get_Text( ID_Text_Pascal_Err_String_225, _Text_Pascal_Err_String_225 ) ;
end ;


function Text_Pascal_Err_String_226 : AnsiString ;

begin
    Text_Pascal_Err_String_226 :=
        Get_Text( ID_Text_Pascal_Err_String_226, _Text_Pascal_Err_String_226 ) ;
end ;


function Text_Pascal_Err_String_227 : AnsiString ;

begin
    Text_Pascal_Err_String_227 :=
        Get_Text( ID_Text_Pascal_Err_String_227, _Text_Pascal_Err_String_227 ) ;
end ;


function Text_Pascal_Err_String_228 : AnsiString ;

begin
    Text_Pascal_Err_String_228 :=
        Get_Text( ID_Text_Pascal_Err_String_228, _Text_Pascal_Err_String_228 ) ;
end ;


function Text_Pascal_Err_String_229 : AnsiString ;

begin
    Text_Pascal_Err_String_229 :=
        Get_Text( ID_Text_Pascal_Err_String_229, _Text_Pascal_Err_String_229 ) ;
end ;


function Text_Pascal_Err_String_230 : AnsiString ;

begin
    Text_Pascal_Err_String_230 :=
        Get_Text( ID_Text_Pascal_Err_String_230, _Text_Pascal_Err_String_230 ) ;
end ;


function Text_Pascal_Err_String_231 : AnsiString ;

begin
    Text_Pascal_Err_String_231 :=
        Get_Text( ID_Text_Pascal_Err_String_231, _Text_Pascal_Err_String_231 ) ;
end ;


function Text_Pascal_Err_String_232 : AnsiString ;

begin
    Text_Pascal_Err_String_232 :=
        Get_Text( ID_Text_Pascal_Err_String_232, _Text_Pascal_Err_String_232 ) ;
end ;


function Text_Error_Invalid_List_Index : AnsiString ;

begin
    Text_Error_Invalid_List_Index :=
        Get_Text( ID_Text_Error_Invalid_List_Index, _Text_Error_Invalid_List_Index ) ;
end ;


function Text_SHErr_No_Room_On_Device : AnsiString ;

begin
    Text_SHErr_No_Room_On_Device :=
        Get_Text( ID_Text_SHErr_No_Room_On_Device, _Text_SHErr_No_Room_On_Device ) ;
end ;


function Text_SHErr_Corrupted_File_Structure : AnsiString ;

begin
    Text_SHErr_Corrupted_File_Structure :=
        Get_Text( ID_Text_SHErr_Corrupted_File_Structure, _Text_SHErr_Corrupted_File_Structure ) ;
end ;


function Text_SHErr_Invalid_Pointer_Operation : AnsiString ;

begin
    Text_SHErr_Invalid_Pointer_Operation :=
        Get_Text( ID_Text_SHErr_Invalid_Pointer_Operation, _Text_SHErr_Invalid_Pointer_Operation ) ;
end ;


function Text_SHErr_Deallocation_Error : AnsiString ;

begin
    Text_SHErr_Deallocation_Error :=
        Get_Text( ID_Text_SHErr_Deallocation_Error, _Text_SHErr_Deallocation_Error ) ;
end ;


function Text_SHErr_Size_Mismatch : AnsiString ;

begin
    Text_SHErr_Size_Mismatch :=
        Get_Text( ID_Text_SHErr_Size_Mismatch, _Text_SHErr_Size_Mismatch ) ;
end ;


function Text_SHErr_Read_Out_Of_Range : AnsiString ;

begin
    Text_SHErr_Read_Out_Of_Range :=
        Get_Text( ID_Text_SHErr_Read_Out_Of_Range, _Text_SHErr_Read_Out_Of_Range ) ;
end ;


function Text_SHErr_Read_Size_Error : AnsiString ;

begin
    Text_SHErr_Read_Size_Error :=
        Get_Text( ID_Text_SHErr_Read_Size_Error, _Text_SHErr_Read_Size_Error ) ;
end ;


function Text_SHErr_Write_Out_Of_Range : AnsiString ;

begin
    Text_SHErr_Write_Out_Of_Range :=
        Get_Text( ID_Text_SHErr_Write_Out_Of_Range, _Text_SHErr_Write_Out_Of_Range ) ;
end ;


function Text_SHErr_Write_Size_Error : AnsiString ;

begin
    Text_SHErr_Write_Size_Error :=
        Get_Text( ID_Text_SHErr_Write_Size_Error, _Text_SHErr_Write_Size_Error ) ;
end ;


function Text_SHErr_Bad_Minimum : AnsiString ;

begin
    Text_SHErr_Bad_Minimum :=
        Get_Text( ID_Text_SHErr_Bad_Minimum, _Text_SHErr_Bad_Minimum ) ;
end ;


function Text_Template_Illegally_Referenced : AnsiString ;

begin
    Text_Template_Illegally_Referenced :=
        Get_Text( ID_Text_Template_Illegally_Referenced, _Text_Template_Illegally_Referenced ) ;
end ;


function Text_Object_Cannot_Call_Routine : AnsiString ;

begin
    Text_Object_Cannot_Call_Routine :=
        Get_Text( ID_Text_Object_Cannot_Call_Routine, _Text_Object_Cannot_Call_Routine ) ;
end ;


function Text_Objects_In_Arrays_Must_Be_Size_4 : AnsiString ;

begin
    Text_Objects_In_Arrays_Must_Be_Size_4 :=
        Get_Text( ID_Text_Objects_In_Arrays_Must_Be_Size_4, _Text_Objects_In_Arrays_Must_Be_Size_4 ) ;
end ;


function Text_Maximum_Size_Of_Array_Object_Data_Exceeded : AnsiString ;

begin
    Text_Maximum_Size_Of_Array_Object_Data_Exceeded :=
        Get_Text( ID_Text_Maximum_Size_Of_Array_Object_Data_Exceeded, _Text_Maximum_Size_Of_Array_Object_Data_Exceeded ) ;
end ;


function Text_Error_Subscript_Out_Of_Range_In : AnsiString ;

begin
    Text_Error_Subscript_Out_Of_Range_In :=
        Get_Text( ID_Text_Error_Subscript_Out_Of_Range_In, _Text_Error_Subscript_Out_Of_Range_In ) ;
end ;


function Text_Error_Static_Array_Is_Invalid : AnsiString ;

begin
    Text_Error_Static_Array_Is_Invalid :=
        Get_Text( ID_Text_Error_Static_Array_Is_Invalid, _Text_Error_Static_Array_Is_Invalid ) ;
end ;


function Text_Error_Maximum_EMS_Array_Element_Size_IS_16384 : AnsiString ;

begin
    Text_Error_Maximum_EMS_Array_Element_Size_IS_16384 :=
        Get_Text( ID_Text_Error_Maximum_EMS_Array_Element_Size_IS_16384, _Text_Error_Maximum_EMS_Array_Element_Size_IS_16384 ) ;
end ;


function Text_Error_Expanded_Memory_Device_Not_Responding : AnsiString ;

begin
    Text_Error_Expanded_Memory_Device_Not_Responding :=
        Get_Text( ID_Text_Error_Expanded_Memory_Device_Not_Responding, _Text_Error_Expanded_Memory_Device_Not_Responding ) ;
end ;


function Text_Error_Expanded_Memory_Device_Not_Present : AnsiString ;

begin
    Text_Error_Expanded_Memory_Device_Not_Present :=
        Get_Text( ID_Text_Error_Expanded_Memory_Device_Not_Present, _Text_Error_Expanded_Memory_Device_Not_Present ) ;
end ;


function Text_Error_Incompatible_Version_Of_Expanded_Memory_Driver : AnsiString ;

begin
    Text_Error_Incompatible_Version_Of_Expanded_Memory_Driver :=
        Get_Text( ID_Text_Error_Incompatible_Version_Of_Expanded_Memory_Driver, _Text_Error_Incompatible_Version_Of_Expanded_Memory_Driver ) ;
end ;


function Text_Error_Requested_Array_Size_Is_Zero_Pages : AnsiString ;

begin
    Text_Error_Requested_Array_Size_Is_Zero_Pages :=
        Get_Text( ID_Text_Error_Requested_Array_Size_Is_Zero_Pages, _Text_Error_Requested_Array_Size_Is_Zero_Pages ) ;
end ;


function Text_Error_Insufficient_Expanded_Memory_Available_For_Array : AnsiString ;

begin
    Text_Error_Insufficient_Expanded_Memory_Available_For_Array :=
        Get_Text( ID_Text_Error_Insufficient_Expanded_Memory_Available_For_Array, _Text_Error_Insufficient_Expanded_Memory_Available_For_Array ) ;
end ;


function Text_Error_Static_EMS_Array_Is_Invalid : AnsiString ;

begin
    Text_Error_Static_EMS_Array_Is_Invalid :=
        Get_Text( ID_Text_Error_Static_EMS_Array_Is_Invalid, _Text_Error_Static_EMS_Array_Is_Invalid ) ;
end ;


function Text_Error_Maximum_Stack_Size_Is_Exceeded : AnsiString ;

begin
    Text_Error_Maximum_Stack_Size_Is_Exceeded :=
        Get_Text( ID_Text_Error_Maximum_Stack_Size_Is_Exceeded, _Text_Error_Maximum_Stack_Size_Is_Exceeded ) ;
end ;


function Text_Stack_Overflow_In : AnsiString ;

begin
    Text_Stack_Overflow_In :=
        Get_Text( ID_Text_Stack_Overflow_In, _Text_Stack_Overflow_In ) ;
end ;


function Text_Error_Stack_Is_Empty_In : AnsiString ;

begin
    Text_Error_Stack_Is_Empty_In :=
        Get_Text( ID_Text_Error_Stack_Is_Empty_In, _Text_Error_Stack_Is_Empty_In ) ;
end ;


function Text_Error_Dynamic_Array_Is_Invalid : AnsiString ;

begin
    Text_Error_Dynamic_Array_Is_Invalid :=
        Get_Text( ID_Text_Error_Dynamic_Array_Is_Invalid, _Text_Error_Dynamic_Array_Is_Invalid ) ;
end ;


function Text_Error_Maximum_Dynamic_Stack_Size_Is_Exceeded : AnsiString ;

begin
    Text_Error_Maximum_Dynamic_Stack_Size_Is_Exceeded :=
        Get_Text( ID_Text_Error_Maximum_Dynamic_Stack_Size_Is_Exceeded, _Text_Error_Maximum_Dynamic_Stack_Size_Is_Exceeded ) ;
end ;


function Text_Error_While_Opening_Virtual_Array_Image_File : AnsiString ;

begin
    Text_Error_While_Opening_Virtual_Array_Image_File :=
        Get_Text( ID_Text_Error_While_Opening_Virtual_Array_Image_File, _Text_Error_While_Opening_Virtual_Array_Image_File ) ;
end ;


function Text_Error_Virtual_Array_Is_Invalid : AnsiString ;

begin
    Text_Error_Virtual_Array_Is_Invalid :=
        Get_Text( ID_Text_Error_Virtual_Array_Is_Invalid, _Text_Error_Virtual_Array_Is_Invalid ) ;
end ;


function Text_Error_Maximum_Virtual_Stack_Size_Is_Exceeded : AnsiString ;

begin
    Text_Error_Maximum_Virtual_Stack_Size_Is_Exceeded :=
        Get_Text( ID_Text_Error_Maximum_Virtual_Stack_Size_Is_Exceeded, _Text_Error_Maximum_Virtual_Stack_Size_Is_Exceeded ) ;
end ;


function Text_Error_Maximum_Size_Of_List_Object_Data_Is_Exceeded : AnsiString ;

begin
    Text_Error_Maximum_Size_Of_List_Object_Data_Is_Exceeded :=
        Get_Text( ID_Text_Error_Maximum_Size_Of_List_Object_Data_Is_Exceeded, _Text_Error_Maximum_Size_Of_List_Object_Data_Is_Exceeded ) ;
end ;


function Text_Error_Objects_In_Lists_Must_Be_Size_4 : AnsiString ;

begin
    Text_Error_Objects_In_Lists_Must_Be_Size_4 :=
        Get_Text( ID_Text_Error_Objects_In_Lists_Must_Be_Size_4, _Text_Error_Objects_In_Lists_Must_Be_Size_4 ) ;
end ;


function Text_Error_End_Of_List_In : AnsiString ;

begin
    Text_Error_End_Of_List_In :=
        Get_Text( ID_Text_Error_End_Of_List_In, _Text_Error_End_Of_List_In ) ;
end ;


function Text_Error_No_Context_In : AnsiString ;

begin
    Text_Error_No_Context_In :=
        Get_Text( ID_Text_Error_No_Context_In, _Text_Error_No_Context_In ) ;
end ;


function Text_Error_Beginning_Of_List_In : AnsiString ;

begin
    Text_Error_Beginning_Of_List_In :=
        Get_Text( ID_Text_Error_Beginning_Of_List_In, _Text_Error_Beginning_Of_List_In ) ;
end ;


function Text_Error_Empty_List_In : AnsiString ;

begin
    Text_Error_Empty_List_In :=
        Get_Text( ID_Text_Error_Empty_List_In, _Text_Error_Empty_List_In ) ;
end ;


function Text_Error_Queue_Is_Empty_In : AnsiString ;

begin
    Text_Error_Queue_Is_Empty_In :=
        Get_Text( ID_Text_Error_Queue_Is_Empty_In, _Text_Error_Queue_Is_Empty_In ) ;
end ;


function Text_Error_Maximum_Size_Of_Array_Object_Data_Is_Exceeded : AnsiString ;

begin
    Text_Error_Maximum_Size_Of_Array_Object_Data_Is_Exceeded :=
        Get_Text( ID_Text_Error_Maximum_Size_Of_Array_Object_Data_Is_Exceeded, _Text_Error_Maximum_Size_Of_Array_Object_Data_Is_Exceeded ) ;
end ;


function Text_Error_Objects_In_Trees_Must_Be_Size_4 : AnsiString ;

begin
    Text_Error_Objects_In_Trees_Must_Be_Size_4 :=
        Get_Text( ID_Text_Error_Objects_In_Trees_Must_Be_Size_4, _Text_Error_Objects_In_Trees_Must_Be_Size_4 ) ;
end ;


function Text_Error_Maximum_Size_Of_B_Tree_Object_Data_Is_Exceeded : AnsiString ;

begin
    Text_Error_Maximum_Size_Of_B_Tree_Object_Data_Is_Exceeded :=
        Get_Text( ID_Text_Error_Maximum_Size_Of_B_Tree_Object_Data_Is_Exceeded, _Text_Error_Maximum_Size_Of_B_Tree_Object_Data_Is_Exceeded ) ;
end ;


function Text_Error_Maximum_Size_Of_B_Tree_Bucket_Is_Exceeded : AnsiString ;

begin
    Text_Error_Maximum_Size_Of_B_Tree_Bucket_Is_Exceeded :=
        Get_Text( ID_Text_Error_Maximum_Size_Of_B_Tree_Bucket_Is_Exceeded, _Text_Error_Maximum_Size_Of_B_Tree_Bucket_Is_Exceeded ) ;
end ;


function Text_Error_Illegal_Record_Context : AnsiString ;

begin
    Text_Error_Illegal_Record_Context :=
        Get_Text( ID_Text_Error_Illegal_Record_Context, _Text_Error_Illegal_Record_Context ) ;
end ;


function Text_Dynamic_Stack : AnsiString ;

begin
    Text_Dynamic_Stack := Get_Text( ID_Text_Dynamic_Stack, _Text_Dynamic_Stack ) ;
end ;


function Text_Virtual_Stack : AnsiString ;

begin
    Text_Virtual_Stack := Get_Text( ID_Text_Virtual_Stack, _Text_Virtual_Stack ) ;
end ;


function Text_List_Stack : AnsiString ;

begin
    Text_List_Stack := Get_Text( ID_Text_List_Stack, _Text_List_Stack ) ;
end ;


function Text_Sparse_Array : AnsiString ;

begin
    Text_Sparse_Array := Get_Text( ID_Text_Sparse_Array, _Text_Sparse_Array ) ;
end ;


function Text_Error_Key_Size_Cannot_Exceed_Total_Tree_Object_Data_Size : AnsiString ;

begin
    Text_Error_Key_Size_Cannot_Exceed_Total_Tree_Object_Data_Size :=
        Get_Text( ID_Text_Error_Key_Size_Cannot_Exceed_Total_Tree_Object_Data_Size, _Text_Error_Key_Size_Cannot_Exceed_Total_Tree_Object_Data_Size ) ;
end ;


function Text_Error_Maximum_Size_Of_Tree_Object_Data_Is_Exceeded : AnsiString ;

begin
    Text_Error_Maximum_Size_Of_Tree_Object_Data_Is_Exceeded :=
        Get_Text( ID_Text_Error_Maximum_Size_Of_Tree_Object_Data_Is_Exceeded, _Text_Error_Maximum_Size_Of_Tree_Object_Data_Is_Exceeded ) ;
end ;


function Text_Error_Duplicate_Items_Encountered_In_Tree : AnsiString ;

begin
    Text_Error_Duplicate_Items_Encountered_In_Tree :=
        Get_Text( ID_Text_Error_Duplicate_Items_Encountered_In_Tree, _Text_Error_Duplicate_Items_Encountered_In_Tree ) ;
end ;


function Text_Error_Tree_Error : AnsiString ;

begin
    Text_Error_Tree_Error :=
        Get_Text( ID_Text_Error_Tree_Error, _Text_Error_Tree_Error ) ;
end ;


function Text_Error_Tree_is_Empty_In : AnsiString ;

begin
    Text_Error_Tree_is_Empty_In :=
        Get_Text( ID_Text_Error_Tree_is_Empty_In, _Text_Error_Tree_is_Empty_In ) ;
end ;


function Text_Error_End_Of_Tree_In : AnsiString ;

begin
    Text_Error_End_Of_Tree_In :=
        Get_Text( ID_Text_Error_End_Of_Tree_In, _Text_Error_End_Of_Tree_In ) ;
end ;


function Text_Error_While_Padding_Virtual_Array_Image_File : AnsiString ;

begin
    Text_Error_While_Padding_Virtual_Array_Image_File :=
        Get_Text( ID_Text_Error_While_Padding_Virtual_Array_Image_File, _Text_Error_While_Padding_Virtual_Array_Image_File ) ;
end ;


function Text_Invalid_Symbol_Name : AnsiString ;

begin
    Text_Invalid_Symbol_Name :=
        Get_Text( ID_Text_Invalid_Symbol_Name, _Text_Invalid_Symbol_Name ) ;
end ;


function Text_Reserved_Name : AnsiString ;

begin
    Text_Reserved_Name :=
        Get_Text( ID_Text_Reserved_Name, _Text_Reserved_Name ) ;
end ;


function Text_Multiply_Defined_Symbol : AnsiString ;

begin
    Text_Multiply_Defined_Symbol :=
        Get_Text( ID_Text_Multiply_Defined_Symbol, _Text_Multiply_Defined_Symbol ) ;
end ;


function Text_Undefined_Reference : AnsiString ;

begin
    Text_Undefined_Reference :=
        Get_Text( ID_Text_Undefined_Reference, _Text_Undefined_Reference ) ;
end ;


function Text_No_More_Matches : AnsiString ;

begin
    Text_No_More_Matches :=
        Get_Text( ID_Text_No_More_Matches, _Text_No_More_Matches ) ;
end ;


function Text_Unknown_Symbol_Error : AnsiString ;

begin
    Text_Unknown_Symbol_Error :=
        Get_Text( ID_Text_Unknown_Symbol_Error, _Text_Unknown_Symbol_Error ) ;
end ;


function Text_Error_TEU_Not_Enough_Memory : AnsiString ;

begin
    Text_Error_TEU_Not_Enough_Memory :=
        Get_Text( ID_Text_Error_TEU_Not_Enough_Memory, _Text_Error_TEU_Not_Enough_Memory ) ;
end ;


function Text_Error_TEU_Backup_Past_Beginning_Of_Buffer : AnsiString ;

begin
    Text_Error_TEU_Backup_Past_Beginning_Of_Buffer :=
        Get_Text( ID_Text_Error_TEU_Backup_Past_Beginning_Of_Buffer, _Text_Error_TEU_Backup_Past_Beginning_Of_Buffer ) ;
end ;


function Text_Error_TEU_Advance_Beyond_End_Of_Buffer : AnsiString ;

begin
    Text_Error_TEU_Advance_Beyond_End_Of_Buffer :=
        Get_Text( ID_Text_Error_TEU_Advance_Beyond_End_Of_Buffer, _Text_Error_TEU_Advance_Beyond_End_Of_Buffer ) ;
end ;


function Text_Error_TEU_Line_Length_Exceeds_255_Characters : AnsiString ;

begin
    Text_Error_TEU_Line_Length_Exceeds_255_Characters :=
        Get_Text( ID_Text_Error_TEU_Line_Length_Exceeds_255_Characters, _Text_Error_TEU_Line_Length_Exceeds_255_Characters ) ;
end ;


function Text_Error_TEU_Text_Not_Found : AnsiString ;

begin
    Text_Error_TEU_Text_Not_Found :=
        Get_Text( ID_Text_Error_TEU_Text_Not_Found, _Text_Error_TEU_Text_Not_Found ) ;
end ;


function Text_Error_TEU_Nothing_Selected : AnsiString ;

begin
    Text_Error_TEU_Nothing_Selected :=
        Get_Text( ID_Text_Error_TEU_Nothing_Selected, _Text_Error_TEU_Nothing_Selected ) ;
end ;


function Text_Error_TEU_Selection_In_Progress : AnsiString ;

begin
    Text_Error_TEU_Selection_In_Progress :=
        Get_Text( ID_Text_Error_TEU_Selection_In_Progress, _Text_Error_TEU_Selection_In_Progress ) ;
end ;


function Text_Error_Maximum_Memory_Exceeded : AnsiString ;

begin
    Text_Error_Maximum_Memory_Exceeded :=
            Get_Text( ID_Text_Error_Maximum_Memory_Exceeded, _Text_Error_Maximum_Memory_Exceeded ) ;
end ;


function Text_Error_Opening : AnsiString ;

begin
    Text_Error_Opening :=
        Get_Text( ID_Text_Error_Opening, _Text_Error_Opening ) ;
end ;


function Text_Warning_Some_Lines_Too_Long : AnsiString ;

begin
    Text_Warning_Some_Lines_Too_Long :=
        Get_Text( ID_Text_Warning_Some_Lines_Too_Long, _Text_Warning_Some_Lines_Too_Long ) ;
end ;


function Text_More : AnsiString ;

begin
    Text_More := Get_Text( ID_Text_More, _Text_More ) ;
end ;


function Text_Press_Enter_To_Continue1 : AnsiString ;

begin
    Text_Press_Enter_To_Continue1 :=
        Get_Text( ID_Text_Press_Enter_To_Continue1, _Text_Press_Enter_To_Continue1 ) ;
end ;


function Text_Searching_For : AnsiString ;

begin
    Text_Searching_For :=
        Get_Text( ID_Text_Searching_For, _Text_Searching_For ) ;
end ;


function Text_Enter_Keystroke_Whose_Definition_You_Wish_To_Save : AnsiString ;

begin
    Text_Enter_Keystroke_Whose_Definition_You_Wish_To_Save :=
        Get_Text( ID_Text_Enter_Keystroke_Whose_Definition_You_Wish_To_Save, _Text_Enter_Keystroke_Whose_Definition_You_Wish_To_Save ) ;
end ;


function Text_Store_Aborted : AnsiString ;

begin
    Text_Store_Aborted :=
        Get_Text( ID_Text_Store_Aborted, _Text_Store_Aborted ) ;
end ;


function Text_Modifications_Will_No_Be_Saved_Continue_Quitting_NO : AnsiString ;

begin
    Text_Modifications_Will_No_Be_Saved_Continue_Quitting_NO :=
        Get_Text( ID_Text_Modifications_Will_No_Be_Saved_Continue_Quitting_NO,
        _Text_Modifications_Will_No_Be_Saved_Continue_Quitting_NO ) ;
end ;


function Text_1_Line : AnsiString ;

begin
    Text_1_Line := Get_Text( ID_Text_1_Line, _Text_1_Line ) ;
end ;


function Text_n_Lines : AnsiString ;

begin
    Text_n_Lines := Get_Text( ID_Text_n_Lines, _Text_n_Lines ) ;
end ;


function Text_Error_Illegal_Command : AnsiString ;

begin
    Text_Error_Illegal_Command :=
        Get_Text( ID_Text_Error_Illegal_Command, _Text_Error_Illegal_Command ) ;
end ;


function Text_Missing_Parameter : AnsiString ;

begin
    Text_Missing_Parameter :=
        Get_Text( ID_Text_Missing_Parameter, _Text_Missing_Parameter ) ;
end ;


function Text_Error_Missing_Operand : AnsiString ;

begin
    Text_Error_Missing_Operand :=
        Get_Text( ID_Text_Error_Missing_Operand, _Text_Error_Missing_Operand ) ;
end ;


function Text_Error_Invalid_Line_Number : AnsiString ;

begin
    Text_Error_Invalid_Line_Number :=
        Get_Text( ID_Text_Error_Invalid_Line_Number, _Text_Error_Invalid_Line_Number ) ;
end ;


function Text_Text_To_Search_For : AnsiString ;

begin
    Text_Text_To_Search_For :=
        Get_Text( ID_Text_Text_To_Search_For, _Text_Text_To_Search_For ) ;
end ;


function Text_Error_Nested_Key_Definitions_Are_Not_Allowed : AnsiString ;

begin
    Text_Error_Nested_Key_Definitions_Are_Not_Allowed :=
        Get_Text( ID_Text_Error_Nested_Key_Definitions_Are_Not_Allowed,
        _Text_Error_Nested_Key_Definitions_Are_Not_Allowed ) ;
end ;


function Text_Line : AnsiString ;

begin
    Text_Line := Get_Text( ID_Text_Line, _Text_Line ) ;
end ;


function Text_Column : AnsiString ;

begin
    Text_Column := Get_Text( ID_Text_Column, _Text_Column ) ;
end ;


function Text_Error_No_Keystrokes_Are_Being_Recorded : AnsiString ;

begin
    Text_Error_No_Keystrokes_Are_Being_Recorded :=
        Get_Text( ID_Text_Error_No_Keystrokes_Are_Being_Recorded, _Text_Error_No_Keystrokes_Are_Being_Recorded ) ;
end ;


function Text_Error_No_Keystrokes_Were_Recorded : AnsiString ;

begin
    Text_Error_No_Keystrokes_Were_Recorded :=
        Get_Text( ID_Text_Error_No_Keystrokes_Were_Recorded, _Text_Error_No_Keystrokes_Were_Recorded ) ;
end ;


function Text_Press_The_Key_To_Which_To_Assign_The_Keystrokes : AnsiString ;

begin
    Text_Press_The_Key_To_Which_To_Assign_The_Keystrokes :=
        Get_Text( ID_Text_Press_The_Key_To_Which_To_Assign_The_Keystrokes,
        _Text_Press_The_Key_To_Which_To_Assign_The_Keystrokes ) ;
end ;


function Text_Keystrokes_Remembered : AnsiString ;

begin
    Text_Keystrokes_Remembered :=
        Get_Text( ID_Text_Keystrokes_Remembered, _Text_Keystrokes_Remembered ) ;
end ;


function Text_Error_Previous_Key_Macro_Recording_Must_Be_Finished : AnsiString ;

begin
    Text_Error_Previous_Key_Macro_Recording_Must_Be_Finished :=
        Get_Text( ID_Text_Error_Previous_Key_Macro_Recording_Must_Be_Finished, _Text_Error_Previous_Key_Macro_Recording_Must_Be_Finished ) ;
end ;


function Text_Enter_The_Keystrokes_To_Record : AnsiString ;

begin
    Text_Enter_The_Keystrokes_To_Record :=
        Get_Text( ID_Text_Enter_The_Keystrokes_To_Record, _Text_Enter_The_Keystrokes_To_Record ) ;
end ;


function Text_Command : AnsiString ;

begin
    Text_Command := Get_Text( ID_Text_Command, _Text_Command ) ;
end ;


function Text_Control_C_Ignored : AnsiString ;

begin
    Text_Control_C_Ignored := Get_Text( ID_Text_Control_C_Ignored, _Text_Control_C_Ignored ) ;
end ;


function Text_Modified : AnsiString ;

begin
    Text_Modified := Get_Text( ID_Text_Modified, _Text_Modified ) ;
end ;


function Text_File : AnsiString ;

begin
    Text_File := Get_Text( ID_Text_File, _Text_File ) ;
end ;


function Text_n_Bytes_Available : AnsiString ;

begin
    Text_n_Bytes_Available := Get_Text( ID_Text_n_Bytes_Available, _Text_n_Bytes_Available ) ;
end ;


function Text_Line_Column : AnsiString ;

begin
    Text_Line_Column := Get_Text( ID_Text_Line_Column, _Text_Line_Column ) ;
end ;


function Text_Editing_File_x_Confirm : AnsiString ;

begin
    Text_Editing_File_x_Confirm :=
        Get_Text( ID_Text_Editing_File_x_Confirm, _Text_Editing_File_x_Confirm ) ;
end ;


function Text_Parameters_Are_Not_Allowed_On : AnsiString ;

begin
    Text_Parameters_Are_Not_Allowed_On :=
        Get_Text( ID_Text_Parameters_Are_Not_Allowed_On, _Text_Parameters_Are_Not_Allowed_On ) ;
end ;


function Text_Recover_And_Read_Only_Are_Incompatible_Switches : AnsiString ;

begin
    Text_Recover_And_Read_Only_Are_Incompatible_Switches :=
        Get_Text( ID_Text_Recover_And_Read_Only_Are_Incompatible_Switches,
        _Text_Recover_And_Read_Only_Are_Incompatible_Switches ) ;
end ;


function Text_Invalid_Switch : AnsiString ;

begin
    Text_Invalid_Switch :=
        Get_Text( ID_Text_Invalid_Switch, _Text_Invalid_Switch ) ;
end ;


function Text_Error_While_Opening_Journal_File_Cant_Recover : AnsiString ;

begin
    Text_Error_While_Opening_Journal_File_Cant_Recover :=
        Get_Text( ID_Text_Error_While_Opening_Journal_File_Cant_Recover, _Text_Error_While_Opening_Journal_File_Cant_Recover ) ;
end ;


function Text_Error_Input_File_Does_Not_Exist : AnsiString ;

begin
    Text_Error_Input_File_Does_Not_Exist :=
        Get_Text( ID_Text_Error_Input_File_Does_Not_Exist, _Text_Error_Input_File_Does_Not_Exist ) ;
end ;


function Text_Sun : AnsiString ;

begin
    Text_Sun := Get_Text( ID_Text_Sun, _Text_Sun ) ;
end ;


function Text_Mon : AnsiString ;

begin
    Text_Mon := Get_Text( ID_Text_Mon, _Text_Mon ) ;
end ;


function Text_Tue : AnsiString ;

begin
    Text_Tue := Get_Text( ID_Text_Tue, _Text_Tue ) ;
end ;


function Text_Wed : AnsiString ;

begin
    Text_Wed := Get_Text( ID_Text_Wed, _Text_Wed ) ;
end ;


function Text_Thu : AnsiString ;

begin
    Text_Thu := Get_Text( ID_Text_Thu, _Text_Thu ) ;
end ;


function Text_Fri : AnsiString ;

begin
    Text_Fri := Get_Text( ID_Text_Fri, _Text_Fri ) ;
end ;


function Text_Sat : AnsiString ;

begin
    Text_Sat := Get_Text( ID_Text_Sat, _Text_Sat ) ;
end ;


function Text_Address : AnsiString ;

begin
    Text_Address := Get_Text( ID_Text_Address, _Text_Address ) ;
end ;


function Text_Data : AnsiString ;

begin
    Text_Data := Get_Text( ID_Text_Data, _Text_Data ) ;
end ;


function Text_Caption_Modify_Memory : AnsiString ;

begin
    Text_Caption_Modify_Memory :=
        Get_Text( ID_Text_Caption_Modify_Memory, _Text_Caption_Modify_Memory ) ;
end ;


function Text_Literal_Text : AnsiString ;

begin
    Text_Literal_Text :=
        Get_Text( ID_Text_Literal_Text, _Text_Literal_Text ) ;
end ;


function Text_Caption_Size : AnsiString ;

begin
    Text_Caption_Size :=
        Get_Text( ID_Text_Caption_Size, _Text_Caption_Size ) ;
end ;


function Text_Byte1 : AnsiString ;

begin
    Text_Byte1 := Get_Text( ID_Text_Byte1, _Text_Byte1 ) ;
end ;


function Text_Word1 : AnsiString ;

begin
    Text_Word1 := Get_Text( ID_Text_Word1, _Text_Word1 ) ;
end ;


function Text_Long1 : AnsiString ;

begin
    Text_Long1 := Get_Text( ID_Text_Long1, _Text_Long1 ) ;
end ;


function Text_Button_Caption_OK : AnsiString ;

begin
    Text_Button_Caption_OK := Get_Text( ID_Text_Button_Caption_OK, _Text_Button_Caption_OK ) ;
end ;


function Text_Button_Caption_Cancel : AnsiString ;

begin
    Text_Button_Caption_Cancel := Get_Text( ID_Text_Button_Caption_Cancel, _Text_Button_Caption_Cancel ) ;
end ;


function Text_Button_Caption_Help : AnsiString ;

begin
    Text_Button_Caption_Help := Get_Text( ID_Text_Button_Caption_Help, _Text_Button_Caption_Help ) ;
end ;


function Text_New : AnsiString ;

begin
    Text_New := Get_Text( ID_Text_New, _Text_New ) ;
end ;


function Text_Button_Caption_Delete : AnsiString ;

begin
    Text_Button_Caption_Delete :=
        Get_Text( ID_Text_Button_Caption_Delete, _Text_Button_Caption_Delete ) ;
end ;


function Text_Button_Caption_New_Folder : AnsiString ;

begin
    Text_Button_Caption_New_Folder :=
        Get_Text( ID_Text_Button_Caption_New_Folder, _Text_Button_Caption_New_Folder ) ;
end ;


function Text_Caption_Internals : AnsiString ;

begin
    Text_Caption_Internals :=
        Get_Text( ID_Text_Caption_Internals, _Text_Caption_Internals ) ;
end ;


function Text_Persistant_Selection_Blocks : AnsiString ;

begin
    Text_Persistant_Selection_Blocks :=
        Get_Text( ID_Text_Persistant_Selection_Blocks, _Text_Persistant_Selection_Blocks ) ;
end ;


function Text_Bounded_Caret : AnsiString ;

begin
    Text_Bounded_Caret :=
        Get_Text( ID_Text_Bounded_Caret, _Text_Bounded_Caret ) ;
end ;


function Text_Inactive_Selection : AnsiString ;

begin
    Text_Inactive_Selection :=
        Get_Text( ID_Text_Inactive_Selection, _Text_Inactive_Selection ) ;
end ;


function Text_Tab_Processing : AnsiString ;

begin
    Text_Tab_Processing :=
        Get_Text( ID_Text_Tab_Processing, _Text_Tab_Processing ) ;
end ;


function Text_Sub_Window : AnsiString ;

begin
    Text_Sub_Window := Get_Text( ID_Text_Sub_Window, _Text_Sub_Window ) ;
end ;


function Text_Auto_Indent : AnsiString ;

begin
    Text_Auto_Indent := Get_Text( ID_Text_Auto_Indent, _Text_Auto_Indent ) ;
end ;


function Text_Wrap_Caret : AnsiString ;

begin
    Text_Wrap_Caret := Get_Text( ID_Text_Wrap_Caret, _Text_Wrap_Caret ) ;
end ;


function Text_Menu_Caption_Edit_Amp : AnsiString ;

begin
    Text_Menu_Caption_Edit_Amp := Get_Text( ID_Text_Menu_Caption_Edit_Amp, _Text_Menu_Caption_Edit_Amp ) ;
end ;


function Text_Menu_Caption_Undo_Amp : AnsiString ;

begin
    Text_Menu_Caption_Undo_Amp := Get_Text( ID_Text_Menu_Caption_Undo_Amp, _Text_Menu_Caption_Undo_Amp ) ;
end ;


function Text_Menu_Undo_Hint : AnsiString ;

begin
    Text_Menu_Undo_Hint := Get_Text( ID_Text_Menu_Undo_Hint, _Text_Menu_Undo_Hint ) ;
end ;


function Text_Menu_Caption_Cut_Amp : AnsiString ;

begin
    Text_Menu_Caption_Cut_Amp := Get_Text( ID_Text_Menu_Caption_Cut_Amp, _Text_Menu_Caption_Cut_Amp ) ;
end ;


function Text_Menu_Cut_Hint : AnsiString ;

begin
    Text_Menu_Cut_Hint := Get_Text( ID_Text_Menu_Cut_Hint, _Text_Menu_Cut_Hint ) ;
end ;


function Text_Menu_Caption_Copy_Amp : AnsiString ;

begin
    Text_Menu_Caption_Copy_Amp := Get_Text( ID_Text_Menu_Caption_Copy_Amp, _Text_Menu_Caption_Copy_Amp ) ;
end ;


function Text_Menu_Copy_Hint : AnsiString ;

begin
    Text_Menu_Copy_Hint := Get_Text( ID_Text_Menu_Copy_Hint, _Text_Menu_Copy_Hint ) ;
end ;


function Text_Menu_Caption_Paste_Amp : AnsiString ;

begin
    Text_Menu_Caption_Paste_Amp := Get_Text( ID_Text_Menu_Caption_Paste_Amp, _Text_Menu_Caption_Paste_Amp ) ;
end ;


function Text_Menu_Paste_Hint : AnsiString ;

begin
    Text_Menu_Paste_Hint := Get_Text( ID_Text_Menu_Paste_Hint, _Text_Menu_Paste_Hint ) ;
end ;


function Text_Menu_Caption_Delete_Amp : AnsiString ;

begin
    Text_Menu_Caption_Delete_Amp := Get_Text( ID_Text_Menu_Caption_Delete_Amp, _Text_Menu_Caption_Delete_Amp ) ;
end ;


function Text_Menu_Delete_Hint : AnsiString ;

begin
    Text_Menu_Delete_Hint := Get_Text( ID_Text_Menu_Delete_Hint, _Text_Menu_Delete_Hint ) ;
end ;


function Text_Menu_Caption_Include_Amp : AnsiString ;

begin
    Text_Menu_Caption_Include_Amp := Get_Text( ID_Text_Menu_Caption_Include_Amp, _Text_Menu_Caption_Include_Amp ) ;
end ;


function Text_Menu_Include_Hint : AnsiString ;

begin
    Text_Menu_Include_Hint := Get_Text( ID_Text_Menu_Include_Hint, _Text_Menu_Include_Hint ) ;
end ;


function Text_Menu_Caption_Search_Amp : AnsiString ;

begin
    Text_Menu_Caption_Search_Amp := Get_Text( ID_Text_Menu_Caption_Search_Amp, _Text_Menu_Caption_Search_Amp ) ;
end ;


function Text_Menu_Caption_Find_Amp : AnsiString ;

begin
    Text_Menu_Caption_Find_Amp := Get_Text( ID_Text_Menu_Caption_Find_Amp, _Text_Menu_Caption_Find_Amp ) ;
end ;


function Text_Menu_Find_Hint : AnsiString ;

begin
    Text_Menu_Find_Hint := Get_Text( ID_Text_Menu_Find_Hint, _Text_Menu_Find_Hint ) ;
end ;


function Text_Menu_Caption_Replace_Amp : AnsiString ;

begin
    Text_Menu_Caption_Replace_Amp := Get_Text( ID_Text_Menu_Caption_Replace_Amp, _Text_Menu_Caption_Replace_Amp ) ;
end ;


function Text_Menu_Replace_Hint : AnsiString ;

begin
    Text_Menu_Replace_Hint := Get_Text( ID_Text_Menu_Replace_Hint, _Text_Menu_Replace_Hint ) ;
end ;


function Text_Menu_Caption_Find_Next_Amp : AnsiString ;

begin
    Text_Menu_Caption_Find_Next_Amp := Get_Text( ID_Text_Menu_Caption_Find_Next_Amp, _Text_Menu_Caption_Find_Next_Amp ) ;
end ;


function Text_Menu_Find_Next_Hint : AnsiString ;

begin
    Text_Menu_Find_Next_Hint := Get_Text( ID_Text_Menu_Find_Next_Hint, _Text_Menu_Find_Next_Hint ) ;
end ;


function Text_Menu_Caption_Goto_Amp : AnsiString ;

begin
    Text_Menu_Caption_Goto_Amp := Get_Text( ID_Text_Menu_Caption_Goto_Amp, _Text_Menu_Caption_Goto_Amp ) ;
end ;


function Text_Caption_Include_File : AnsiString ;

begin
    Text_Caption_Include_File := Get_Text( ID_Text_Caption_Include_File, _Text_Caption_Include_File ) ;
end ;


function Text_Caption_Find_Data : AnsiString ;

begin
    Text_Caption_Find_Data := Get_Text( ID_Text_Caption_Find_Data, _Text_Caption_Find_Data ) ;
end ;


function Text_Search_For : AnsiString ;

begin
    Text_Search_For := Get_Text( ID_Text_Search_For, _Text_Search_For ) ;
end ;


function Text_Search_Options : AnsiString ;

begin
    Text_Search_Options := Get_Text( ID_Text_Search_Options, _Text_Search_Options ) ;
end ;


function Text_Bytes : AnsiString ;

begin
    Text_Bytes := Get_Text( ID_Text_Bytes, _Text_Bytes ) ;
end ;


function Text_Case_Sensitive : AnsiString ;

begin
    Text_Case_Sensitive := Get_Text( ID_Text_Case_Sensitive, _Text_Case_Sensitive ) ;
end ;


function Text_Little_Endian : AnsiString ;

begin
    Text_Little_Endian := Get_Text( ID_Text_Little_Endian, _Text_Little_Endian ) ;
end ;


function Text_Caption_Editor_Preferences : AnsiString ;

begin
    Text_Caption_Editor_Preferences :=
        Get_Text( ID_Text_Caption_Editor_Preferences, _Text_Caption_Editor_Preferences ) ;
end ;


function Text_Caption_Enter_Numeric_Value : AnsiString ;

begin
    Text_Caption_Enter_Numeric_Value :=
        Get_Text( ID_Text_Caption_Enter_Numeric_Value, _Text_Caption_Enter_Numeric_Value ) ;
end ;


function Text_Enter_The_Value : AnsiString ;

begin
    Text_Enter_The_Value :=
        Get_Text( ID_Text_Enter_The_Value, _Text_Enter_The_Value ) ;
end ;


function Text_ASCII : AnsiString ;

begin
    Text_ASCII := Get_Text( ID_Text_ASCII, _Text_ASCII ) ;
end ;


function Text_EBCDIC : AnsiString ;

begin
    Text_EBCDIC := Get_Text( ID_Text_EBCDIC, _Text_EBCDIC ) ;
end ;


function Text_Other : AnsiString ;

begin
    Text_Other := Get_Text( ID_Text_Other, _Text_Other ) ;
end ;


function Text_Caption_Goto_Address : AnsiString ;

begin
    Text_Caption_Goto_Address :=
        Get_Text( ID_Text_Caption_Goto_Address, _Text_Caption_Goto_Address ) ;
end ;


function Text_Enter_New_Address : AnsiString ;

begin
    Text_Enter_New_Address :=
        Get_Text( ID_Text_Enter_New_Address, _Text_Enter_New_Address ) ;
end ;


function Text_Button_Caption_Abort : AnsiString ;

begin
    Text_Button_Caption_Abort :=
        Get_Text( ID_Text_Button_Caption_Abort, _Text_Button_Caption_Abort ) ;
end ;


function Text_Caption_Go_To_Line_Number : AnsiString ;

begin
    Text_Caption_Go_To_Line_Number :=
        Get_Text( ID_Text_Caption_Go_To_Line_Number, _Text_Caption_Go_To_Line_Number ) ;
end ;


function Text_Enter_New_Line_Number_Amp : AnsiString ;

begin
    Text_Enter_New_Line_Number_Amp :=
        Get_Text( ID_Text_Enter_New_Line_Number_Amp, _Text_Enter_New_Line_Number_Amp ) ;
end ;


function Text_Caption_Outline_Editor : AnsiString ;

begin
    Text_Caption_Outline_Editor :=
        Get_Text( ID_Text_Caption_Outline_Editor, _Text_Caption_Outline_Editor ) ;
end ;


function Text_Button_Caption_Rename : AnsiString ;

begin
    Text_Button_Caption_Rename :=
        Get_Text( ID_Text_Button_Caption_Rename, _Text_Button_Caption_Rename ) ;
end ;


function Text_Button_Caption_Add : AnsiString ;

begin
    Text_Button_Caption_Add :=
        Get_Text( ID_Text_Button_Caption_Add, _Text_Button_Caption_Add ) ;
end ;


function Text_Button_Caption_Create_Sub : AnsiString ;

begin
    Text_Button_Caption_Create_Sub :=
        Get_Text( ID_Text_Button_Caption_Create_Sub, _Text_Button_Caption_Create_Sub ) ;
end ;


function Text_Button_Caption_Move : AnsiString ;

begin
    Text_Button_Caption_Move :=
        Get_Text( ID_Text_Button_Caption_Move, _Text_Button_Caption_Move ) ;
end ;


function Text_Caption_Choose_Radix : AnsiString ;

begin
    Text_Caption_Choose_Radix :=
        Get_Text( ID_Text_Caption_Choose_Radix, _Text_Caption_Choose_Radix ) ;
end ;


function Text_Choose_The_Radix_For_Numeric_Display : AnsiString ;

begin
    Text_Choose_The_Radix_For_Numeric_Display :=
        Get_Text( ID_Text_Choose_The_Radix_For_Numeric_Display, _Text_Choose_The_Radix_For_Numeric_Display ) ;
end ;


function Text_Button_Caption_Help_Amp : AnsiString ;

begin
    Text_Button_Caption_Help_Amp :=
        Get_Text( ID_Text_Button_Caption_Help_Amp, _Text_Button_Caption_Help_Amp ) ;
end ;


function Text_Caption_File_Has_Changed : AnsiString ;

begin
    Text_Caption_File_Has_Changed :=
        Get_Text( ID_Text_Caption_File_Has_Changed, _Text_Caption_File_Has_Changed ) ;
end ;


function Text_Save_Changes_To1 : AnsiString ;

begin
    Text_Save_Changes_To1 :=
        Get_Text( ID_Text_Save_Changes_To1, _Text_Save_Changes_To1 ) ;
end ;


function Text_Button_Caption_Yes : AnsiString ;

begin
    Text_Button_Caption_Yes :=
        Get_Text( ID_Text_Button_Caption_Yes, _Text_Button_Caption_Yes ) ;
end ;


function Text_Button_Caption_No : AnsiString ;

begin
    Text_Button_Caption_No :=
        Get_Text( ID_Text_Button_Caption_No, _Text_Button_Caption_No ) ;
end ;


function Text_Text_To_Substitute : AnsiString ;

begin
    Text_Text_To_Substitute :=
        Get_Text( ID_Text_Text_To_Substitute, _Text_Text_To_Substitute ) ;
end ;


function Text_Scope : AnsiString ;

begin
    Text_Scope :=
        Get_Text( ID_Text_Scope, _Text_Scope ) ;
end ;


function Text_Search_From_Current_Position : AnsiString ;

begin
    Text_Search_From_Current_Position :=
        Get_Text( ID_Text_Search_From_Current_Position, _Text_Search_From_Current_Position ) ;
end ;


function Text_Search_Entire_File : AnsiString ;

begin
    Text_Search_Entire_File :=
        Get_Text( ID_Text_Search_Entire_File, _Text_Search_Entire_File ) ;
end ;


function Text_Button_Caption_Replace : AnsiString ;

begin
    Text_Button_Caption_Replace :=
        Get_Text( ID_Text_Button_Caption_Replace, _Text_Button_Caption_Replace ) ;
end ;


function Text_Prompt_On_Replace : AnsiString ;

begin
    Text_Prompt_On_Replace :=
        Get_Text( ID_Text_Prompt_On_Replace, _Text_Prompt_On_Replace ) ;
end ;


function Text_Search : AnsiString ;

begin
    Text_Search :=
        Get_Text( ID_Text_Search, _Text_Search ) ;
end ;


{
// Generate default text file
procedure Create_Text_File ;

var F : textfile ;

begin
    assignfile( F, 'e:\english.text' ) ;
    rewrite( F ) ;
    writeln( F, '' ) ;
    writeln( F, Text_Error_Allocation_Table_Load_Failure ) ;
    writeln( F, Text_Error_Allocation_Table_Load_Failure ) ;
    writeln( F, Text_Error_Execution_Exceeds_ms ) ;
    writeln( F, Text_Error_Adding_Existing_Object_Or_Failure_To_Delete_Old_Object ) ;
    writeln( F, Text_Error_Found_Object_Has_Facility_Mismatch ) ;
    writeln( F, Text_Error_Facility_Out_Of_Range ) ;
    writeln( F, Text_Error_Removing_Non_Existant_Object ) ;
    writeln( F, Text_Error_Facility_Mismatch ) ;
    writeln( F, Text_Press_Enter_To_Continue ) ;
    writeln( F, Text_Application ) ;
    writeln( F, Text_Unsigned ) ;
    writeln( F, Text_Signed ) ;
    writeln( F, Text_Byte ) ;
    writeln( F, Text_Word ) ;
    writeln( F, Text_Longint ) ;
    writeln( F, Text_Binary ) ;
    writeln( F, Text_Octal ) ;
    writeln( F, Text_Decimal ) ;
    writeln( F, Text_Hexadecimal ) ;
    writeln( F, Text_Radix_50 ) ;
    writeln( F, Text_Base_n ) ;
    writeln( F, Text_Size_Amp ) ;
    writeln( F, Text_Base_Amp ) ;
    writeln( F, Text_Binary_Amp ) ;
    writeln( F, Text_Octal_Amp ) ;
    writeln( F, Text_Decimal_Amp ) ;
    writeln( F, Text_Hexadecimal_Amp ) ;
    writeln( F, Text_Radix_50_Amp ) ;
    writeln( F, Text_Err_Writing_To_Log_File ) ;
    writeln( F, Text_Volume_ID_Is ) ;
    writeln( F, Text_Error_Invalid_Output_Drive ) ;
    writeln( F, Text_Error_FAT_Is_Too_Big ) ;
    writeln( F, Text_Initialization_Error_Correct_And_Press_Any_Key_To_Continue ) ;
    writeln( F, Text_Initialization_Error ) ;
    writeln( F, Text_Error_Unknown_Command_Or_Invalid_Drive ) ;
    writeln( F, Text_Error_Bad_Address_Mark ) ;
    writeln( F, Text_Error_Sector_Not_Found ) ;
    writeln( F, Text_Error_DMA_Failure ) ;
    writeln( F, Text_Error_Data_Error_CRC ) ;
    writeln( F, Text_Error_Controller_Failure ) ;
    writeln( F, Text_Error_Seek_Failure ) ;
    writeln( F, Text_Error_Drive_Does_Not_Respond ) ;
    writeln( F, Text_Error_Drive_Is_Write_Locked ) ;
    writeln( F, Text_Error_Unknown_Unit ) ;
    writeln( F, Text_Error_Drive_Not_Ready ) ;
    writeln( F, Text_Error_Unknown_Command_In_Absolute_Sector_Write ) ;
    writeln( F, Text_Error_Bad_Request_Structure_Length ) ;
    writeln( F, Text_Error_Seek_Error ) ;
    writeln( F, Text_Error_Unknown_Media_Type ) ;
    writeln( F, Text_Error_Printer_Out_Of_Paper ) ;
    writeln( F, Text_Error_Write_Fault ) ;
    writeln( F, Text_Error_Read_Fault ) ;
    writeln( F, Text_Error_General_Failure ) ;
    writeln( F, Text_Error_Error_13_In_Absolute_Sector_Write ) ;
    writeln( F, Text_Error_Error_14_In_Absolute_Sector_Write ) ;
    writeln( F, Text_Error_Invalid_Disk_Change ) ;
    writeln( F, Text_Place_Saveset_Volume_Into_Drive_And_Press_Return ) ;
    writeln( F, Text_Place_Saveset_Volume_Into_Drive ) ;
    writeln( F, Text_Success ) ;
    writeln( F, Text_Error_No_Dictionary_Open ) ;
    writeln( F, Text_Error_Already_Defined ) ;
    writeln( F, Text_Error_Invalid_Syntax_Type ) ;
    writeln( F, Text_Error_Not_Defined ) ;
    writeln( F, Text_Error_Attach_Failed ) ;
    writeln( F, Text_Error_Detach_Failed ) ;
    writeln( F, Text_True ) ;
    writeln( F, Text_False ) ;
    writeln( F, Text_Error_Invalid_Base ) ;
    writeln( F, Text_Error_Numeric_Error ) ;
    writeln( F, Text_Error_Abstract_Method_Called ) ;
    writeln( F, Text_Other_Ellipse ) ;
    writeln( F, Text_Signed_Amp ) ;
    writeln( F, Text_Byte_Amp ) ;
    writeln( F, Text_Word_Amp ) ;
    writeln( F, Text_Long_Amp ) ;
    writeln( F, Text_Quad_Amp ) ;
    writeln( F, Text_EBCDIC_Amp ) ;
    writeln( F, Text_Goto_Address_Ellipse ) ;
    writeln( F, Text_Find_Ellipse ) ;
    writeln( F, Text_Modify_Ellipse ) ;
    writeln( F, Text_Nothing_Found ) ;
    writeln( F, Text_Month_Jan ) ;
    writeln( F, Text_Month_Feb ) ;
    writeln( F, Text_Month_Mar ) ;
    writeln( F, Text_Month_Apr ) ;
    writeln( F, Text_Month_May ) ;
    writeln( F, Text_Month_Jun ) ;
    writeln( F, Text_Month_Jul ) ;
    writeln( F, Text_Month_Aug ) ;
    writeln( F, Text_Month_Sep ) ;
    writeln( F, Text_Month_Oct ) ;
    writeln( F, Text_Month_Nov ) ;
    writeln( F, Text_Month_Dec ) ;
    writeln( F, Text_Month_January ) ;
    writeln( F, Text_Month_February ) ;
    writeln( F, Text_Month_March ) ;
    writeln( F, Text_Month_April ) ;
    writeln( F, Text_Month_June ) ;
    writeln( F, Text_Month_July ) ;
    writeln( F, Text_Month_August ) ;
    writeln( F, Text_Month_September ) ;
    writeln( F, Text_Month_October ) ;
    writeln( F, Text_Month_November ) ;
    writeln( F, Text_Month_December ) ;
    writeln( F, Text_ASCII_Amp ) ;
    writeln( F, Text_Day_Sunday ) ;
    writeln( F, Text_Day_Monday ) ;
    writeln( F, Text_Day_Tuesday ) ;
    writeln( F, Text_Day_Wednesday ) ;
    writeln( F, Text_Day_Thursday ) ;
    writeln( F, Text_Day_Friday ) ;
    writeln( F, Text_Day_Saturday ) ;
    writeln( F, Text_Application_x ) ;
    writeln( F, Text_Operating_System_x ) ;
    writeln( F, Text_There_Is_No_Debugging_Information_Available ) ;
    writeln( F, Text_Error_Opening_x ) ;
    writeln( F, Text_Search_String_Not_Found ) ;
    writeln( F, Text_Caption_Search ) ;
    writeln( F, Text_Caption_Replace ) ;
    writeln( F, Text_Replace_This_Instance ) ;
    writeln( F, Text_Save_Changes_To ) ;
    writeln( F, Text_Noname ) ;
    writeln( F, Text_Unknown_Error_Code ) ;
    writeln( F, Text_Facility_n_Error_n ) ;
    writeln( F, Text_Error_Severity_Success ) ;
    writeln( F, Text_Error_Severity_Notification ) ;
    writeln( F, Text_Error_Severity_Warning ) ;
    writeln( F, Text_Error_Severity_Error ) ;
    writeln( F, Text_Error_Severity_Fatal ) ;
    writeln( F, Text_DOS_Error_Success ) ;
    writeln( F, Text_DOS_Error_1 ) ;
    writeln( F, Text_DOS_Error_2 ) ;
    writeln( F, Text_DOS_Error_3 ) ;
    writeln( F, Text_DOS_Error_4 ) ;
    writeln( F, Text_DOS_Error_5 ) ;
    writeln( F, Text_DOS_Error_6 ) ;
    writeln( F, Text_DOS_Error_7 ) ;
    writeln( F, Text_DOS_Error_8 ) ;
    writeln( F, Text_DOS_Error_9 ) ;
    writeln( F, Text_DOS_Error_10 ) ;
    writeln( F, Text_DOS_Error_11 ) ;
    writeln( F, Text_DOS_Error_12 ) ;
    writeln( F, Text_DOS_Error_13 ) ;
    writeln( F, Text_DOS_Error_14 ) ;
    writeln( F, Text_DOS_Error_15 ) ;
    writeln( F, Text_DOS_Error_16 ) ;
    writeln( F, Text_DOS_Error_17 ) ;
    writeln( F, Text_DOS_Error_18 ) ;
    writeln( F, Text_DOS_Error_19 ) ;
    writeln( F, Text_DOS_Error_20 ) ;
    writeln( F, Text_DOS_Error_21 ) ;
    writeln( F, Text_DOS_Error_22 ) ;
    writeln( F, Text_DOS_Error_23 ) ;
    writeln( F, Text_DOS_Error_24 ) ;
    writeln( F, Text_DOS_Error_25 ) ;
    writeln( F, Text_DOS_Error_26 ) ;
    writeln( F, Text_DOS_Error_27 ) ;
    writeln( F, Text_DOS_Error_28 ) ;
    writeln( F, Text_DOS_Error_29 ) ;
    writeln( F, Text_DOS_Error_30 ) ;
    writeln( F, Text_DOS_Error_31 ) ;
    writeln( F, Text_DOS_Error_32 ) ;
    writeln( F, Text_DOS_Error_33 ) ;
    writeln( F, Text_DOS_Error_34 ) ;
    writeln( F, Text_DOS_Error_35 ) ;
    writeln( F, Text_DOS_Error_36 ) ;
    writeln( F, Text_DOS_Error_38 ) ;
    writeln( F, Text_DOS_Error_50 ) ;
    writeln( F, Text_DOS_Error_51 ) ;
    writeln( F, Text_DOS_Error_52 ) ;
    writeln( F, Text_DOS_Error_53 ) ;
    writeln( F, Text_DOS_Error_54 ) ;
    writeln( F, Text_DOS_Error_55 ) ;
    writeln( F, Text_DOS_Error_56 ) ;
    writeln( F, Text_DOS_Error_57 ) ;
    writeln( F, Text_DOS_Error_58 ) ;
    writeln( F, Text_DOS_Error_59 ) ;
    writeln( F, Text_DOS_Error_60 ) ;
    writeln( F, Text_DOS_Error_61 ) ;
    writeln( F, Text_DOS_Error_62 ) ;
    writeln( F, Text_DOS_Error_63 ) ;
    writeln( F, Text_DOS_Error_64 ) ;
    writeln( F, Text_DOS_Error_65 ) ;
    writeln( F, Text_DOS_Error_66 ) ;
    writeln( F, Text_DOS_Error_67 ) ;
    writeln( F, Text_DOS_Error_68 ) ;
    writeln( F, Text_DOS_Error_69 ) ;
    writeln( F, Text_DOS_Error_70 ) ;
    writeln( F, Text_DOS_Error_71 ) ;
    writeln( F, Text_DOS_Error_72 ) ;
    writeln( F, Text_DOS_Error_80 ) ;
    writeln( F, Text_DOS_Error_81 ) ;
    writeln( F, Text_DOS_Error_82 ) ;
    writeln( F, Text_DOS_Error_83 ) ;
    writeln( F, Text_DOS_Error_84 ) ;
    writeln( F, Text_DOS_Error_85 ) ;
    writeln( F, Text_DOS_Error_86 ) ;
    writeln( F, Text_DOS_Error_87 ) ;
    writeln( F, Text_DOS_Error_88 ) ;
    writeln( F, Text_DOS_Error_89 ) ;
    writeln( F, Text_DOS_Error_90 ) ;
    writeln( F, Text_DOS_Error_91 ) ;
    writeln( F, Text_DOS_Error_92 ) ;
    writeln( F, Text_DOS_Error_93 ) ;
    writeln( F, Text_DOS_Error_95 ) ;
    writeln( F, Text_DOS_Error_100 ) ;
    writeln( F, Text_DOS_Error_101 ) ;
    writeln( F, Text_DOS_Error_102 ) ;
    writeln( F, Text_DOS_Error_103 ) ;
    writeln( F, Text_DOS_Error_104 ) ;
    writeln( F, Text_DOS_Error_105 ) ;
    writeln( F, Text_DOS_Error_106 ) ;
    writeln( F, Text_DOS_Error_107 ) ;
    writeln( F, Text_DOS_Error_108 ) ;
    writeln( F, Text_DOS_Error_109 ) ;
    writeln( F, Text_DOS_Error_110 ) ;
    writeln( F, Text_DOS_Error_111 ) ;
    writeln( F, Text_DOS_Error_112 ) ;
    writeln( F, Text_DOS_Error_113 ) ;
    writeln( F, Text_DOS_Error_114 ) ;
    writeln( F, Text_DOS_Error_115 ) ;
    writeln( F, Text_DOS_Error_116 ) ;
    writeln( F, Text_DOS_Error_117 ) ;
    writeln( F, Text_DOS_Error_118 ) ;
    writeln( F, Text_DOS_Error_119 ) ;
    writeln( F, Text_DOS_Error_120 ) ;
    writeln( F, Text_DOS_Error_121 ) ;
    writeln( F, Text_DOS_Error_122 ) ;
    writeln( F, Text_DOS_Error_123 ) ;
    writeln( F, Text_DOS_Error_124 ) ;
    writeln( F, Text_DOS_Error_125 ) ;
    writeln( F, Text_DOS_Error_126 ) ;
    writeln( F, Text_DOS_Error_127 ) ;
    writeln( F, Text_DOS_Error_128 ) ;
    writeln( F, Text_DOS_Error_129 ) ;
    writeln( F, Text_DOS_Error_130 ) ;
    writeln( F, Text_DOS_Error_131 ) ;
    writeln( F, Text_DOS_Error_132 ) ;
    writeln( F, Text_DOS_Error_133 ) ;
    writeln( F, Text_DOS_Error_134 ) ;
    writeln( F, Text_DOS_Error_135 ) ;
    writeln( F, Text_DOS_Error_136 ) ;
    writeln( F, Text_DOS_Error_137 ) ;
    writeln( F, Text_DOS_Error_138 ) ;
    writeln( F, Text_DOS_Error_139 ) ;
    writeln( F, Text_DOS_Error_140 ) ;
    writeln( F, Text_DOS_Error_141 ) ;
    writeln( F, Text_DOS_Error_142 ) ;
    writeln( F, Text_DOS_Error_143 ) ;
    writeln( F, Text_DOS_Error_144 ) ;
    writeln( F, Text_DOS_Error_145 ) ;
    writeln( F, Text_DOS_Error_146 ) ;
    writeln( F, Text_DOS_Error_147 ) ;
    writeln( F, Text_DOS_Error_148 ) ;
    writeln( F, Text_DOS_Error_149 ) ;
    writeln( F, Text_DOS_Error_150 ) ;
    writeln( F, Text_DOS_Error_151 ) ;
    writeln( F, Text_DOS_Error_152 ) ;
    writeln( F, Text_DOS_Error_153 ) ;
    writeln( F, Text_DOS_Error_154 ) ;
    writeln( F, Text_DOS_Error_155 ) ;
    writeln( F, Text_DOS_Error_156 ) ;
    writeln( F, Text_DOS_Error_157 ) ;
    writeln( F, Text_DOS_Error_158 ) ;
    writeln( F, Text_DOS_Error_159 ) ;
    writeln( F, Text_DOS_Error_160 ) ;
    writeln( F, Text_DOS_Error_161 ) ;
    writeln( F, Text_DOS_Error_162 ) ;
    writeln( F, Text_DOS_Error_163 ) ;
    writeln( F, Text_DOS_Error_164 ) ;
    writeln( F, Text_DOS_Error_165 ) ;
    writeln( F, Text_DOS_Error_180 ) ;
    writeln( F, Text_DOS_Error_181 ) ;
    writeln( F, Text_DOS_Error_182 ) ;
    writeln( F, Text_DOS_Error_183 ) ;
    writeln( F, Text_DOS_Error_184 ) ;
    writeln( F, Text_DOS_Error_185 ) ;
    writeln( F, Text_DOS_Error_186 ) ;
    writeln( F, Text_DOS_Error_187 ) ;
    writeln( F, Text_DOS_Error_188 ) ;
    writeln( F, Text_DOS_Error_189 ) ;
    writeln( F, Text_DOS_Error_190 ) ;
    writeln( F, Text_DOS_Error_191 ) ;
    writeln( F, Text_DOS_Error_192 ) ;
    writeln( F, Text_DOS_Error_193 ) ;
    writeln( F, Text_DOS_Error_194 ) ;
    writeln( F, Text_DOS_Error_195 ) ;
    writeln( F, Text_DOS_Error_196 ) ;
    writeln( F, Text_DOS_Error_197 ) ;
    writeln( F, Text_DOS_Error_198 ) ;
    writeln( F, Text_DOS_Error_199 ) ;
    writeln( F, Text_DOS_Error_200 ) ;
    writeln( F, Text_DOS_Error_201 ) ;
    writeln( F, Text_DOS_Error_202 ) ;
    writeln( F, Text_DOS_Error_203 ) ;
    writeln( F, Text_DOS_Error_204 ) ;
    writeln( F, Text_DOS_Error_205 ) ;
    writeln( F, Text_DOS_Error_206 ) ;
    writeln( F, Text_DOS_Error_207 ) ;
    writeln( F, Text_DOS_Error_208 ) ;
    writeln( F, Text_DOS_Error_209 ) ;
    writeln( F, Text_DOS_Error_210 ) ;
    writeln( F, Text_DOS_Error_211 ) ;
    writeln( F, Text_DOS_Error_212 ) ;
    writeln( F, Text_DOS_Error_213 ) ;
    writeln( F, Text_DOS_Error_214 ) ;
    writeln( F, Text_DOS_Error_215 ) ;
    writeln( F, Text_DOS_Error_216 ) ;
    writeln( F, Text_DOS_Error_600 ) ;
    writeln( F, Text_DOS_Error_601 ) ;
    writeln( F, Text_DOS_Error_602 ) ;
    writeln( F, Text_DOS_Error_603 ) ;
    writeln( F, Text_DOS_Error_604 ) ;
    writeln( F, Text_DOS_Error_605 ) ;
    writeln( F, Text_DOS_Error_606 ) ;
    writeln( F, Text_DOS_Error_607 ) ;
    writeln( F, Text_DOS_Error_608 ) ;
    writeln( F, Text_DOS_Error_609 ) ;
    writeln( F, Text_DOS_Error_610 ) ;
    writeln( F, Text_DOS_Error_611 ) ;
    writeln( F, Text_DOS_Error_612 ) ;
    writeln( F, Text_DOS_Error_613 ) ;
    writeln( F, Text_DOS_Error_614 ) ;
    writeln( F, Text_DOS_Error_615 ) ;
    writeln( F, Text_DOS_Error_616 ) ;
    writeln( F, Text_DOS_Error_617 ) ;
    writeln( F, Text_DOS_Error_618 ) ;
    writeln( F, Text_DOS_Error_619 ) ;
    writeln( F, Text_DOS_Error_620 ) ;
    writeln( F, Text_DOS_Error_621 ) ;
    writeln( F, Text_DOS_Error_622 ) ;
    writeln( F, Text_DOS_Error_623 ) ;
    writeln( F, Text_DOS_Error_624 ) ;
    writeln( F, Text_DOS_Error_625 ) ;
    writeln( F, Text_DOS_Error_626 ) ;
    writeln( F, Text_DOS_Error_627 ) ;
    writeln( F, Text_DOS_Error_628 ) ;
    writeln( F, Text_DOS_Error_629 ) ;
    writeln( F, Text_DOS_Error_630 ) ;
    writeln( F, Text_DOS_Error_631 ) ;
    writeln( F, Text_DOS_Error_632 ) ;
    writeln( F, Text_DOS_Error_633 ) ;
    writeln( F, Text_DOS_Error_634 ) ;
    writeln( F, Text_DOS_Error_635 ) ;
    writeln( F, Text_DOS_Error_636 ) ;
    writeln( F, Text_DOS_Error_637 ) ;
    writeln( F, Text_DOS_Error_638 ) ;
    writeln( F, Text_DOS_Error_639 ) ;
    writeln( F, Text_DOS_Error_640 ) ;
    writeln( F, Text_DOS_Error_641 ) ;
    writeln( F, Text_DOS_Error_642 ) ;
    writeln( F, Text_DOS_Error_643 ) ;
    writeln( F, Text_DOS_Error_644 ) ;
    writeln( F, Text_DOS_Error_645 ) ;
    writeln( F, Text_DOS_Error_646 ) ;
    writeln( F, Text_DOS_Error_647 ) ;
    writeln( F, Text_DOS_Error_648 ) ;
    writeln( F, Text_DOS_Error_649 ) ;
    writeln( F, Text_DOS_Error_650 ) ;
    writeln( F, Text_DOS_Error_651 ) ;
    writeln( F, Text_DOS_Error_652 ) ;
    writeln( F, Text_DOS_Error_653 ) ;
    writeln( F, Text_DOS_Error_654 ) ;
    writeln( F, Text_DOS_Error_655 ) ;
    writeln( F, Text_DOS_Error_656 ) ;
    writeln( F, Text_DOS_Error_657 ) ;
    writeln( F, Text_DOS_Error_658 ) ;
    writeln( F, Text_DOS_Error_659 ) ;
    writeln( F, Text_DOS_Error_660 ) ;
    writeln( F, Text_DOS_Error_661 ) ;
    writeln( F, Text_DOS_Error_662 ) ;
    writeln( F, Text_DOS_Error_663 ) ;
    writeln( F, Text_DOS_Error_664 ) ;
    writeln( F, Text_DOS_Error_665 ) ;
    writeln( F, Text_DOS_Error_666 ) ;
    writeln( F, Text_DOS_Error_667 ) ;
    writeln( F, Text_DOS_Error_668 ) ;
    writeln( F, Text_DOS_Error_669 ) ;
    writeln( F, Text_DOS_Error_670 ) ;
    writeln( F, Text_DOS_Error_671 ) ;
    writeln( F, Text_DOS_Error_672 ) ;
    writeln( F, Text_DOS_Error_673 ) ;
    writeln( F, Text_DOS_Error_674 ) ;
    writeln( F, Text_DOS_Error_675 ) ;
    writeln( F, Text_DOS_Error_676 ) ;
    writeln( F, Text_DOS_Error_677 ) ;
    writeln( F, Text_DOS_Error_678 ) ;
    writeln( F, Text_DOS_Error_679 ) ;
    writeln( F, Text_DOS_Error_680 ) ;
    writeln( F, Text_DOS_Error_681 ) ;
    writeln( F, Text_DOS_Error_682 ) ;
    writeln( F, Text_DOS_Error_683 ) ;
    writeln( F, Text_DOS_Error_684 ) ;
    writeln( F, Text_DOS_Error_685 ) ;
    writeln( F, Text_DOS_Error_686 ) ;
    writeln( F, Text_DOS_Error_687 ) ;
    writeln( F, Text_DOS_Error_688 ) ;
    writeln( F, Text_DOS_Error_689 ) ;
    writeln( F, Text_DOS_Error_690 ) ;
    writeln( F, Text_DOS_Error_691 ) ;
    writeln( F, Text_DOS_Error_692 ) ;
    writeln( F, Text_DOS_Error_693 ) ;
    writeln( F, Text_DOS_Error_694 ) ;
    writeln( F, Text_DOS_Error_695 ) ;
    writeln( F, Text_DOS_Error_696 ) ;
    writeln( F, Text_DOS_Error_697 ) ;
    writeln( F, Text_DOS_Error_698 ) ;
    writeln( F, Text_DOS_Error_699 ) ;
    writeln( F, Text_DOS_Error_700 ) ;
    writeln( F, Text_DOS_Error_701 ) ;
    writeln( F, Text_DOS_Error_702 ) ;
    writeln( F, Text_DOS_Error_703 ) ;
    writeln( F, Text_DOS_Error_704 ) ;
    writeln( F, Text_DOS_Error_705 ) ;
    writeln( F, Text_DOS_Error_706 ) ;
    writeln( F, Text_DOS_Error_707 ) ;
    writeln( F, Text_DOS_Error_708 ) ;
    writeln( F, Text_DOS_Error_709 ) ;
    writeln( F, Text_DOS_Error_710 ) ;
    writeln( F, Text_DOS_Error_711 ) ;
    writeln( F, Text_DOS_Error_712 ) ;
    writeln( F, Text_DOS_Error_713 ) ;
    writeln( F, Text_DOS_Error_714 ) ;
    writeln( F, Text_DOS_Error_715 ) ;
    writeln( F, Text_DOS_Error_716 ) ;
    writeln( F, Text_DOS_Error_717 ) ;
    writeln( F, Text_DOS_Error_718 ) ;
    writeln( F, Text_DOS_Error_719 ) ;
    writeln( F, Text_DOS_Error_720 ) ;
    writeln( F, Text_DOS_Error_721 ) ;
    writeln( F, Text_DOS_Error_722 ) ;
    writeln( F, Text_DOS_Error_723 ) ;
    writeln( F, Text_DOS_Error_724 ) ;
    writeln( F, Text_DOS_Error_725 ) ;
    writeln( F, Text_DOS_Error_726 ) ;
    writeln( F, Text_DOS_Error_727 ) ;
    writeln( F, Text_DOS_Error_728 ) ;
    writeln( F, Text_DOS_Error_729 ) ;
    writeln( F, Text_DOS_Error_730 ) ;
    writeln( F, Text_DOS_Error_731 ) ;
    writeln( F, Text_DOS_Error_732 ) ;
    writeln( F, Text_DOS_Error_733 ) ;
    writeln( F, Text_DOS_Error_734 ) ;
    writeln( F, Text_DOS_Error_735 ) ;
    writeln( F, Text_DOS_Error_736 ) ;
    writeln( F, Text_DOS_Error_737 ) ;
    writeln( F, Text_DOS_Error_738 ) ;
    writeln( F, Text_DOS_Error_739 ) ;
    writeln( F, Text_DOS_Error_740 ) ;
    writeln( F, Text_DOS_Error_741 ) ;
    writeln( F, Text_DOS_Error_742 ) ;
    writeln( F, Text_DOS_Error_743 ) ;
    writeln( F, Text_DOS_Error_744 ) ;
    writeln( F, Text_DOS_Error_752 ) ;
    writeln( F, Text_Error_Unused_Error_Number ) ;
    writeln( F, Text_Express_Error_Expected_Comma ) ;
    writeln( F, Text_Express_Error_Syntax_Error ) ;
    writeln( F, Text_Express_Error_Illegal_Symbol ) ;
    writeln( F, Text_Express_Error_Expected_Left_Parenthesis ) ;
    writeln( F, Text_Express_Error_Division_By_Zero ) ;
    writeln( F, Text_Express_Error_Illegal_Number_for_factorial ) ;
    writeln( F, Text_Express_Error_Floating_point_error ) ;
    writeln( F, Text_Express_Error_Illegal_Number ) ;
    writeln( F, Text_Express_Error_Illegal_Argument ) ;
    writeln( F, Text_Express_Error_Imaginary_Number ) ;
    writeln( F, Text_Express_Error_Illegal_Argument_in_LOG ) ;
    writeln( F, Text_Express_Error_Argument_Too_large_in_EXP ) ;
    writeln( F, Text_Express_Error_Missing_Right_Parenthesis ) ;
    writeln( F, Text_FSErr_FileNotOpen ) ;
    writeln( F, Text_FSErr_EndOfFile ) ;
    writeln( F, Text_FSErr_FileNotFound ) ;
    writeln( F, Text_FSErr_FileNameLength ) ;
    writeln( F, Text_FSErr_FileName ) ;
    writeln( F, Text_FSErr_DirectoryNotFound ) ;
    writeln( F, Text_FSErr_InvalidPath ) ;
    writeln( F, Text_FSErr_NoRoomOnDevice ) ;
    writeln( F, Text_FSErr_ProtectionViolation ) ;
    writeln( F, Text_FSErr_DirectoryExists ) ;
    writeln( F, Text_FSErr_FileNotEmpty ) ;
    writeln( F, Text_FSErr_DirectoryNotEmpty ) ;
    writeln( F, Text_FSErr_CorruptedFileStructure ) ;
    writeln( F, Text_FSErr_FileExists ) ;
    writeln( F, Text_FSErr_IllegalOperationType ) ;
    writeln( F, Text_FSErr_LineTooLong ) ;
    writeln( F, Text_FSErr_InvalidDevice ) ;
    writeln( F, Text_FSErr_Internal_Duplicate ) ;
    writeln( F, Text_FSErr_Invalid_Open_Mode ) ;
    writeln( F, Text_FSErr_Unsupported_Operation ) ;
    writeln( F, Text_FSErr_Device_In_Use ) ;
    writeln( F, Text_FSErr_Unknown_Device_Type ) ;
    writeln( F, Text_FSErr_Internal_Error_On_Add ) ;
    writeln( F, Text_FSErr_Invalid_Record_Size ) ;
    writeln( F, Text_FSErr_Internal_Corruption ) ;
    writeln( F, Text_FSErr_Timeout ) ;
    writeln( F, Text_FSErr_Invalid_Handle ) ;
    writeln( F, Text_FSErr_Data_Format_Error ) ;
    writeln( F, Text_FSErr_Read_Only ) ;
    writeln( F, Text_FHErr_No_Room_On_Device ) ;
    writeln( F, Text_FHErr_Corrupted_File_Structure ) ;
    writeln( F, Text_FHErr_Invalid_Pointer_Operation ) ;
    writeln( F, Text_FHErr_Deallocation_Error ) ;
    writeln( F, Text_FHErr_Size_Mismatch ) ;
    writeln( F, Text_FHErr_Read_Out_Of_Range ) ;
    writeln( F, Text_FHErr_Read_Size_Error ) ;
    writeln( F, Text_FHErr_Write_Out_Of_Range ) ;
    writeln( F, Text_FHErr_Write_Size_Error ) ;
    writeln( F, Text_FHErr_Bad_Minimum ) ;
    writeln( F, Text_Error_Heap_Deallocation_Error ) ;
    writeln( F, Text_Error_Heap_Access_Error ) ;
    writeln( F, Text_Error_Illegal_Resolution_Size ) ;
    writeln( F, Text_Error_Invalid_Address ) ;
    writeln( F, Text_Further_Help_Is_Available_On ) ;
    writeln( F, Text_Sorry_No_Help_For_x_Found_At_This_Level ) ;
    writeln( F, Text_Warning_Nesting_Exceeds_40_Levels ) ;
    writeln( F, Text_Prompt_Topic ) ;
    writeln( F, Text_Error_Help_Not_Available ) ;
    writeln( F, Text_Error_HTML_No_Content ) ;
    writeln( F, Text_Error_HTML_Moved_Permanently ) ;
    writeln( F, Text_Error_HTML_Moved_Temporarily ) ;
    writeln( F, Text_Error_HTML_Bad_Request ) ;
    writeln( F, Text_Error_HTML_Unauthorized ) ;
    writeln( F, Text_Error_HTML_Payment_Required ) ;
    writeln( F, Text_Error_HTML_Forbidden ) ;
    writeln( F, Text_Error_HTML_Not_Found ) ;
    writeln( F, Text_Error_HTML_Method_Not_Allowed ) ;
    writeln( F, Text_Error_HTML_Proxy_Authentication_Required ) ;
    writeln( F, Text_Error_HTML_Request_Timeout ) ;
    writeln( F, Text_Error_HTML_Conflict ) ;
    writeln( F, Text_Error_HTML_Gone ) ;
    writeln( F, Text_Error_HTML_Bad_Gateway ) ;
    writeln( F, Text_Error_HTML_Service_Unavailable ) ;
    writeln( F, Text_Error_HTML_Gateway_Timeout ) ;
    writeln( F, Text_LibErr_Invalid_Library_File_Format ) ;
    writeln( F, Text_LibErr_Module_Not_Found ) ;
    writeln( F, Text_LibErr_Module_Already_Exists ) ;
    writeln( F, Text_LibErr_Illegal_Module_Format ) ;
    writeln( F, Text_Error_Imaginary_Number ) ;
    writeln( F, Text_Error_Store_Overwrite ) ;
    writeln( F, Text_Keystroke_Abort ) ;
    writeln( F, Text_Keystroke_Cancel ) ;
    writeln( F, Text_Keystroke_Ignore ) ;
    writeln( F, Text_Keystroke_No ) ;
    writeln( F, Text_Keystroke_OK ) ;
    writeln( F, Text_Keystroke_Retry ) ;
    writeln( F, Text_Keystroke_Yes ) ;
    writeln( F, Text_Prompt_Abort ) ;
    writeln( F, Text_Prompt_Cancel ) ;
    writeln( F, Text_Prompt_Ignore ) ;
    writeln( F, Text_Prompt_No ) ;
    writeln( F, Text_Prompt_OK ) ;
    writeln( F, Text_Prompt_Retry ) ;
    writeln( F, Text_Prompt_Yes ) ;
    writeln( F, Text_Prompt_Attempt_To_Delete_Alarm_For_Software_Configuration_Key ) ;
    writeln( F, Text_Prompt_Attempt_To_Delete_Software_Configuration_Key ) ;
    writeln( F, Text_Prompt_Attempt_To_Change_Alarm_For_Software_Configuration_Key ) ;
    writeln( F, Text_Prompt_Attempt_To_Change_Software_Configuration_Key ) ;
    writeln( F, Text_Prompt_Attempt_To_Read_Software_Configuration_Key ) ;
    writeln( F, Text_Error_SMU_Error ) ;
    writeln( F, Text_Error_Too_Many_Windows ) ;
    writeln( F, Text_Error_Window_Too_Large ) ;
    writeln( F, Text_Warning_Window_Collision ) ;
    writeln( F, Text_Pascal_Err_String_100 ) ;
    writeln( F, Text_Pascal_Err_String_101 ) ;
    writeln( F, Text_Pascal_Err_String_102 ) ;
    writeln( F, Text_Pascal_Err_String_103 ) ;
    writeln( F, Text_Pascal_Err_String_104 ) ;
    writeln( F, Text_Pascal_Err_String_105 ) ;
    writeln( F, Text_Pascal_Err_String_106 ) ;
    writeln( F, Text_Pascal_Err_String_162 ) ;
    writeln( F, Text_Pascal_Err_String_200 ) ;
    writeln( F, Text_Pascal_Err_String_201 ) ;
    writeln( F, Text_Pascal_Err_String_202 ) ;
    writeln( F, Text_Pascal_Err_String_203 ) ;
    writeln( F, Text_Pascal_Err_String_204 ) ;
    writeln( F, Text_Pascal_Err_String_205 ) ;
    writeln( F, Text_Pascal_Err_String_206 ) ;
    writeln( F, Text_Pascal_Err_String_207 ) ;
    writeln( F, Text_Pascal_Err_String_208 ) ;
    writeln( F, Text_Pascal_Err_String_209 ) ;
    writeln( F, Text_Pascal_Err_String_210 ) ;
    writeln( F, Text_Pascal_Err_String_211 ) ;
    writeln( F, Text_Pascal_Err_String_212 ) ;
    writeln( F, Text_Pascal_Err_String_213 ) ;
    writeln( F, Text_Pascal_Err_String_214 ) ;
    writeln( F, Text_Pascal_Err_String_215 ) ;
    writeln( F, Text_Pascal_Err_String_216 ) ;
    writeln( F, Text_Pascal_Err_String_217 ) ;
    writeln( F, Text_Pascal_Err_String_218 ) ;
    writeln( F, Text_Pascal_Err_String_219 ) ;
    writeln( F, Text_Pascal_Err_String_220 ) ;
    writeln( F, Text_Pascal_Err_String_221 ) ;
    writeln( F, Text_Pascal_Err_String_222 ) ;
    writeln( F, Text_Pascal_Err_String_223 ) ;
    writeln( F, Text_Pascal_Err_String_224 ) ;
    writeln( F, Text_Pascal_Err_String_225 ) ;
    writeln( F, Text_Pascal_Err_String_226 ) ;
    writeln( F, Text_Pascal_Err_String_227 ) ;
    writeln( F, Text_Pascal_Err_String_228 ) ;
    writeln( F, Text_Pascal_Err_String_229 ) ;
    writeln( F, Text_Pascal_Err_String_230 ) ;
    writeln( F, Text_Pascal_Err_String_231 ) ;
    writeln( F, Text_Pascal_Err_String_232 ) ;
    writeln( F, Text_Error_Invalid_List_Index ) ;
    writeln( F, Text_SHErr_No_Room_On_Device ) ;
    writeln( F, Text_SHErr_Corrupted_File_Structure ) ;
    writeln( F, Text_SHErr_Invalid_Pointer_Operation ) ;
    writeln( F, Text_SHErr_Deallocation_Error ) ;
    writeln( F, Text_SHErr_Size_Mismatch ) ;
    writeln( F, Text_SHErr_Read_Out_Of_Range ) ;
    writeln( F, Text_SHErr_Read_Size_Error ) ;
    writeln( F, Text_SHErr_Write_Out_Of_Range ) ;
    writeln( F, Text_SHErr_Write_Size_Error ) ;
    writeln( F, Text_SHErr_Bad_Minimum ) ;
    writeln( F, Text_Template_Illegally_Referenced ) ;
    writeln( F, Text_Object_Cannot_Call_Routine ) ;
    writeln( F, Text_Objects_In_Arrays_Must_Be_Size_4 ) ;
    writeln( F, Text_Maximum_Size_Of_Array_Object_Data_Exceeded ) ;
    writeln( F, Text_Error_Subscript_Out_Of_Range_In ) ;
    writeln( F, Text_Error_Static_Array_Is_Invalid ) ;
    writeln( F, Text_Error_Maximum_EMS_Array_Element_Size_IS_16384 ) ;
    writeln( F, Text_Error_Expanded_Memory_Device_Not_Responding ) ;
    writeln( F, Text_Error_Expanded_Memory_Device_Not_Present ) ;
    writeln( F, Text_Error_Incompatible_Version_Of_Expanded_Memory_Driver ) ;
    writeln( F, Text_Error_Requested_Array_Size_Is_Zero_Pages ) ;
    writeln( F, Text_Error_Insufficient_Expanded_Memory_Available_For_Array ) ;
    writeln( F, Text_Error_Static_EMS_Array_Is_Invalid ) ;
    writeln( F, Text_Error_Maximum_Stack_Size_Is_Exceeded ) ;
    writeln( F, Text_Error_Stack_Is_Empty_In ) ;
    writeln( F, Text_Error_Dynamic_Array_Is_Invalid ) ;
    writeln( F, Text_Error_Maximum_Dynamic_Stack_Size_Is_Exceeded ) ;
    writeln( F, Text_Error_While_Opening_Virtual_Array_Image_File ) ;
    writeln( F, Text_Error_Virtual_Array_Is_Invalid ) ;
    writeln( F, Text_Error_Maximum_Virtual_Stack_Size_Is_Exceeded ) ;
    writeln( F, Text_Error_Maximum_Size_Of_List_Object_Data_Is_Exceeded ) ;
    writeln( F, Text_Error_Objects_In_Lists_Must_Be_Size_4 ) ;
    writeln( F, Text_Error_End_Of_List_In ) ;
    writeln( F, Text_Error_No_Context_In ) ;
    writeln( F, Text_Error_Beginning_Of_List_In ) ;
    writeln( F, Text_Error_Empty_List_In ) ;
    writeln( F, Text_Error_Queue_Is_Empty_In ) ;
    writeln( F, Text_Error_Maximum_Size_Of_Array_Object_Data_Is_Exceeded ) ;
    writeln( F, Text_Error_Objects_In_Trees_Must_Be_Size_4 ) ;
    writeln( F, Text_Error_Maximum_Size_Of_B_Tree_Object_Data_Is_Exceeded ) ;
    writeln( F, Text_Error_Maximum_Size_Of_B_Tree_Bucket_Is_Exceeded ) ;
    writeln( F, Text_Error_Illegal_Record_Context ) ;
    writeln( F, Text_Dynamic_Stack ) ;
    writeln( F, Text_Virtual_Stack ) ;
    writeln( F, Text_List_Stack ) ;
    writeln( F, Text_Sparse_Array ) ;
    writeln( F, Text_Error_Key_Size_Cannot_Exceed_Total_Tree_Object_Data_Size ) ;
    writeln( F, Text_Error_Maximum_Size_Of_Tree_Object_Data_Is_Exceeded ) ;
    writeln( F, Text_Error_Duplicate_Items_Encountered_In_Tree ) ;
    writeln( F, Text_Error_Tree_Error ) ;
    writeln( F, Text_Error_Tree_is_Empty_In ) ;
    writeln( F, Text_Error_End_Of_Tree_In ) ;
    writeln( F, Text_Stack_Overflow_In ) ;
    writeln( F, Text_Error_While_Padding_Virtual_Array_Image_File ) ;
    writeln( F, Text_Invalid_Symbol_Name ) ;
    writeln( F, Text_Reserved_Name ) ;
    writeln( F, Text_Multiply_Defined_Symbol ) ;
    writeln( F, Text_Undefined_Reference ) ;
    writeln( F, Text_No_More_Matches ) ;
    writeln( F, Text_Unknown_Symbol_Error ) ;
    writeln( F, Text_Error_TEU_Not_Enough_Memory ) ;
    writeln( F, Text_Error_TEU_Backup_Past_Beginning_Of_Buffer ) ;
    writeln( F, Text_Error_TEU_Advance_Beyond_End_Of_Buffer ) ;
    writeln( F, Text_Error_TEU_Line_Length_Exceeds_255_Characters ) ;
    writeln( F, Text_Error_TEU_Text_Not_Found ) ;
    writeln( F, Text_Error_TEU_Nothing_Selected ) ;
    writeln( F, Text_Error_TEU_Selection_In_Progress ) ;
    writeln( F, Text_Error_Maximum_Memory_Exceeded ) ;
    writeln( F, Text_Error_Creating ) ;
    writeln( F, Text_Error_Opening ) ;
    writeln( F, Text_Warning_Some_Lines_Too_Long ) ;
    writeln( F, Text_More ) ;
    writeln( F, Text_Press_Enter_To_Continue1 ) ;
    writeln( F, Text_Searching_For ) ;
    writeln( F, Text_Enter_Keystroke_whose_Definition_You_Wish_To_Save ) ;
    writeln( F, Text_Store_Aborted ) ;
    writeln( F, Text_Modifications_Will_No_Be_Saved_Continue_Quitting_NO ) ;
    writeln( F, Text_1_Line ) ;
    writeln( F, Text_n_Lines ) ;
    writeln( F, Text_Error_Illegal_Command ) ;
    writeln( F, Text_Missing_Parameter ) ;
    writeln( F, Text_Error_Missing_Operand ) ;
    writeln( F, Text_Error_Invalid_Line_Number ) ;
    writeln( F, Text_Text_To_Search_For ) ;
    writeln( F, Text_Error_Nested_Key_Definitions_Are_Not_Allowed ) ;
    writeln( F, Text_Line ) ;
    writeln( F, Text_Column ) ;
    writeln( F, Text_Error_No_Keystrokes_Are_Being_Recorded ) ;
    writeln( F, Text_Error_No_Keystrokes_Were_Recorded ) ;
    writeln( F, Text_Press_The_Key_To_Which_To_Assign_The_Keystrokes ) ;
    writeln( F, Text_Keystrokes_Remembered ) ;
    writeln( F, Text_Error_Previous_Key_Macro_Recording_Must_Be_Finished ) ;
    writeln( F, Text_Enter_The_Keystrokes_To_Record ) ;
    writeln( F, Text_Command ) ;
    writeln( F, Text_Control_C_Ignored ) ;
    writeln( F, Text_Modified ) ;
    writeln( F, Text_File ) ;
    writeln( F, Text_n_Bytes_Available ) ;
    writeln( F, Text_Line_Column ) ;
    writeln( F, Text_Editing_File_x_Confirm ) ;
    writeln( F, Text_Parameters_Are_Not_Allowed_On ) ;
    writeln( F, Text_Recover_And_Read_Only_Are_Incompatible_Switches ) ;
    writeln( F, Text_Invalid_Switch ) ;
    writeln( F, Text_Error_Input_File_Does_Not_Exist ) ;
    writeln( F, Text_Error_While_Opening_Journal_File_Cant_Recover ) ;
    writeln( F, Text_Sun ) ;
    writeln( F, Text_Mon ) ;
    writeln( F, Text_Tue ) ;
    writeln( F, Text_Wed ) ;
    writeln( F, Text_Thu ) ;
    writeln( F, Text_Fri ) ;
    writeln( F, Text_Sat ) ;
    writeln( F, Text_Address ) ;
    writeln( F, Text_Data ) ;
    writeln( F, Text_Caption_Modify_Memory ) ;
    writeln( F, Text_Literal_Text ) ;
    writeln( F, Text_Caption_Size ) ;
    writeln( F, Text_Byte1 ) ;
    writeln( F, Text_Word1 ) ;
    writeln( F, Text_Long1 ) ;
    writeln( F, Text_Button_Caption_OK ) ;
    writeln( F, Text_Button_Caption_Cancel ) ;
    writeln( F, Text_Button_Caption_Help ) ;
    writeln( F, Text_New ) ;
    writeln( F, Text_Button_Caption_Delete ) ;
    writeln( F, Text_Button_Caption_New_Folder ) ;
    writeln( F, Text_Caption_Internals ) ;
    writeln( F, Text_Caption_Editor_Preferences ) ;
    writeln( F, Text_Persistant_Selection_Blocks ) ;
    writeln( F, Text_Bounded_Caret ) ;
    writeln( F, Text_Inactive_Selection ) ;
    writeln( F, Text_Tab_Processing ) ;
    writeln( F, Text_Sub_Window ) ;
    writeln( F, Text_Auto_Indent ) ;
    writeln( F, Text_Wrap_Caret ) ;
    writeln( F, Text_Menu_Caption_Edit_Amp ) ;
    writeln( F, Text_Menu_Caption_Undo_Amp ) ;
    writeln( F, Text_Menu_Undo_Hint ) ;
    writeln( F, Text_Menu_Caption_Cut_Amp ) ;
    writeln( F, Text_Menu_Cut_Hint ) ;
    writeln( F, Text_Menu_Caption_Copy_Amp ) ;
    writeln( F, Text_Menu_Copy_Hint ) ;
    writeln( F, Text_Menu_Caption_Paste_Amp ) ;
    writeln( F, Text_Menu_Paste_Hint ) ;
    writeln( F, Text_Menu_Caption_Delete_Amp ) ;
    writeln( F, Text_Menu_Delete_Hint ) ;
    writeln( F, Text_Menu_Caption_Include_Amp ) ;
    writeln( F, Text_Menu_Include_Hint ) ;
    writeln( F, Text_Menu_Caption_Search_Amp ) ;
    writeln( F, Text_Menu_Caption_Find_Amp ) ;
    writeln( F, Text_Menu_Find_Hint ) ;
    writeln( F, Text_Menu_Caption_Replace_Amp ) ;
    writeln( F, Text_Menu_Replace_Hint ) ;
    writeln( F, Text_Menu_Caption_Find_Next_Amp ) ;
    writeln( F, Text_Menu_Find_Next_Hint ) ;
    writeln( F, Text_Menu_Caption_Goto_Amp ) ;
    writeln( F, Text_Caption_Include_File ) ;
    writeln( F, Text_Caption_Find_Data ) ;
    writeln( F, Text_Search_For ) ;
    writeln( F, Text_Search_Options ) ;
    writeln( F, Text_Bytes ) ;
    writeln( F, Text_Case_Sensitive ) ;
    writeln( F, Text_Little_Endian ) ;
    writeln( F, Text_Caption_Enter_Numeric_Value ) ;
    writeln( F, Text_Enter_The_Value ) ;
    writeln( F, Text_ASCII ) ;
    writeln( F, Text_EBCDIC ) ;
    writeln( F, Text_Other ) ;
    writeln( F, Text_Caption_Goto_Address ) ;
    writeln( F, Text_Enter_New_Address ) ;
    writeln( F, Text_Button_Caption_Abort ) ;
    writeln( F, Text_Caption_Go_To_Line_Number ) ;
    writeln( F, Text_Enter_New_Line_Number_Amp ) ;
    writeln( F, Text_Caption_Outline_Editor ) ;
    writeln( F, Text_Button_Caption_Move ) ;
    writeln( F, Text_Button_Caption_Rename ) ;
    writeln( F, Text_Button_Caption_Add ) ;
    writeln( F, Text_Button_Caption_Create_Sub ) ;
    writeln( F, Text_Caption_Choose_Radix ) ;
    writeln( F, Text_Choose_The_Radix_For_Numeric_Display ) ;
    writeln( F, Text_Button_Caption_Help_Amp ) ;
    writeln( F, Text_Caption_File_Has_Changed ) ;
    writeln( F, Text_Save_Changes_To1 ) ;
    writeln( F, Text_Button_Caption_Yes ) ;
    writeln( F, Text_Button_Caption_No ) ;
    writeln( F, Text_Prompt_On_Replace ) ;
    writeln( F, Text_Text_To_Substitute ) ;
    writeln( F, Text_Scope ) ;
    writeln( F, Text_Search_From_Current_Position ) ;
    writeln( F, Text_Search_Entire_File ) ;
    writeln( F, Text_Button_Caption_Replace ) ;
    writeln( F, Text_Search ) ;
    writeln( F, Text_Error_Invalid_Key_Size ) ;
    writeln( F, Text_Files_Unit_Was_Not_Compiled_Correctly ) ;
    writeln( F, Text_Error_FiP_Is_A_Singleton_Object ) ;
    writeln( F, Text_Prompt_Enter_A_Filename ) ;
    writeln( F, Text_Error_Filesys_Unit_Was_Not_Compiled_Correctly ) ;
    writeln( F, Text_Error_Invalid_Syntax ) ;
    writeln( F, Text_Error_Object_Is_Missing_A_Name ) ;
    writeln( F, Text_Error_Expected_Colon ) ;
    writeln( F, Text_Error_Object_Is_Missing_Type ) ;
    writeln( F, Text_Error_Expected_Equal ) ;
    writeln( F, Text_Prompt_Press_Any_Key_To_Continue ) ;
    closefile( F ) ;
end ;
}

begin
//    Create_Text_File ;
    Texts := nil ;
end.
